#include "mock-iki.h"

#ifdef __cplusplus
extern "C" {
#endif

void __wrap_f_iki_eki_read(f_string_static_t * const buffer, f_range_t * const range, f_iki_eki_t * const data, f_state_t * const state) {

  if (!state) return;

  if (!buffer || !range || !data || !state) {
    state->status = F_status_set_error(F_parameter_not);

    return;
  }

  const bool failure = mock_type(bool);

  if (failure) {
    state->status = mock_type(f_status_t);

    return;
  }

  range->start = mock_type(f_number_unsigned_t);
  state->status = mock_type(f_status_t);
}

void __wrap_f_iki_read(f_string_static_t * const buffer, f_range_t * const range, f_iki_data_t * const data, f_state_t * const state) {

  if (!state) return;

  if (!buffer || !range || !data || !state) {
    state->status = F_status_set_error(F_parameter_not);

    return;
  }

  const bool failure = mock_type(bool);

  if (failure) {
    state->status = mock_type(f_status_t);

    return;
  }

  range->start = mock_type(f_number_unsigned_t);
  state->status = mock_type(f_status_t);
}

#ifdef __cplusplus
} // extern "C"
#endif
