#include "mock-time.h"

#ifdef __cplusplus
extern "C" {
#endif

int mock_unwrap = 0;
int mock_unwrap_f_string = 1;

f_status_t __wrap_f_string_append(const f_string_t source, const f_number_unsigned_t length, f_string_dynamic_t * const destination) {

  if (mock_unwrap_f_string) {
    return __real_f_string_append(source, length, destination);
  }

  if (!destination) return F_status_set_error(F_parameter_not);

  const bool failure = mock_type(bool);

  if (failure) return mock_type(f_status_t);

  destination->string = mock_type(f_string_t);
  destination->used = mock_type(f_number_unsigned_t);
  destination->size = 0;

  return mock_type(f_status_t);
}

char *__wrap_asctime_r(const struct tm *tm, char *buf) {

  const bool failure = mock_type(bool);

  if (failure) {
    errno = mock_type(int);

    return 0;
  }

  char *str = mock_type(char *);

  strcpy(buf, str);

  return str;
}

char *__wrap_ctime_r(const time_t *timep, char *buf) {

  const bool failure = mock_type(bool);

  if (failure) {
    errno = mock_type(int);

    return 0;
  }

  char *str = mock_type(char *);

  strcpy(buf, str);

  return str;
}

int __wrap_gettimeofday(struct timeval *tv, struct timezone *tz) {

  const bool failure = mock_type(bool);

  if (failure) {
    errno = mock_type(int);

    return -1;
  }

  struct timeval *result = mock_type(struct timeval *);

  if (tv) {
    *tv = *result;
  }

  return 0;
}

struct tm *__wrap_gmtime_r(const time_t *timep, struct tm *result) {

  const bool failure = mock_type(bool);

  if (failure) {
    errno = mock_type(int);

    return 0;
  }

  struct tm *res = mock_type(struct tm *);

  if (result) {
    *result = *res;
  }

  return res;
}

struct tm *__wrap_localtime_r(const time_t *timep, struct tm *result) {

  const bool failure = mock_type(bool);

  if (failure) {
    errno = mock_type(int);

    return 0;
  }

  struct tm *res = mock_type(struct tm *);

  if (result) {
    *result = *res;
  }

  return res;
}

int __wrap_nanosleep(const struct timespec *req, struct timespec *rem) {

  const bool failure = mock_type(bool);

  if (failure) {
    errno = mock_type(int);

    return -1;
  }

  if (rem) {
    *rem = *mock_type(struct timespec *);
  }

  return 0;
}

int __wrap_settimeofday(const struct timeval *tv, const struct timezone *tz) {

  const bool failure = mock_type(bool);

  if (failure) {
    errno = mock_type(int);

    return -1;
  }

  return 0;
}

time_t __wrap_time(time_t *tloc) {

  const bool failure = mock_type(bool);

  if (failure) {
    errno = mock_type(int);

    return ((time_t) -1);
  }

  return mock_type(time_t);
}

int __wrap_clock_getres(clockid_t clockid, struct timespec *tp) {

  const bool failure = mock_type(bool);

  if (failure) {
    errno = mock_type(int);

    return -1;
  }

  if (tp) {
    *tp = *mock_type(struct timespec *);
  }

  return 0;
}

int __wrap_clock_gettime(clockid_t clockid, struct timespec *tp) {

  const bool failure = mock_type(bool);

  if (failure) {
    errno = mock_type(int);

    return -1;
  }

  if (tp) {
    *tp = *mock_type(struct timespec *);
  }

  return 0;
}

int __wrap_clock_settime(clockid_t clockid, const struct timespec *tp) {

  const bool failure = mock_type(bool);

  if (failure) {
    errno = mock_type(int);

    return -1;
  }

  return 0;
}

#ifdef __cplusplus
} // extern "C"
#endif
