/**
 * FLL - Level 0
 *
 * Project: Time
 * API Version: 0.7
 * Licenses: lgpl-2.1-or-later
 *
 * Test the time project.
 */
#ifndef _MOCK__time_h
#define _MOCK__time_h

// Libc includes.
#include <semaphore.h>
#include <stdarg.h>
#include <stddef.h>
#include <setjmp.h>
#include <stdint.h>
#include <string.h>
#include <time.h>

// cmocka includes.
#include <cmocka.h>

// FLL-0 includes.
#include <fll/level_0/time.h>

#ifdef __cplusplus
extern "C" {
#endif

const static int mock_errno_generic = 32767;

extern int mock_unwrap;
extern int mock_unwrap_f_string;

extern f_status_t __real_f_string_append(const f_string_t source, const f_number_unsigned_t length, f_string_dynamic_t * const destination);

extern f_status_t __wrap_f_string_append(const f_string_t source, const f_number_unsigned_t length, f_string_dynamic_t * const destination);

extern char *__wrap_asctime_r(const struct tm *tm, char *buf);
extern int __wrap_clock_getres(clockid_t clockid, struct timespec *tp);
extern int __wrap_clock_gettime(clockid_t clockid, struct timespec *tp);
extern int __wrap_clock_settime(clockid_t clockid, const struct timespec *tp);
extern char *__wrap_ctime_r(const time_t *timep, char *buf);
extern int __wrap_gettimeofday(struct timeval *tv, struct timezone *tz);
extern struct tm *__wrap_gmtime_r(const time_t *timep, struct tm *result);
extern struct tm *__wrap_localtime_r(const time_t *timep, struct tm *result);
extern int __wrap_nanosleep(const struct timespec *req, struct timespec *rem);
extern int __wrap_settimeofday(const struct timeval *tv, const struct timezone *tz);
extern time_t __wrap_time(time_t *tloc);

#ifdef __cplusplus
} // extern "C"
#endif

#endif // _MOCK__time_h
