/**
 * FLL - Level 0
 *
 * Project: Color
 * API Version: 0.7
 * Licenses: lgpl-2.1-or-later
 *
 * Test the color project.
 */
#ifndef _TEST__F_color_h
#define _TEST__F_color_h

// Libc includes.
#include <stdarg.h>
#include <stddef.h>
#include <setjmp.h>
#include <stdint.h>

// cmocka includes.
#include <cmocka.h>

// FLL-0 includes.
#include <fll/level_0/color.h>

// Mock includes.
#include "mock-color.h"

// Test includes.
#include "test-color-load_context.h"
#include "test-color-save_1.h"
#include "test-color-save_2.h"
#include "test-color-save_3.h"
#include "test-color-save_4.h"
#include "test-color-save_5.h"
#include "test-color-context_delete.h"
#include "test-color-context_destroy.h"

#ifdef __cplusplus
extern "C" {
#endif

/**
 * Perform any setup operations.
 *
 * @param state
 *   The test state.
 *
 * @return
 *   The status of this function, where 0 means success.
 */
extern int setup(void **state);

/**
 * Peform any setdown operations.
 *
 * @param state
 *   The test state.
 *
 * @return
 *   The status of this function, where 0 means success.
 */
extern int setdown(void **state);

/**
 * Run all tests.
 *
 * @return
 *   The final result of the tests.
 *
 * @see cmocka_run_group_tests()
 * @see cmocka_unit_test()
 */
extern int main(void);

#ifdef __cplusplus
} // extern "C"
#endif

#endif // _TEST__F_color_h
