/**
 * FLL - Level 0
 *
 * Project: Memory
 * API Version: 0.7
 * Licenses: lgpl-2.1-or-later
 *
 * Test set quote increase in the fss project.
 */
#ifndef _TEST__F_memory__array_increase
#define _TEST__F_memory__array_increase

/**
 * Test that the function correctly fails on invalid parameter.
 *
 * @see f_memory_array_increase()
 */
extern void test__f_memory_array_increase__parameter_checking(void **state);

/**
 * Test that the function returns F_array_too_large.
 *
 * @see f_memory_array_increase()
 */
extern void test__f_memory_array_increase__returns_array_too_large(void **state);

/**
 * Test that the function returns F_data_not.
 *
 * @see f_memory_array_increase()
 */
extern void test__f_memory_array_increase__returns_data_not(void **state);

/**
 * Test that the function works.
 *
 * @see f_memory_array_increase()
 */
extern void test__f_memory_array_increase__works(void **state);

/**
 * Test that the function works for step increase.
 *
 * This test expects the macro_f_memory_increase_step_4 to be used by f_memory_array_increase().
 * This test expects the F_memory_default_allocation_*_d to be used.
 * This test expects the first allocation step to be of size 1.
 *
 * @see f_memory_array_increase()
 */
extern void test__f_memory_array_increase__works_for_step_increase(void **state);

#endif // _TEST__F_memory__array_increase
