/**
 * FLL - Level 0
 *
 * Project: Network
 * API Version: 0.7
 * Licenses: lgpl-2.1-or-later
 *
 * Test the network project.
 */
#ifndef _TEST__F_network_h
#define _TEST__F_network_h

// Libc includes.
#include <stdarg.h>
#include <stddef.h>
#include <setjmp.h>
#include <stdint.h>
#include <string.h>

// cmocka includes.
#include <cmocka.h>

// FLL-0 includes.
#include <fll/level_0/string.h>
#include <fll/level_0/network.h>

// Mock includes.
#include "mock-network.h"

// Test includes.
#include "test-network-from_host_long.h"
#include "test-network-from_host_short.h"
#include "test-network-from_ip_address.h"
#include "test-network-from_ip_name.h"
#include "test-network-from_ip_string.h"
#include "test-network-is_ip_address.h"
#include "test-network-to_host_long.h"
#include "test-network-to_host_short.h"
#include "test-network-to_ip_string.h"

#ifdef __cplusplus
extern "C" {
#endif

/**
 * Perform any setup operations.
 *
 * @param state
 *   The test state.
 *
 * @return
 *   The status of this function, where 0 means success.
 */
extern int setup(void **state);

/**
 * Peform any setdown operations.
 *
 * @param state
 *   The test state.
 *
 * @return
 *   The status of this function, where 0 means success.
 */
extern int setdown(void **state);

/**
 * Run all tests.
 *
 * @return
 *   The final result of the tests.
 *
 * @see cmocka_run_group_tests()
 * @see cmocka_unit_test()
 */
extern int main(void);

#ifdef __cplusplus
} // extern "C"
#endif

#endif // _TEST__F_network_h
