#include "test-thread.h"
#include "test-thread-spin_create.h"

#ifdef __cplusplus
extern "C" {
#endif

void test__f_thread_spin_create__fails(void **state) {

  f_thread_spin_t spin = f_thread_spin_t_initialize;
  int shared = 0;

  int errnos[] = {
    EAGAIN,
    ENOMEM,
    mock_errno_generic,
  };

  f_status_t statuss[] = {
    F_resource_not,
    F_memory_not,
    F_failure,
  };

  for (uint8_t i = 0; i < 3; ++i) {

    will_return(__wrap_pthread_spin_init, true);
    will_return(__wrap_pthread_spin_init, errnos[i]);

    const f_status_t status = f_thread_spin_create(shared, &spin);

    assert_int_equal(status, F_status_set_error(statuss[i]));
  } // for
}

void test__f_thread_spin_create__parameter_checking(void **state) {

  int shared = 0;

  {
    const f_status_t status = f_thread_spin_create(shared, 0);

    assert_int_equal(status, F_status_set_error(F_parameter));
  }
}

void test__f_thread_spin_create__works(void **state) {

  f_thread_spin_t spin = f_thread_spin_t_initialize;
  int shared = 0;

  {
    will_return(__wrap_pthread_spin_init, false);

    const f_status_t status = f_thread_spin_create(shared, &spin);

    assert_int_equal(status, F_okay);
  }
}

#ifdef __cplusplus
} // extern "C"
#endif
