#include "test-time.h"
#include "test-time-clock_set.h"

#ifdef __cplusplus
extern "C" {
#endif

void test__f_time_clock_set__fails(void **state) {

  const f_time_spec_t time = f_time_spec_t_initialize;

  {
    int errnos[] = {
      EACCES,
      EFAULT,
      ENODEV,
      ENOTSUP,
      EINVAL,
      EOVERFLOW,
      EPERM,
      mock_errno_generic,
    };

    f_status_t statuss[] = {
      F_status_set_error(F_access_denied),
      F_status_set_error(F_buffer),
      F_status_set_error(F_device_not),
      F_status_set_error(F_support_not),
      F_status_set_error(F_parameter),
      F_status_set_error(F_buffer_overflow),
      F_status_set_error(F_prohibited),
      F_status_set_error(F_failure),
    };

    for (int i = 0; i < 8; ++i) {

      will_return(__wrap_clock_settime, true);
      will_return(__wrap_clock_settime, errnos[i]);

      const f_status_t status = f_time_clock_set(0, time);

      assert_int_equal(status, statuss[i]);
    } // for
  }
}

void test__f_time_clock_set__works(void **state) {

  {
    const f_time_spec_t time = f_time_spec_t_initialize;

    will_return(__wrap_clock_settime, false);

    const f_status_t status = f_time_clock_set(0, time);

    assert_int_equal(status, F_okay);
  }
}

#ifdef __cplusplus
} // extern "C"
#endif
