#include "test-time.h"
#include "test-time-epoch_get.h"

#ifdef __cplusplus
extern "C" {
#endif

void test__f_time_epoch_get__fails(void **state) {

  {
    int errnos[] = {
      EFAULT,
      mock_errno_generic,
    };

    f_status_t statuss[] = {
      F_status_set_error(F_buffer),
      F_status_set_error(F_failure),
    };

    for (int i = 0; i < 2; ++i) {

      time_t time = { 0 };

      will_return(__wrap_time, true);
      will_return(__wrap_time, errnos[i]);

      const f_status_t status = f_time_epoch_get(&time);

      assert_int_equal(status, statuss[i]);
    } // for
  }
}

void test__f_time_epoch_get__parameter_checking(void **state) {

  {
    const f_status_t status = f_time_epoch_get(0);

    assert_int_equal(status, F_status_set_error(F_parameter));
  }
}

void test__f_time_epoch_get__works(void **state) {

  const time_t expect = 1;

  {
    time_t time = 0;

    will_return(__wrap_time, false);
    will_return(__wrap_time, expect);

    const f_status_t status = f_time_epoch_get(&time);

    assert_int_equal(status, F_okay);
    assert_int_equal(time, expect);
  }
}

#ifdef __cplusplus
} // extern "C"
#endif
