#include "test-time.h"
#include "test-time-of_day_set.h"

#ifdef __cplusplus
extern "C" {
#endif

void test__f_time_of_day_set__fails(void **state) {

  const f_time_value_t time = f_time_value_t_initialize;

  {
    int errnos[] = {
      EFAULT,
      EINVAL,
      EPERM,
      mock_errno_generic,
    };

    f_status_t statuss[] = {
      F_status_set_error(F_buffer),
      F_status_set_error(F_parameter),
      F_status_set_error(F_prohibited),
      F_status_set_error(F_failure),
    };

    for (int i = 0; i < 4; ++i) {

      will_return(__wrap_settimeofday, true);
      will_return(__wrap_settimeofday, errnos[i]);

      const f_status_t status = f_time_of_day_set(time);

      assert_int_equal(status, statuss[i]);
    } // for
  }
}

void test__f_time_of_day_set__works(void **state) {

  {
    const f_time_value_t time = f_time_value_t_initialize;

    will_return(__wrap_settimeofday, false);

    const f_status_t status = f_time_of_day_set(time);

    assert_int_equal(status, F_okay);
  }
}

#ifdef __cplusplus
} // extern "C"
#endif
