#include "test-time.h"

#ifdef __cplusplus
extern "C" {
#endif

int setup(void **state) {

  return 0;
}

int setdown(void **state) {

  errno = 0;

  return 0;
}

int main(void) {

  const struct CMUnitTest tests[] = {
    cmocka_unit_test(test__f_time_calendar_string__fails),
    cmocka_unit_test(test__f_time_calendar_string_part__fails),
    cmocka_unit_test(test__f_time_clock_get__fails),
    cmocka_unit_test(test__f_time_clock_precision__fails),
    cmocka_unit_test(test__f_time_clock_set__fails),
    cmocka_unit_test(test__f_time_epoch_get__fails),
    cmocka_unit_test(test__f_time_local_get__fails),
    cmocka_unit_test(test__f_time_of_day_get__fails),
    cmocka_unit_test(test__f_time_of_day_set__fails),
    cmocka_unit_test(test__f_time_sleep_spec__fails),
    cmocka_unit_test(test__f_time_utc_get__fails),

    cmocka_unit_test(test__f_time_calendar_string__works),
    cmocka_unit_test(test__f_time_calendar_string_part__works),
    cmocka_unit_test(test__f_time_clock_get__works),
    cmocka_unit_test(test__f_time_clock_precision__works),
    cmocka_unit_test(test__f_time_clock_set__works),
    cmocka_unit_test(test__f_time_epoch_get__works),
    cmocka_unit_test(test__f_time_local_get__works),
    cmocka_unit_test(test__f_time_of_day_get__works),
    cmocka_unit_test(test__f_time_of_day_set__works),
    cmocka_unit_test(test__f_time_sleep_spec__works),
    cmocka_unit_test(test__f_time_utc_get__works),

    cmocka_unit_test(test__f_time_spec_millisecond__number_overflow),
    cmocka_unit_test(test__f_time_spec_millisecond__number_underflow),
    cmocka_unit_test(test__f_time_spec_millisecond__works),

    cmocka_unit_test(test__f_time_spec_nanosecond__number_overflow),
    cmocka_unit_test(test__f_time_spec_nanosecond__number_underflow),
    cmocka_unit_test(test__f_time_spec_nanosecond__works),

    #ifndef _di_level_0_parameter_checking_
      cmocka_unit_test(test__f_time_calendar_string__parameter_checking),
      cmocka_unit_test(test__f_time_calendar_string_part__parameter_checking),
      cmocka_unit_test(test__f_time_clock_get__parameter_checking),
      cmocka_unit_test(test__f_time_clock_precision__parameter_checking),
      // f_time_clock_set() doesn't use parameter checking.
      cmocka_unit_test(test__f_time_epoch_get__parameter_checking),
      cmocka_unit_test(test__f_time_local_get__parameter_checking),
      cmocka_unit_test(test__f_time_of_day_get__parameter_checking),
      // f_time_of_day_set() doesn't use parameter checking.
      // f_time_sleep_spec() doesn't use parameter checking.
      cmocka_unit_test(test__f_time_spec_millisecond__parameter_checking),
      cmocka_unit_test(test__f_time_spec_nanosecond__parameter_checking),
      cmocka_unit_test(test__f_time_utc_get__parameter_checking),
    #endif // _di_level_0_parameter_checking_
  };

  return cmocka_run_group_tests(tests, setup, setdown);
}

#ifdef __cplusplus
} // extern "C"
#endif
