/**
 * FLL - Level 0
 *
 * Project: Time
 * API Version: 0.7
 * Licenses: lgpl-2.1-or-later
 *
 * Test the time project.
 */
#ifndef _TEST__F_time_h
#define _TEST__F_time_h

// Libc includes.
#include <stdarg.h>
#include <stddef.h>
#include <setjmp.h>
#include <stdint.h>

// cmocka includes.
#include <cmocka.h>

// FLL-0 includes.
#include <fll/level_0/time.h>

// Mock includes.
#include "mock-time.h"

// Test includes.
#include "test-time-calendar_string.h"
#include "test-time-calendar_string_part.h"
#include "test-time-clock_get.h"
#include "test-time-clock_precision.h"
#include "test-time-clock_set.h"
#include "test-time-epoch_get.h"
#include "test-time-local_get.h"
#include "test-time-of_day_get.h"
#include "test-time-of_day_set.h"
#include "test-time-utc_get.h"
#include "test-time-sleep_spec.h"
#include "test-time-spec_millisecond.h"
#include "test-time-spec_nanosecond.h"

#ifdef __cplusplus
extern "C" {
#endif

/**
 * Perform any setup operations.
 *
 * @param state
 *   The test state.
 *
 * @return
 *   The status of this function, where 0 means success.
 */
extern int setup(void **state);

/**
 * Peform any setdown operations.
 *
 * @param state
 *   The test state.
 *
 * @return
 *   The status of this function, where 0 means success.
 */
extern int setdown(void **state);

/**
 * Run all tests.
 *
 * @return
 *   The final result of the tests.
 *
 * @see cmocka_run_group_tests()
 * @see cmocka_unit_test()
 */
extern int main(void);

#ifdef __cplusplus
} // extern "C"
#endif

#endif // _TEST__F_time_h
