#include "test-file.h"
#include "test-file-mode_from_string.h"

#ifdef __cplusplus
extern "C" {
#endif

void test__f_file_mode_from_string__fails_basic(void **state) {

  f_string_static_t codes[] = {
    macro_f_string_static_t_initialize_1("+a", 0, 2),
    macro_f_string_static_t_initialize_1("-b", 0, 2),
    macro_f_string_static_t_initialize_1("=c", 0, 2),
    macro_f_string_static_t_initialize_1("++", 0, 2),
    macro_f_string_static_t_initialize_1("+-", 0, 2),
    macro_f_string_static_t_initialize_1("+=", 0, 2),
    macro_f_string_static_t_initialize_1("-+", 0, 2),
    macro_f_string_static_t_initialize_1("--", 0, 2),
    macro_f_string_static_t_initialize_1("-=", 0, 2),
    macro_f_string_static_t_initialize_1("=+", 0, 2),
    macro_f_string_static_t_initialize_1("=-", 0, 2),
    macro_f_string_static_t_initialize_1("==", 0, 2),
    macro_f_string_static_t_initialize_1("hijk", 0, 4),
    macro_f_string_static_t_initialize_1("lmno3", 0, 5),
    macro_f_string_static_t_initialize_1("u", 0, 1),
    macro_f_string_static_t_initialize_1("g", 0, 1),
    macro_f_string_static_t_initialize_1("o", 0, 1),
    macro_f_string_static_t_initialize_1("uu", 0, 2),
    macro_f_string_static_t_initialize_1("gu", 0, 2),
    macro_f_string_static_t_initialize_1("ou", 0, 2),
    macro_f_string_static_t_initialize_1("ug", 0, 2),
    macro_f_string_static_t_initialize_1("gg", 0, 2),
    macro_f_string_static_t_initialize_1("og", 0, 2),
    macro_f_string_static_t_initialize_1("uo", 0, 2),
    macro_f_string_static_t_initialize_1("go", 0, 2),
    macro_f_string_static_t_initialize_1("oo", 0, 2),
    macro_f_string_static_t_initialize_1("uuu", 0, 3),
    macro_f_string_static_t_initialize_1("guu", 0, 3),
    macro_f_string_static_t_initialize_1("ouu", 0, 3),
    macro_f_string_static_t_initialize_1("ugu", 0, 3),
    macro_f_string_static_t_initialize_1("ggu", 0, 3),
    macro_f_string_static_t_initialize_1("ogu", 0, 3),
    macro_f_string_static_t_initialize_1("uou", 0, 3),
    macro_f_string_static_t_initialize_1("gou", 0, 3),
    macro_f_string_static_t_initialize_1("oou", 0, 3),
    macro_f_string_static_t_initialize_1("uug", 0, 3),
    macro_f_string_static_t_initialize_1("gug", 0, 3),
    macro_f_string_static_t_initialize_1("oug", 0, 3),
    macro_f_string_static_t_initialize_1("ugg", 0, 3),
    macro_f_string_static_t_initialize_1("ggg", 0, 3),
    macro_f_string_static_t_initialize_1("ogg", 0, 3),
    macro_f_string_static_t_initialize_1("uog", 0, 3),
    macro_f_string_static_t_initialize_1("gog", 0, 3),
    macro_f_string_static_t_initialize_1("oog", 0, 3),
    macro_f_string_static_t_initialize_1("uuo", 0, 3),
    macro_f_string_static_t_initialize_1("guo", 0, 3),
    macro_f_string_static_t_initialize_1("ouo", 0, 3),
    macro_f_string_static_t_initialize_1("ugo", 0, 3),
    macro_f_string_static_t_initialize_1("ggo", 0, 3),
    macro_f_string_static_t_initialize_1("ogo", 0, 3),
    macro_f_string_static_t_initialize_1("uoo", 0, 3),
    macro_f_string_static_t_initialize_1("goo", 0, 3),
    macro_f_string_static_t_initialize_1("ooo", 0, 3),
    macro_f_string_static_t_initialize_1("u+", 0, 2),
    macro_f_string_static_t_initialize_1("g+", 0, 2),
    macro_f_string_static_t_initialize_1("o+", 0, 2),
    macro_f_string_static_t_initialize_1("u-", 0, 2),
    macro_f_string_static_t_initialize_1("g-", 0, 2),
    macro_f_string_static_t_initialize_1("o-", 0, 2),
    macro_f_string_static_t_initialize_1("u=", 0, 2),
    macro_f_string_static_t_initialize_1("g=", 0, 2),
    macro_f_string_static_t_initialize_1("o=", 0, 2),
    macro_f_string_static_t_initialize_1("u+r0", 0, 4),
    macro_f_string_static_t_initialize_1("g+r0", 0, 4),
    macro_f_string_static_t_initialize_1("o+r0", 0, 4),
    macro_f_string_static_t_initialize_1("u-w1", 0, 4),
    macro_f_string_static_t_initialize_1("g-w1", 0, 4),
    macro_f_string_static_t_initialize_1("o-w1", 0, 4),
    macro_f_string_static_t_initialize_1("u=2x", 0, 4),
    macro_f_string_static_t_initialize_1("g=2x", 0, 4),
    macro_f_string_static_t_initialize_1("o=2x", 0, 4),
    macro_f_string_static_t_initialize_1("012a", 0, 4),
    macro_f_string_static_t_initialize_1("351r", 0, 4),
    macro_f_string_static_t_initialize_1("5+x", 0, 3),
    macro_f_string_static_t_initialize_1("32425", 0, 5),
    macro_f_string_static_t_initialize_1("0000012345", 0, 10),
    macro_f_string_static_t_initialize_1("8", 0, 1),
    macro_f_string_static_t_initialize_1("9", 0, 1),
    macro_f_string_static_t_initialize_1("0+1", 0, 3),
    macro_f_string_static_t_initialize_1("0+r", 0, 3),
    macro_f_string_static_t_initialize_1("2+1", 0, 3),
    macro_f_string_static_t_initialize_1("2+r", 0, 3),
    macro_f_string_static_t_initialize_1("u+rwx", 0, 2),
    macro_f_string_static_t_initialize_1("u+r", 0, 4),
    macro_f_string_static_t_initialize_1("555", 0, 4),
  };

  f_status_t statuss[] = {
    F_syntax,
    F_syntax,
    F_syntax,
    F_syntax,
    F_syntax,
    F_syntax,
    F_syntax,
    F_syntax,
    F_syntax,
    F_syntax,
    F_syntax,
    F_syntax,
    F_syntax,
    F_syntax,
    F_syntax,
    F_syntax,
    F_syntax,
    F_syntax,
    F_syntax,
    F_syntax,
    F_syntax,
    F_syntax,
    F_syntax,
    F_syntax,
    F_syntax,
    F_syntax,
    F_syntax,
    F_syntax,
    F_syntax,
    F_syntax,
    F_syntax,
    F_syntax,
    F_syntax,
    F_syntax,
    F_syntax,
    F_syntax,
    F_syntax,
    F_syntax,
    F_syntax,
    F_syntax,
    F_syntax,
    F_syntax,
    F_syntax,
    F_syntax,
    F_syntax,
    F_syntax,
    F_syntax,
    F_syntax,
    F_syntax,
    F_syntax,
    F_syntax,
    F_syntax,
    F_syntax,
    F_syntax,
    F_syntax,
    F_syntax,
    F_syntax,
    F_syntax,
    F_syntax,
    F_syntax,
    F_syntax,
    F_syntax,
    F_syntax,
    F_syntax,
    F_syntax,
    F_syntax,
    F_syntax,
    F_syntax,
    F_syntax,
    F_syntax,
    F_syntax,
    F_syntax,
    F_syntax,
    F_syntax,
    F_syntax,
    F_syntax,
    F_syntax,
    F_syntax,
    F_syntax,
    F_syntax,
    F_syntax,
    F_syntax,
    F_syntax,
    F_syntax,
    F_syntax,
  };

  for (int i = 0; i < 85; ++i) {

    f_file_mode_t mode = 0;
    uint8_t replace = 0;

    const f_status_t status = f_file_mode_from_string(codes[i], 0, &mode, &replace);

    assert_int_equal(status, F_status_set_error(statuss[i]));
  } // for
}

void test__f_file_mode_from_string__parameter_checking(void **state) {

  {
    const f_status_t status = f_file_mode_from_string(f_string_empty_s, 0, 0, 0);

    assert_int_equal(status, F_status_set_error(F_parameter));
  }

  {
    uint8_t replace = 0;

    const f_status_t status = f_file_mode_from_string(f_string_empty_s, 0, 0, &replace);

    assert_int_equal(status, F_status_set_error(F_parameter));
  }
}

void test__f_file_mode_from_string__returns_data_not(void **state) {

    {
      f_file_mode_t mode_file = f_file_mode_t_initialize;
      uint8_t replace = 0;

      const f_status_t status = f_file_mode_from_string(f_string_empty_s, 0, &mode_file, &replace);

      assert_int_equal(F_status_set_fine(status), F_data_not);
    }

    {
      f_file_mode_t mode_file = f_file_mode_t_initialize;

      const f_status_t status = f_file_mode_from_string(f_string_empty_s, 0, &mode_file, 0);

      assert_int_equal(F_status_set_fine(status), F_data_not);
    }
}

void test__f_file_mode_from_string__works_basic_alphabet(void **state) {

  f_string_static_t codes[] = {
    macro_f_string_static_t_initialize_1("+r", 0, 2),
    macro_f_string_static_t_initialize_1("-w", 0, 2),
    macro_f_string_static_t_initialize_1("=x", 0, 2),
    macro_f_string_static_t_initialize_1("+rw", 0, 3),
    macro_f_string_static_t_initialize_1("+rx", 0, 3),
    macro_f_string_static_t_initialize_1("+wr", 0, 3),
    macro_f_string_static_t_initialize_1("+wx", 0, 3),
    macro_f_string_static_t_initialize_1("+xr", 0, 3),
    macro_f_string_static_t_initialize_1("+xw", 0, 3),
    macro_f_string_static_t_initialize_1("-rw", 0, 3),
    macro_f_string_static_t_initialize_1("-rx", 0, 3),
    macro_f_string_static_t_initialize_1("-wr", 0, 3),
    macro_f_string_static_t_initialize_1("-wx", 0, 3),
    macro_f_string_static_t_initialize_1("-xr", 0, 3),
    macro_f_string_static_t_initialize_1("-xw", 0, 3),
    macro_f_string_static_t_initialize_1("=rw", 0, 3),
    macro_f_string_static_t_initialize_1("=rx", 0, 3),
    macro_f_string_static_t_initialize_1("=wr", 0, 3),
    macro_f_string_static_t_initialize_1("=wx", 0, 3),
    macro_f_string_static_t_initialize_1("=xr", 0, 3),
    macro_f_string_static_t_initialize_1("=xw", 0, 3),
    macro_f_string_static_t_initialize_1("+rwx", 0, 4),
    macro_f_string_static_t_initialize_1("+wrx", 0, 4),
    macro_f_string_static_t_initialize_1("+wxr", 0, 4),
    macro_f_string_static_t_initialize_1("+rxw", 0, 4),
    macro_f_string_static_t_initialize_1("+wxr", 0, 4),
    macro_f_string_static_t_initialize_1("+xwr", 0, 4),
    macro_f_string_static_t_initialize_1("+xrw", 0, 4),
    macro_f_string_static_t_initialize_1("-rwx", 0, 4),
    macro_f_string_static_t_initialize_1("-wrx", 0, 4),
    macro_f_string_static_t_initialize_1("-wxr", 0, 4),
    macro_f_string_static_t_initialize_1("-rxw", 0, 4),
    macro_f_string_static_t_initialize_1("-wxr", 0, 4),
    macro_f_string_static_t_initialize_1("-xwr", 0, 4),
    macro_f_string_static_t_initialize_1("-xrw", 0, 4),
    macro_f_string_static_t_initialize_1("=rwx", 0, 4),
    macro_f_string_static_t_initialize_1("=wrx", 0, 4),
    macro_f_string_static_t_initialize_1("=wxr", 0, 4),
    macro_f_string_static_t_initialize_1("=rxw", 0, 4),
    macro_f_string_static_t_initialize_1("=wxr", 0, 4),
    macro_f_string_static_t_initialize_1("=xwr", 0, 4),
    macro_f_string_static_t_initialize_1("=xrw", 0, 4),
    macro_f_string_static_t_initialize_1("u+rw", 0, 4),
    macro_f_string_static_t_initialize_1("u+rx", 0, 4),
    macro_f_string_static_t_initialize_1("u+wr", 0, 4),
    macro_f_string_static_t_initialize_1("u+wx", 0, 4),
    macro_f_string_static_t_initialize_1("u+xr", 0, 4),
    macro_f_string_static_t_initialize_1("u+xw", 0, 4),
    macro_f_string_static_t_initialize_1("u-rw", 0, 4),
    macro_f_string_static_t_initialize_1("u-rx", 0, 4),
    macro_f_string_static_t_initialize_1("u-wr", 0, 4),
    macro_f_string_static_t_initialize_1("u-wx", 0, 4),
    macro_f_string_static_t_initialize_1("u-xr", 0, 4),
    macro_f_string_static_t_initialize_1("u-xw", 0, 4),
    macro_f_string_static_t_initialize_1("u=rw", 0, 4),
    macro_f_string_static_t_initialize_1("u=rx", 0, 4),
    macro_f_string_static_t_initialize_1("u=wr", 0, 4),
    macro_f_string_static_t_initialize_1("u=wx", 0, 4),
    macro_f_string_static_t_initialize_1("u=xr", 0, 4),
    macro_f_string_static_t_initialize_1("u=xw", 0, 4),
    macro_f_string_static_t_initialize_1("u+rwx", 0, 5),
    macro_f_string_static_t_initialize_1("u+wrx", 0, 5),
    macro_f_string_static_t_initialize_1("u+wxr", 0, 5),
    macro_f_string_static_t_initialize_1("u+rxw", 0, 5),
    macro_f_string_static_t_initialize_1("u+wxr", 0, 5),
    macro_f_string_static_t_initialize_1("u+xwr", 0, 5),
    macro_f_string_static_t_initialize_1("u+xrw", 0, 5),
    macro_f_string_static_t_initialize_1("u-rwx", 0, 5),
    macro_f_string_static_t_initialize_1("u-wrx", 0, 5),
    macro_f_string_static_t_initialize_1("u-wxr", 0, 5),
    macro_f_string_static_t_initialize_1("u-rxw", 0, 5),
    macro_f_string_static_t_initialize_1("u-wxr", 0, 5),
    macro_f_string_static_t_initialize_1("u-xwr", 0, 5),
    macro_f_string_static_t_initialize_1("u-xrw", 0, 5),
    macro_f_string_static_t_initialize_1("u=rwx", 0, 5),
    macro_f_string_static_t_initialize_1("u=wrx", 0, 5),
    macro_f_string_static_t_initialize_1("u=wxr", 0, 5),
    macro_f_string_static_t_initialize_1("u=rxw", 0, 5),
    macro_f_string_static_t_initialize_1("u=wxr", 0, 5),
    macro_f_string_static_t_initialize_1("u=xwr", 0, 5),
    macro_f_string_static_t_initialize_1("u=xrw", 0, 5),
    macro_f_string_static_t_initialize_1("g+rw", 0, 4),
    macro_f_string_static_t_initialize_1("g+rx", 0, 4),
    macro_f_string_static_t_initialize_1("g+wr", 0, 4),
    macro_f_string_static_t_initialize_1("g+wx", 0, 4),
    macro_f_string_static_t_initialize_1("g+xr", 0, 4),
    macro_f_string_static_t_initialize_1("g+xw", 0, 4),
    macro_f_string_static_t_initialize_1("g-rw", 0, 4),
    macro_f_string_static_t_initialize_1("g-rx", 0, 4),
    macro_f_string_static_t_initialize_1("g-wr", 0, 4),
    macro_f_string_static_t_initialize_1("g-wx", 0, 4),
    macro_f_string_static_t_initialize_1("g-xr", 0, 4),
    macro_f_string_static_t_initialize_1("g-xw", 0, 4),
    macro_f_string_static_t_initialize_1("g=rw", 0, 4),
    macro_f_string_static_t_initialize_1("g=rx", 0, 4),
    macro_f_string_static_t_initialize_1("g=wr", 0, 4),
    macro_f_string_static_t_initialize_1("g=wx", 0, 4),
    macro_f_string_static_t_initialize_1("g=xr", 0, 4),
    macro_f_string_static_t_initialize_1("g=xw", 0, 4),
    macro_f_string_static_t_initialize_1("g+rwx", 0, 5),
    macro_f_string_static_t_initialize_1("g+wrx", 0, 5),
    macro_f_string_static_t_initialize_1("g+wxr", 0, 5),
    macro_f_string_static_t_initialize_1("g+rxw", 0, 5),
    macro_f_string_static_t_initialize_1("g+wxr", 0, 5),
    macro_f_string_static_t_initialize_1("g+xwr", 0, 5),
    macro_f_string_static_t_initialize_1("g+xrw", 0, 5),
    macro_f_string_static_t_initialize_1("g-rwx", 0, 5),
    macro_f_string_static_t_initialize_1("g-wrx", 0, 5),
    macro_f_string_static_t_initialize_1("g-wxr", 0, 5),
    macro_f_string_static_t_initialize_1("g-rxw", 0, 5),
    macro_f_string_static_t_initialize_1("g-wxr", 0, 5),
    macro_f_string_static_t_initialize_1("g-xwr", 0, 5),
    macro_f_string_static_t_initialize_1("g-xrw", 0, 5),
    macro_f_string_static_t_initialize_1("g=rwx", 0, 5),
    macro_f_string_static_t_initialize_1("g=wrx", 0, 5),
    macro_f_string_static_t_initialize_1("g=wxr", 0, 5),
    macro_f_string_static_t_initialize_1("g=rxw", 0, 5),
    macro_f_string_static_t_initialize_1("g=wxr", 0, 5),
    macro_f_string_static_t_initialize_1("g=xwr", 0, 5),
    macro_f_string_static_t_initialize_1("g=xrw", 0, 5),
    macro_f_string_static_t_initialize_1("o+rw", 0, 4),
    macro_f_string_static_t_initialize_1("o+rx", 0, 4),
    macro_f_string_static_t_initialize_1("o+wr", 0, 4),
    macro_f_string_static_t_initialize_1("o+wx", 0, 4),
    macro_f_string_static_t_initialize_1("o+xr", 0, 4),
    macro_f_string_static_t_initialize_1("o+xw", 0, 4),
    macro_f_string_static_t_initialize_1("o-rw", 0, 4),
    macro_f_string_static_t_initialize_1("o-rx", 0, 4),
    macro_f_string_static_t_initialize_1("o-wr", 0, 4),
    macro_f_string_static_t_initialize_1("o-wx", 0, 4),
    macro_f_string_static_t_initialize_1("o-xr", 0, 4),
    macro_f_string_static_t_initialize_1("o-xw", 0, 4),
    macro_f_string_static_t_initialize_1("o=rw", 0, 4),
    macro_f_string_static_t_initialize_1("o=rx", 0, 4),
    macro_f_string_static_t_initialize_1("o=wr", 0, 4),
    macro_f_string_static_t_initialize_1("o=wx", 0, 4),
    macro_f_string_static_t_initialize_1("o=xr", 0, 4),
    macro_f_string_static_t_initialize_1("o=xw", 0, 4),
    macro_f_string_static_t_initialize_1("o+rwx", 0, 5),
    macro_f_string_static_t_initialize_1("o+wrx", 0, 5),
    macro_f_string_static_t_initialize_1("o+wxr", 0, 5),
    macro_f_string_static_t_initialize_1("o+rxw", 0, 5),
    macro_f_string_static_t_initialize_1("o+wxr", 0, 5),
    macro_f_string_static_t_initialize_1("o+xwr", 0, 5),
    macro_f_string_static_t_initialize_1("o+xrw", 0, 5),
    macro_f_string_static_t_initialize_1("o-rwx", 0, 5),
    macro_f_string_static_t_initialize_1("o-wrx", 0, 5),
    macro_f_string_static_t_initialize_1("o-wxr", 0, 5),
    macro_f_string_static_t_initialize_1("o-rxw", 0, 5),
    macro_f_string_static_t_initialize_1("o-wxr", 0, 5),
    macro_f_string_static_t_initialize_1("o-xwr", 0, 5),
    macro_f_string_static_t_initialize_1("o-xrw", 0, 5),
    macro_f_string_static_t_initialize_1("o=rwx", 0, 5),
    macro_f_string_static_t_initialize_1("o=wrx", 0, 5),
    macro_f_string_static_t_initialize_1("o=wxr", 0, 5),
    macro_f_string_static_t_initialize_1("o=rxw", 0, 5),
    macro_f_string_static_t_initialize_1("o=wxr", 0, 5),
    macro_f_string_static_t_initialize_1("o=xwr", 0, 5),
    macro_f_string_static_t_initialize_1("o=xrw", 0, 5),
    macro_f_string_static_t_initialize_1("ug+rw", 0, 5),
    macro_f_string_static_t_initialize_1("ug+rx", 0, 5),
    macro_f_string_static_t_initialize_1("ug+wr", 0, 5),
    macro_f_string_static_t_initialize_1("ug+wx", 0, 5),
    macro_f_string_static_t_initialize_1("ug+xr", 0, 5),
    macro_f_string_static_t_initialize_1("ug+xw", 0, 5),
    macro_f_string_static_t_initialize_1("ug-rw", 0, 5),
    macro_f_string_static_t_initialize_1("ug-rx", 0, 5),
    macro_f_string_static_t_initialize_1("ug-wr", 0, 5),
    macro_f_string_static_t_initialize_1("ug-wx", 0, 5),
    macro_f_string_static_t_initialize_1("ug-xr", 0, 5),
    macro_f_string_static_t_initialize_1("ug-xw", 0, 5),
    macro_f_string_static_t_initialize_1("ug=rw", 0, 5),
    macro_f_string_static_t_initialize_1("ug=rx", 0, 5),
    macro_f_string_static_t_initialize_1("ug=wr", 0, 5),
    macro_f_string_static_t_initialize_1("ug=wx", 0, 5),
    macro_f_string_static_t_initialize_1("ug=xr", 0, 5),
    macro_f_string_static_t_initialize_1("ug=xw", 0, 5),
    macro_f_string_static_t_initialize_1("ug+rwx", 0, 6),
    macro_f_string_static_t_initialize_1("ug+wrx", 0, 6),
    macro_f_string_static_t_initialize_1("ug+wxr", 0, 6),
    macro_f_string_static_t_initialize_1("ug+rxw", 0, 6),
    macro_f_string_static_t_initialize_1("ug+wxr", 0, 6),
    macro_f_string_static_t_initialize_1("ug+xwr", 0, 6),
    macro_f_string_static_t_initialize_1("ug+xrw", 0, 6),
    macro_f_string_static_t_initialize_1("ug-rwx", 0, 6),
    macro_f_string_static_t_initialize_1("ug-wrx", 0, 6),
    macro_f_string_static_t_initialize_1("ug-wxr", 0, 6),
    macro_f_string_static_t_initialize_1("ug-rxw", 0, 6),
    macro_f_string_static_t_initialize_1("ug-wxr", 0, 6),
    macro_f_string_static_t_initialize_1("ug-xwr", 0, 6),
    macro_f_string_static_t_initialize_1("ug-xrw", 0, 6),
    macro_f_string_static_t_initialize_1("ug=rwx", 0, 6),
    macro_f_string_static_t_initialize_1("ug=wrx", 0, 6),
    macro_f_string_static_t_initialize_1("ug=wxr", 0, 6),
    macro_f_string_static_t_initialize_1("ug=rxw", 0, 6),
    macro_f_string_static_t_initialize_1("ug=wxr", 0, 6),
    macro_f_string_static_t_initialize_1("ug=xwr", 0, 6),
    macro_f_string_static_t_initialize_1("ug=xrw", 0, 6),
    macro_f_string_static_t_initialize_1("uo+rw", 0, 5),
    macro_f_string_static_t_initialize_1("uo+rx", 0, 5),
    macro_f_string_static_t_initialize_1("uo+wr", 0, 5),
    macro_f_string_static_t_initialize_1("uo+wx", 0, 5),
    macro_f_string_static_t_initialize_1("uo+xr", 0, 5),
    macro_f_string_static_t_initialize_1("uo+xw", 0, 5),
    macro_f_string_static_t_initialize_1("uo-rw", 0, 5),
    macro_f_string_static_t_initialize_1("uo-rx", 0, 5),
    macro_f_string_static_t_initialize_1("uo-wr", 0, 5),
    macro_f_string_static_t_initialize_1("uo-wx", 0, 5),
    macro_f_string_static_t_initialize_1("uo-xr", 0, 5),
    macro_f_string_static_t_initialize_1("uo-xw", 0, 5),
    macro_f_string_static_t_initialize_1("uo=rw", 0, 5),
    macro_f_string_static_t_initialize_1("uo=rx", 0, 5),
    macro_f_string_static_t_initialize_1("uo=wr", 0, 5),
    macro_f_string_static_t_initialize_1("uo=wx", 0, 5),
    macro_f_string_static_t_initialize_1("uo=xr", 0, 5),
    macro_f_string_static_t_initialize_1("uo=xw", 0, 5),
    macro_f_string_static_t_initialize_1("uo+rwx", 0, 6),
    macro_f_string_static_t_initialize_1("uo+wrx", 0, 6),
    macro_f_string_static_t_initialize_1("uo+wxr", 0, 6),
    macro_f_string_static_t_initialize_1("uo+rxw", 0, 6),
    macro_f_string_static_t_initialize_1("uo+wxr", 0, 6),
    macro_f_string_static_t_initialize_1("uo+xwr", 0, 6),
    macro_f_string_static_t_initialize_1("uo+xrw", 0, 6),
    macro_f_string_static_t_initialize_1("uo-rwx", 0, 6),
    macro_f_string_static_t_initialize_1("uo-wrx", 0, 6),
    macro_f_string_static_t_initialize_1("uo-wxr", 0, 6),
    macro_f_string_static_t_initialize_1("uo-rxw", 0, 6),
    macro_f_string_static_t_initialize_1("uo-wxr", 0, 6),
    macro_f_string_static_t_initialize_1("uo-xwr", 0, 6),
    macro_f_string_static_t_initialize_1("uo-xrw", 0, 6),
    macro_f_string_static_t_initialize_1("uo=rwx", 0, 6),
    macro_f_string_static_t_initialize_1("uo=wrx", 0, 6),
    macro_f_string_static_t_initialize_1("uo=wxr", 0, 6),
    macro_f_string_static_t_initialize_1("uo=rxw", 0, 6),
    macro_f_string_static_t_initialize_1("uo=wxr", 0, 6),
    macro_f_string_static_t_initialize_1("uo=xwr", 0, 6),
    macro_f_string_static_t_initialize_1("uo=xrw", 0, 6),
    macro_f_string_static_t_initialize_1("gu+rw", 0, 5),
    macro_f_string_static_t_initialize_1("gu+rx", 0, 5),
    macro_f_string_static_t_initialize_1("gu+wr", 0, 5),
    macro_f_string_static_t_initialize_1("gu+wx", 0, 5),
    macro_f_string_static_t_initialize_1("gu+xr", 0, 5),
    macro_f_string_static_t_initialize_1("gu+xw", 0, 5),
    macro_f_string_static_t_initialize_1("gu-rw", 0, 5),
    macro_f_string_static_t_initialize_1("gu-rx", 0, 5),
    macro_f_string_static_t_initialize_1("gu-wr", 0, 5),
    macro_f_string_static_t_initialize_1("gu-wx", 0, 5),
    macro_f_string_static_t_initialize_1("gu-xr", 0, 5),
    macro_f_string_static_t_initialize_1("gu-xw", 0, 5),
    macro_f_string_static_t_initialize_1("gu=rw", 0, 5),
    macro_f_string_static_t_initialize_1("gu=rx", 0, 5),
    macro_f_string_static_t_initialize_1("gu=wr", 0, 5),
    macro_f_string_static_t_initialize_1("gu=wx", 0, 5),
    macro_f_string_static_t_initialize_1("gu=xr", 0, 5),
    macro_f_string_static_t_initialize_1("gu=xw", 0, 5),
    macro_f_string_static_t_initialize_1("gu+rwx", 0, 6),
    macro_f_string_static_t_initialize_1("gu+wrx", 0, 6),
    macro_f_string_static_t_initialize_1("gu+wxr", 0, 6),
    macro_f_string_static_t_initialize_1("gu+rxw", 0, 6),
    macro_f_string_static_t_initialize_1("gu+wxr", 0, 6),
    macro_f_string_static_t_initialize_1("gu+xwr", 0, 6),
    macro_f_string_static_t_initialize_1("gu+xrw", 0, 6),
    macro_f_string_static_t_initialize_1("gu-rwx", 0, 6),
    macro_f_string_static_t_initialize_1("gu-wrx", 0, 6),
    macro_f_string_static_t_initialize_1("gu-wxr", 0, 6),
    macro_f_string_static_t_initialize_1("gu-rxw", 0, 6),
    macro_f_string_static_t_initialize_1("gu-wxr", 0, 6),
    macro_f_string_static_t_initialize_1("gu-xwr", 0, 6),
    macro_f_string_static_t_initialize_1("gu-xrw", 0, 6),
    macro_f_string_static_t_initialize_1("gu=rwx", 0, 6),
    macro_f_string_static_t_initialize_1("gu=wrx", 0, 6),
    macro_f_string_static_t_initialize_1("gu=wxr", 0, 6),
    macro_f_string_static_t_initialize_1("gu=rxw", 0, 6),
    macro_f_string_static_t_initialize_1("gu=wxr", 0, 6),
    macro_f_string_static_t_initialize_1("gu=xwr", 0, 6),
    macro_f_string_static_t_initialize_1("gu=xrw", 0, 6),
    macro_f_string_static_t_initialize_1("go+rw", 0, 5),
    macro_f_string_static_t_initialize_1("go+rx", 0, 5),
    macro_f_string_static_t_initialize_1("go+wr", 0, 5),
    macro_f_string_static_t_initialize_1("go+wx", 0, 5),
    macro_f_string_static_t_initialize_1("go+xr", 0, 5),
    macro_f_string_static_t_initialize_1("go+xw", 0, 5),
    macro_f_string_static_t_initialize_1("go-rw", 0, 5),
    macro_f_string_static_t_initialize_1("go-rx", 0, 5),
    macro_f_string_static_t_initialize_1("go-wr", 0, 5),
    macro_f_string_static_t_initialize_1("go-wx", 0, 5),
    macro_f_string_static_t_initialize_1("go-xr", 0, 5),
    macro_f_string_static_t_initialize_1("go-xw", 0, 5),
    macro_f_string_static_t_initialize_1("go=rw", 0, 5),
    macro_f_string_static_t_initialize_1("go=rx", 0, 5),
    macro_f_string_static_t_initialize_1("go=wr", 0, 5),
    macro_f_string_static_t_initialize_1("go=wx", 0, 5),
    macro_f_string_static_t_initialize_1("go=xr", 0, 5),
    macro_f_string_static_t_initialize_1("go=xw", 0, 5),
    macro_f_string_static_t_initialize_1("go+rwx", 0, 6),
    macro_f_string_static_t_initialize_1("go+wrx", 0, 6),
    macro_f_string_static_t_initialize_1("go+wxr", 0, 6),
    macro_f_string_static_t_initialize_1("go+rxw", 0, 6),
    macro_f_string_static_t_initialize_1("go+wxr", 0, 6),
    macro_f_string_static_t_initialize_1("go+xwr", 0, 6),
    macro_f_string_static_t_initialize_1("go+xrw", 0, 6),
    macro_f_string_static_t_initialize_1("go-rwx", 0, 6),
    macro_f_string_static_t_initialize_1("go-wrx", 0, 6),
    macro_f_string_static_t_initialize_1("go-wxr", 0, 6),
    macro_f_string_static_t_initialize_1("go-rxw", 0, 6),
    macro_f_string_static_t_initialize_1("go-wxr", 0, 6),
    macro_f_string_static_t_initialize_1("go-xwr", 0, 6),
    macro_f_string_static_t_initialize_1("go-xrw", 0, 6),
    macro_f_string_static_t_initialize_1("go=rwx", 0, 6),
    macro_f_string_static_t_initialize_1("go=wrx", 0, 6),
    macro_f_string_static_t_initialize_1("go=wxr", 0, 6),
    macro_f_string_static_t_initialize_1("go=rxw", 0, 6),
    macro_f_string_static_t_initialize_1("go=wxr", 0, 6),
    macro_f_string_static_t_initialize_1("go=xwr", 0, 6),
    macro_f_string_static_t_initialize_1("go=xrw", 0, 6),
    macro_f_string_static_t_initialize_1("ou+rw", 0, 5),
    macro_f_string_static_t_initialize_1("ou+rx", 0, 5),
    macro_f_string_static_t_initialize_1("ou+wr", 0, 5),
    macro_f_string_static_t_initialize_1("ou+wx", 0, 5),
    macro_f_string_static_t_initialize_1("ou+xr", 0, 5),
    macro_f_string_static_t_initialize_1("ou+xw", 0, 5),
    macro_f_string_static_t_initialize_1("ou-rw", 0, 5),
    macro_f_string_static_t_initialize_1("ou-rx", 0, 5),
    macro_f_string_static_t_initialize_1("ou-wr", 0, 5),
    macro_f_string_static_t_initialize_1("ou-wx", 0, 5),
    macro_f_string_static_t_initialize_1("ou-xr", 0, 5),
    macro_f_string_static_t_initialize_1("ou-xw", 0, 5),
    macro_f_string_static_t_initialize_1("ou=rw", 0, 5),
    macro_f_string_static_t_initialize_1("ou=rx", 0, 5),
    macro_f_string_static_t_initialize_1("ou=wr", 0, 5),
    macro_f_string_static_t_initialize_1("ou=wx", 0, 5),
    macro_f_string_static_t_initialize_1("ou=xr", 0, 5),
    macro_f_string_static_t_initialize_1("ou=xw", 0, 5),
    macro_f_string_static_t_initialize_1("ou+rwx", 0, 6),
    macro_f_string_static_t_initialize_1("ou+wrx", 0, 6),
    macro_f_string_static_t_initialize_1("ou+wxr", 0, 6),
    macro_f_string_static_t_initialize_1("ou+rxw", 0, 6),
    macro_f_string_static_t_initialize_1("ou+wxr", 0, 6),
    macro_f_string_static_t_initialize_1("ou+xwr", 0, 6),
    macro_f_string_static_t_initialize_1("ou+xrw", 0, 6),
    macro_f_string_static_t_initialize_1("ou-rwx", 0, 6),
    macro_f_string_static_t_initialize_1("ou-wrx", 0, 6),
    macro_f_string_static_t_initialize_1("ou-wxr", 0, 6),
    macro_f_string_static_t_initialize_1("ou-rxw", 0, 6),
    macro_f_string_static_t_initialize_1("ou-wxr", 0, 6),
    macro_f_string_static_t_initialize_1("ou-xwr", 0, 6),
    macro_f_string_static_t_initialize_1("ou-xrw", 0, 6),
    macro_f_string_static_t_initialize_1("ou=rwx", 0, 6),
    macro_f_string_static_t_initialize_1("ou=wrx", 0, 6),
    macro_f_string_static_t_initialize_1("ou=wxr", 0, 6),
    macro_f_string_static_t_initialize_1("ou=rxw", 0, 6),
    macro_f_string_static_t_initialize_1("ou=wxr", 0, 6),
    macro_f_string_static_t_initialize_1("ou=xwr", 0, 6),
    macro_f_string_static_t_initialize_1("ou=xrw", 0, 6),
    macro_f_string_static_t_initialize_1("og+rw", 0, 5),
    macro_f_string_static_t_initialize_1("og+rx", 0, 5),
    macro_f_string_static_t_initialize_1("og+wr", 0, 5),
    macro_f_string_static_t_initialize_1("og+wx", 0, 5),
    macro_f_string_static_t_initialize_1("og+xr", 0, 5),
    macro_f_string_static_t_initialize_1("og+xw", 0, 5),
    macro_f_string_static_t_initialize_1("og-rw", 0, 5),
    macro_f_string_static_t_initialize_1("og-rx", 0, 5),
    macro_f_string_static_t_initialize_1("og-wr", 0, 5),
    macro_f_string_static_t_initialize_1("og-wx", 0, 5),
    macro_f_string_static_t_initialize_1("og-xr", 0, 5),
    macro_f_string_static_t_initialize_1("og-xw", 0, 5),
    macro_f_string_static_t_initialize_1("og=rw", 0, 5),
    macro_f_string_static_t_initialize_1("og=rx", 0, 5),
    macro_f_string_static_t_initialize_1("og=wr", 0, 5),
    macro_f_string_static_t_initialize_1("og=wx", 0, 5),
    macro_f_string_static_t_initialize_1("og=xr", 0, 5),
    macro_f_string_static_t_initialize_1("og=xw", 0, 5),
    macro_f_string_static_t_initialize_1("og+rwx", 0, 6),
    macro_f_string_static_t_initialize_1("og+wrx", 0, 6),
    macro_f_string_static_t_initialize_1("og+wxr", 0, 6),
    macro_f_string_static_t_initialize_1("og+rxw", 0, 6),
    macro_f_string_static_t_initialize_1("og+wxr", 0, 6),
    macro_f_string_static_t_initialize_1("og+xwr", 0, 6),
    macro_f_string_static_t_initialize_1("og+xrw", 0, 6),
    macro_f_string_static_t_initialize_1("og-rwx", 0, 6),
    macro_f_string_static_t_initialize_1("og-wrx", 0, 6),
    macro_f_string_static_t_initialize_1("og-wxr", 0, 6),
    macro_f_string_static_t_initialize_1("og-rxw", 0, 6),
    macro_f_string_static_t_initialize_1("og-wxr", 0, 6),
    macro_f_string_static_t_initialize_1("og-xwr", 0, 6),
    macro_f_string_static_t_initialize_1("og-xrw", 0, 6),
    macro_f_string_static_t_initialize_1("og=rwx", 0, 6),
    macro_f_string_static_t_initialize_1("og=wrx", 0, 6),
    macro_f_string_static_t_initialize_1("og=wxr", 0, 6),
    macro_f_string_static_t_initialize_1("og=rxw", 0, 6),
    macro_f_string_static_t_initialize_1("og=wxr", 0, 6),
    macro_f_string_static_t_initialize_1("og=xwr", 0, 6),
    macro_f_string_static_t_initialize_1("og=xrw", 0, 6),
    macro_f_string_static_t_initialize_1("ugo+rw", 0, 6),
    macro_f_string_static_t_initialize_1("ugo+rx", 0, 6),
    macro_f_string_static_t_initialize_1("ugo+wr", 0, 6),
    macro_f_string_static_t_initialize_1("ugo+wx", 0, 6),
    macro_f_string_static_t_initialize_1("ugo+xr", 0, 6),
    macro_f_string_static_t_initialize_1("ugo+xw", 0, 6),
    macro_f_string_static_t_initialize_1("ugo-rw", 0, 6),
    macro_f_string_static_t_initialize_1("ugo-rx", 0, 6),
    macro_f_string_static_t_initialize_1("ugo-wr", 0, 6),
    macro_f_string_static_t_initialize_1("ugo-wx", 0, 6),
    macro_f_string_static_t_initialize_1("ugo-xr", 0, 6),
    macro_f_string_static_t_initialize_1("ugo-xw", 0, 6),
    macro_f_string_static_t_initialize_1("ugo=rw", 0, 6),
    macro_f_string_static_t_initialize_1("ugo=rx", 0, 6),
    macro_f_string_static_t_initialize_1("ugo=wr", 0, 6),
    macro_f_string_static_t_initialize_1("ugo=wx", 0, 6),
    macro_f_string_static_t_initialize_1("ugo=xr", 0, 6),
    macro_f_string_static_t_initialize_1("ugo=xw", 0, 6),
    macro_f_string_static_t_initialize_1("ugo+rwx", 0, 7),
    macro_f_string_static_t_initialize_1("ugo+wrx", 0, 7),
    macro_f_string_static_t_initialize_1("ugo+wxr", 0, 7),
    macro_f_string_static_t_initialize_1("ugo+rxw", 0, 7),
    macro_f_string_static_t_initialize_1("ugo+wxr", 0, 7),
    macro_f_string_static_t_initialize_1("ugo+xwr", 0, 7),
    macro_f_string_static_t_initialize_1("ugo+xrw", 0, 7),
    macro_f_string_static_t_initialize_1("ugo-rwx", 0, 7),
    macro_f_string_static_t_initialize_1("ugo-wrx", 0, 7),
    macro_f_string_static_t_initialize_1("ugo-wxr", 0, 7),
    macro_f_string_static_t_initialize_1("ugo-rxw", 0, 7),
    macro_f_string_static_t_initialize_1("ugo-wxr", 0, 7),
    macro_f_string_static_t_initialize_1("ugo-xwr", 0, 7),
    macro_f_string_static_t_initialize_1("ugo-xrw", 0, 7),
    macro_f_string_static_t_initialize_1("ugo=rwx", 0, 7),
    macro_f_string_static_t_initialize_1("ugo=wrx", 0, 7),
    macro_f_string_static_t_initialize_1("ugo=wxr", 0, 7),
    macro_f_string_static_t_initialize_1("ugo=rxw", 0, 7),
    macro_f_string_static_t_initialize_1("ugo=wxr", 0, 7),
    macro_f_string_static_t_initialize_1("ugo=xwr", 0, 7),
    macro_f_string_static_t_initialize_1("ugo=xrw", 0, 7),
    macro_f_string_static_t_initialize_1("guo+rwx", 0, 7),
    macro_f_string_static_t_initialize_1("guo+wrx", 0, 7),
    macro_f_string_static_t_initialize_1("guo+wxr", 0, 7),
    macro_f_string_static_t_initialize_1("guo+rxw", 0, 7),
    macro_f_string_static_t_initialize_1("guo+wxr", 0, 7),
    macro_f_string_static_t_initialize_1("guo+xwr", 0, 7),
    macro_f_string_static_t_initialize_1("guo+xrw", 0, 7),
    macro_f_string_static_t_initialize_1("guo-rwx", 0, 7),
    macro_f_string_static_t_initialize_1("guo-wrx", 0, 7),
    macro_f_string_static_t_initialize_1("guo-wxr", 0, 7),
    macro_f_string_static_t_initialize_1("guo-rxw", 0, 7),
    macro_f_string_static_t_initialize_1("guo-wxr", 0, 7),
    macro_f_string_static_t_initialize_1("guo-xwr", 0, 7),
    macro_f_string_static_t_initialize_1("guo-xrw", 0, 7),
    macro_f_string_static_t_initialize_1("guo=rwx", 0, 7),
    macro_f_string_static_t_initialize_1("guo=wrx", 0, 7),
    macro_f_string_static_t_initialize_1("guo=wxr", 0, 7),
    macro_f_string_static_t_initialize_1("guo=rxw", 0, 7),
    macro_f_string_static_t_initialize_1("guo=wxr", 0, 7),
    macro_f_string_static_t_initialize_1("guo=xwr", 0, 7),
    macro_f_string_static_t_initialize_1("guo=xrw", 0, 7),
    macro_f_string_static_t_initialize_1("gou+rwx", 0, 7),
    macro_f_string_static_t_initialize_1("gou+wrx", 0, 7),
    macro_f_string_static_t_initialize_1("gou+wxr", 0, 7),
    macro_f_string_static_t_initialize_1("gou+rxw", 0, 7),
    macro_f_string_static_t_initialize_1("gou+wxr", 0, 7),
    macro_f_string_static_t_initialize_1("gou+xwr", 0, 7),
    macro_f_string_static_t_initialize_1("gou+xrw", 0, 7),
    macro_f_string_static_t_initialize_1("gou-rwx", 0, 7),
    macro_f_string_static_t_initialize_1("gou-wrx", 0, 7),
    macro_f_string_static_t_initialize_1("gou-wxr", 0, 7),
    macro_f_string_static_t_initialize_1("gou-rxw", 0, 7),
    macro_f_string_static_t_initialize_1("gou-wxr", 0, 7),
    macro_f_string_static_t_initialize_1("gou-xwr", 0, 7),
    macro_f_string_static_t_initialize_1("gou-xrw", 0, 7),
    macro_f_string_static_t_initialize_1("gou=rwx", 0, 7),
    macro_f_string_static_t_initialize_1("gou=wrx", 0, 7),
    macro_f_string_static_t_initialize_1("gou=wxr", 0, 7),
    macro_f_string_static_t_initialize_1("gou=rxw", 0, 7),
    macro_f_string_static_t_initialize_1("gou=wxr", 0, 7),
    macro_f_string_static_t_initialize_1("gou=xwr", 0, 7),
    macro_f_string_static_t_initialize_1("gou=xrw", 0, 7),
    macro_f_string_static_t_initialize_1("guo+rwx", 0, 7),
    macro_f_string_static_t_initialize_1("guo+wrx", 0, 7),
    macro_f_string_static_t_initialize_1("guo+wxr", 0, 7),
    macro_f_string_static_t_initialize_1("guo+rxw", 0, 7),
    macro_f_string_static_t_initialize_1("guo+wxr", 0, 7),
    macro_f_string_static_t_initialize_1("guo+xwr", 0, 7),
    macro_f_string_static_t_initialize_1("guo+xrw", 0, 7),
    macro_f_string_static_t_initialize_1("guo-rwx", 0, 7),
    macro_f_string_static_t_initialize_1("guo-wrx", 0, 7),
    macro_f_string_static_t_initialize_1("guo-wxr", 0, 7),
    macro_f_string_static_t_initialize_1("guo-rxw", 0, 7),
    macro_f_string_static_t_initialize_1("guo-wxr", 0, 7),
    macro_f_string_static_t_initialize_1("guo-xwr", 0, 7),
    macro_f_string_static_t_initialize_1("guo-xrw", 0, 7),
    macro_f_string_static_t_initialize_1("guo=rwx", 0, 7),
    macro_f_string_static_t_initialize_1("guo=wrx", 0, 7),
    macro_f_string_static_t_initialize_1("guo=wxr", 0, 7),
    macro_f_string_static_t_initialize_1("guo=rxw", 0, 7),
    macro_f_string_static_t_initialize_1("guo=wxr", 0, 7),
    macro_f_string_static_t_initialize_1("guo=xwr", 0, 7),
    macro_f_string_static_t_initialize_1("guo=xrw", 0, 7),
    macro_f_string_static_t_initialize_1("uog+rwx", 0, 7),
    macro_f_string_static_t_initialize_1("uog+wrx", 0, 7),
    macro_f_string_static_t_initialize_1("uog+wxr", 0, 7),
    macro_f_string_static_t_initialize_1("uog+rxw", 0, 7),
    macro_f_string_static_t_initialize_1("uog+wxr", 0, 7),
    macro_f_string_static_t_initialize_1("uog+xwr", 0, 7),
    macro_f_string_static_t_initialize_1("uog+xrw", 0, 7),
    macro_f_string_static_t_initialize_1("uog-rwx", 0, 7),
    macro_f_string_static_t_initialize_1("uog-wrx", 0, 7),
    macro_f_string_static_t_initialize_1("uog-wxr", 0, 7),
    macro_f_string_static_t_initialize_1("uog-rxw", 0, 7),
    macro_f_string_static_t_initialize_1("uog-wxr", 0, 7),
    macro_f_string_static_t_initialize_1("uog-xwr", 0, 7),
    macro_f_string_static_t_initialize_1("uog-xrw", 0, 7),
    macro_f_string_static_t_initialize_1("uog=rwx", 0, 7),
    macro_f_string_static_t_initialize_1("uog=wrx", 0, 7),
    macro_f_string_static_t_initialize_1("uog=wxr", 0, 7),
    macro_f_string_static_t_initialize_1("uog=rxw", 0, 7),
    macro_f_string_static_t_initialize_1("uog=wxr", 0, 7),
    macro_f_string_static_t_initialize_1("uog=xwr", 0, 7),
    macro_f_string_static_t_initialize_1("uog=xrw", 0, 7),
    macro_f_string_static_t_initialize_1("oug+rwx", 0, 7),
    macro_f_string_static_t_initialize_1("oug+wrx", 0, 7),
    macro_f_string_static_t_initialize_1("oug+wxr", 0, 7),
    macro_f_string_static_t_initialize_1("oug+rxw", 0, 7),
    macro_f_string_static_t_initialize_1("oug+wxr", 0, 7),
    macro_f_string_static_t_initialize_1("oug+xwr", 0, 7),
    macro_f_string_static_t_initialize_1("oug+xrw", 0, 7),
    macro_f_string_static_t_initialize_1("oug-rwx", 0, 7),
    macro_f_string_static_t_initialize_1("oug-wrx", 0, 7),
    macro_f_string_static_t_initialize_1("oug-wxr", 0, 7),
    macro_f_string_static_t_initialize_1("oug-rxw", 0, 7),
    macro_f_string_static_t_initialize_1("oug-wxr", 0, 7),
    macro_f_string_static_t_initialize_1("oug-xwr", 0, 7),
    macro_f_string_static_t_initialize_1("oug-xrw", 0, 7),
    macro_f_string_static_t_initialize_1("oug=rwx", 0, 7),
    macro_f_string_static_t_initialize_1("oug=wrx", 0, 7),
    macro_f_string_static_t_initialize_1("oug=wxr", 0, 7),
    macro_f_string_static_t_initialize_1("oug=rxw", 0, 7),
    macro_f_string_static_t_initialize_1("oug=wxr", 0, 7),
    macro_f_string_static_t_initialize_1("oug=xwr", 0, 7),
    macro_f_string_static_t_initialize_1("oug=xrw", 0, 7),
    macro_f_string_static_t_initialize_1("uog+rwx", 0, 7),
    macro_f_string_static_t_initialize_1("uog+wrx", 0, 7),
    macro_f_string_static_t_initialize_1("uog+wxr", 0, 7),
    macro_f_string_static_t_initialize_1("uog+rxw", 0, 7),
    macro_f_string_static_t_initialize_1("uog+wxr", 0, 7),
    macro_f_string_static_t_initialize_1("uog+xwr", 0, 7),
    macro_f_string_static_t_initialize_1("uog+xrw", 0, 7),
    macro_f_string_static_t_initialize_1("uog-rwx", 0, 7),
    macro_f_string_static_t_initialize_1("uog-wrx", 0, 7),
    macro_f_string_static_t_initialize_1("uog-wxr", 0, 7),
    macro_f_string_static_t_initialize_1("uog-rxw", 0, 7),
    macro_f_string_static_t_initialize_1("uog-wxr", 0, 7),
    macro_f_string_static_t_initialize_1("uog-xwr", 0, 7),
    macro_f_string_static_t_initialize_1("uog-xrw", 0, 7),
    macro_f_string_static_t_initialize_1("uog=rwx", 0, 7),
    macro_f_string_static_t_initialize_1("uog=wrx", 0, 7),
    macro_f_string_static_t_initialize_1("uog=wxr", 0, 7),
    macro_f_string_static_t_initialize_1("uog=rxw", 0, 7),
    macro_f_string_static_t_initialize_1("uog=wxr", 0, 7),
    macro_f_string_static_t_initialize_1("uog=xwr", 0, 7),
    macro_f_string_static_t_initialize_1("uog=xrw", 0, 7),
  };

  f_file_mode_t modes[] = {
    F_file_mode_t_mask_how_add_d & F_file_mode_t_block_standard_d & F_file_mode_t_mask_bit_read_d,
    F_file_mode_t_mask_how_subtract_d & F_file_mode_t_block_standard_d & F_file_mode_t_mask_bit_write_d,
    F_file_mode_t_mask_how_add_d & F_file_mode_t_block_standard_d & F_file_mode_t_mask_bit_execute_d,
    F_file_mode_t_mask_how_add_d & F_file_mode_t_block_standard_d & (F_file_mode_t_mask_bit_read_d | F_file_mode_t_mask_bit_write_d),
    F_file_mode_t_mask_how_add_d & F_file_mode_t_block_standard_d & (F_file_mode_t_mask_bit_read_d | F_file_mode_t_mask_bit_execute_d),
    F_file_mode_t_mask_how_add_d & F_file_mode_t_block_standard_d & (F_file_mode_t_mask_bit_read_d | F_file_mode_t_mask_bit_write_d),
    F_file_mode_t_mask_how_add_d & F_file_mode_t_block_standard_d & (F_file_mode_t_mask_bit_write_d | F_file_mode_t_mask_bit_execute_d),
    F_file_mode_t_mask_how_add_d & F_file_mode_t_block_standard_d & (F_file_mode_t_mask_bit_read_d | F_file_mode_t_mask_bit_execute_d),
    F_file_mode_t_mask_how_add_d & F_file_mode_t_block_standard_d & (F_file_mode_t_mask_bit_write_d | F_file_mode_t_mask_bit_execute_d),
    F_file_mode_t_mask_how_subtract_d & F_file_mode_t_block_standard_d & (F_file_mode_t_mask_bit_read_d | F_file_mode_t_mask_bit_write_d),
    F_file_mode_t_mask_how_subtract_d & F_file_mode_t_block_standard_d & (F_file_mode_t_mask_bit_read_d | F_file_mode_t_mask_bit_execute_d),
    F_file_mode_t_mask_how_subtract_d & F_file_mode_t_block_standard_d & (F_file_mode_t_mask_bit_read_d | F_file_mode_t_mask_bit_write_d),
    F_file_mode_t_mask_how_subtract_d & F_file_mode_t_block_standard_d & (F_file_mode_t_mask_bit_write_d | F_file_mode_t_mask_bit_execute_d),
    F_file_mode_t_mask_how_subtract_d & F_file_mode_t_block_standard_d & (F_file_mode_t_mask_bit_read_d | F_file_mode_t_mask_bit_execute_d),
    F_file_mode_t_mask_how_subtract_d & F_file_mode_t_block_standard_d & (F_file_mode_t_mask_bit_write_d | F_file_mode_t_mask_bit_execute_d),
    F_file_mode_t_mask_how_add_d & F_file_mode_t_block_standard_d & (F_file_mode_t_mask_bit_read_d | F_file_mode_t_mask_bit_write_d),
    F_file_mode_t_mask_how_add_d & F_file_mode_t_block_standard_d & (F_file_mode_t_mask_bit_read_d | F_file_mode_t_mask_bit_execute_d),
    F_file_mode_t_mask_how_add_d & F_file_mode_t_block_standard_d & (F_file_mode_t_mask_bit_read_d | F_file_mode_t_mask_bit_write_d),
    F_file_mode_t_mask_how_add_d & F_file_mode_t_block_standard_d & (F_file_mode_t_mask_bit_write_d | F_file_mode_t_mask_bit_execute_d),
    F_file_mode_t_mask_how_add_d & F_file_mode_t_block_standard_d & (F_file_mode_t_mask_bit_read_d | F_file_mode_t_mask_bit_execute_d),
    F_file_mode_t_mask_how_add_d & F_file_mode_t_block_standard_d & (F_file_mode_t_mask_bit_write_d | F_file_mode_t_mask_bit_execute_d),
    F_file_mode_t_mask_how_add_d & F_file_mode_t_block_standard_d & (F_file_mode_t_mask_bit_read_d | F_file_mode_t_mask_bit_write_d | F_file_mode_t_mask_bit_execute_d),
    F_file_mode_t_mask_how_add_d & F_file_mode_t_block_standard_d & (F_file_mode_t_mask_bit_read_d | F_file_mode_t_mask_bit_write_d | F_file_mode_t_mask_bit_execute_d),
    F_file_mode_t_mask_how_add_d & F_file_mode_t_block_standard_d & (F_file_mode_t_mask_bit_read_d | F_file_mode_t_mask_bit_write_d | F_file_mode_t_mask_bit_execute_d),
    F_file_mode_t_mask_how_add_d & F_file_mode_t_block_standard_d & (F_file_mode_t_mask_bit_read_d | F_file_mode_t_mask_bit_write_d | F_file_mode_t_mask_bit_execute_d),
    F_file_mode_t_mask_how_add_d & F_file_mode_t_block_standard_d & (F_file_mode_t_mask_bit_read_d | F_file_mode_t_mask_bit_write_d | F_file_mode_t_mask_bit_execute_d),
    F_file_mode_t_mask_how_add_d & F_file_mode_t_block_standard_d & (F_file_mode_t_mask_bit_read_d | F_file_mode_t_mask_bit_write_d | F_file_mode_t_mask_bit_execute_d),
    F_file_mode_t_mask_how_add_d & F_file_mode_t_block_standard_d & (F_file_mode_t_mask_bit_read_d | F_file_mode_t_mask_bit_write_d | F_file_mode_t_mask_bit_execute_d),
    F_file_mode_t_mask_how_subtract_d & F_file_mode_t_block_standard_d & (F_file_mode_t_mask_bit_read_d | F_file_mode_t_mask_bit_write_d | F_file_mode_t_mask_bit_execute_d),
    F_file_mode_t_mask_how_subtract_d & F_file_mode_t_block_standard_d & (F_file_mode_t_mask_bit_read_d | F_file_mode_t_mask_bit_write_d | F_file_mode_t_mask_bit_execute_d),
    F_file_mode_t_mask_how_subtract_d & F_file_mode_t_block_standard_d & (F_file_mode_t_mask_bit_read_d | F_file_mode_t_mask_bit_write_d | F_file_mode_t_mask_bit_execute_d),
    F_file_mode_t_mask_how_subtract_d & F_file_mode_t_block_standard_d & (F_file_mode_t_mask_bit_read_d | F_file_mode_t_mask_bit_write_d | F_file_mode_t_mask_bit_execute_d),
    F_file_mode_t_mask_how_subtract_d & F_file_mode_t_block_standard_d & (F_file_mode_t_mask_bit_read_d | F_file_mode_t_mask_bit_write_d | F_file_mode_t_mask_bit_execute_d),
    F_file_mode_t_mask_how_subtract_d & F_file_mode_t_block_standard_d & (F_file_mode_t_mask_bit_read_d | F_file_mode_t_mask_bit_write_d | F_file_mode_t_mask_bit_execute_d),
    F_file_mode_t_mask_how_subtract_d & F_file_mode_t_block_standard_d & (F_file_mode_t_mask_bit_read_d | F_file_mode_t_mask_bit_write_d | F_file_mode_t_mask_bit_execute_d),
    F_file_mode_t_mask_how_add_d & F_file_mode_t_block_standard_d & (F_file_mode_t_mask_bit_read_d | F_file_mode_t_mask_bit_write_d | F_file_mode_t_mask_bit_execute_d),
    F_file_mode_t_mask_how_add_d & F_file_mode_t_block_standard_d & (F_file_mode_t_mask_bit_read_d | F_file_mode_t_mask_bit_write_d | F_file_mode_t_mask_bit_execute_d),
    F_file_mode_t_mask_how_add_d & F_file_mode_t_block_standard_d & (F_file_mode_t_mask_bit_read_d | F_file_mode_t_mask_bit_write_d | F_file_mode_t_mask_bit_execute_d),
    F_file_mode_t_mask_how_add_d & F_file_mode_t_block_standard_d & (F_file_mode_t_mask_bit_read_d | F_file_mode_t_mask_bit_write_d | F_file_mode_t_mask_bit_execute_d),
    F_file_mode_t_mask_how_add_d & F_file_mode_t_block_standard_d & (F_file_mode_t_mask_bit_read_d | F_file_mode_t_mask_bit_write_d | F_file_mode_t_mask_bit_execute_d),
    F_file_mode_t_mask_how_add_d & F_file_mode_t_block_standard_d & (F_file_mode_t_mask_bit_read_d | F_file_mode_t_mask_bit_write_d | F_file_mode_t_mask_bit_execute_d),
    F_file_mode_t_mask_how_add_d & F_file_mode_t_block_standard_d & (F_file_mode_t_mask_bit_read_d | F_file_mode_t_mask_bit_write_d | F_file_mode_t_mask_bit_execute_d),
    F_file_mode_t_mask_how_add_d & F_file_mode_t_block_owner_d & (F_file_mode_t_mask_bit_read_d | F_file_mode_t_mask_bit_write_d),
    F_file_mode_t_mask_how_add_d & F_file_mode_t_block_owner_d & (F_file_mode_t_mask_bit_read_d | F_file_mode_t_mask_bit_execute_d),
    F_file_mode_t_mask_how_add_d & F_file_mode_t_block_owner_d & (F_file_mode_t_mask_bit_read_d | F_file_mode_t_mask_bit_write_d),
    F_file_mode_t_mask_how_add_d & F_file_mode_t_block_owner_d & (F_file_mode_t_mask_bit_write_d | F_file_mode_t_mask_bit_execute_d),
    F_file_mode_t_mask_how_add_d & F_file_mode_t_block_owner_d & (F_file_mode_t_mask_bit_read_d | F_file_mode_t_mask_bit_execute_d),
    F_file_mode_t_mask_how_add_d & F_file_mode_t_block_owner_d & (F_file_mode_t_mask_bit_write_d | F_file_mode_t_mask_bit_execute_d),
    F_file_mode_t_mask_how_subtract_d & F_file_mode_t_block_owner_d & (F_file_mode_t_mask_bit_read_d | F_file_mode_t_mask_bit_write_d),
    F_file_mode_t_mask_how_subtract_d & F_file_mode_t_block_owner_d & (F_file_mode_t_mask_bit_read_d | F_file_mode_t_mask_bit_execute_d),
    F_file_mode_t_mask_how_subtract_d & F_file_mode_t_block_owner_d & (F_file_mode_t_mask_bit_read_d | F_file_mode_t_mask_bit_write_d),
    F_file_mode_t_mask_how_subtract_d & F_file_mode_t_block_owner_d & (F_file_mode_t_mask_bit_write_d | F_file_mode_t_mask_bit_execute_d),
    F_file_mode_t_mask_how_subtract_d & F_file_mode_t_block_owner_d & (F_file_mode_t_mask_bit_read_d | F_file_mode_t_mask_bit_execute_d),
    F_file_mode_t_mask_how_subtract_d & F_file_mode_t_block_owner_d & (F_file_mode_t_mask_bit_write_d | F_file_mode_t_mask_bit_execute_d),
    F_file_mode_t_mask_how_add_d & F_file_mode_t_block_owner_d & (F_file_mode_t_mask_bit_read_d | F_file_mode_t_mask_bit_write_d),
    F_file_mode_t_mask_how_add_d & F_file_mode_t_block_owner_d & (F_file_mode_t_mask_bit_read_d | F_file_mode_t_mask_bit_execute_d),
    F_file_mode_t_mask_how_add_d & F_file_mode_t_block_owner_d & (F_file_mode_t_mask_bit_read_d | F_file_mode_t_mask_bit_write_d),
    F_file_mode_t_mask_how_add_d & F_file_mode_t_block_owner_d & (F_file_mode_t_mask_bit_write_d | F_file_mode_t_mask_bit_execute_d),
    F_file_mode_t_mask_how_add_d & F_file_mode_t_block_owner_d & (F_file_mode_t_mask_bit_read_d | F_file_mode_t_mask_bit_execute_d),
    F_file_mode_t_mask_how_add_d & F_file_mode_t_block_owner_d & (F_file_mode_t_mask_bit_write_d | F_file_mode_t_mask_bit_execute_d),
    F_file_mode_t_mask_how_add_d & F_file_mode_t_block_owner_d & (F_file_mode_t_mask_bit_read_d | F_file_mode_t_mask_bit_write_d | F_file_mode_t_mask_bit_execute_d),
    F_file_mode_t_mask_how_add_d & F_file_mode_t_block_owner_d & (F_file_mode_t_mask_bit_read_d | F_file_mode_t_mask_bit_write_d | F_file_mode_t_mask_bit_execute_d),
    F_file_mode_t_mask_how_add_d & F_file_mode_t_block_owner_d & (F_file_mode_t_mask_bit_read_d | F_file_mode_t_mask_bit_write_d | F_file_mode_t_mask_bit_execute_d),
    F_file_mode_t_mask_how_add_d & F_file_mode_t_block_owner_d & (F_file_mode_t_mask_bit_read_d | F_file_mode_t_mask_bit_write_d | F_file_mode_t_mask_bit_execute_d),
    F_file_mode_t_mask_how_add_d & F_file_mode_t_block_owner_d & (F_file_mode_t_mask_bit_read_d | F_file_mode_t_mask_bit_write_d | F_file_mode_t_mask_bit_execute_d),
    F_file_mode_t_mask_how_add_d & F_file_mode_t_block_owner_d & (F_file_mode_t_mask_bit_read_d | F_file_mode_t_mask_bit_write_d | F_file_mode_t_mask_bit_execute_d),
    F_file_mode_t_mask_how_add_d & F_file_mode_t_block_owner_d & (F_file_mode_t_mask_bit_read_d | F_file_mode_t_mask_bit_write_d | F_file_mode_t_mask_bit_execute_d),
    F_file_mode_t_mask_how_subtract_d & F_file_mode_t_block_owner_d & (F_file_mode_t_mask_bit_read_d | F_file_mode_t_mask_bit_write_d | F_file_mode_t_mask_bit_execute_d),
    F_file_mode_t_mask_how_subtract_d & F_file_mode_t_block_owner_d & (F_file_mode_t_mask_bit_read_d | F_file_mode_t_mask_bit_write_d | F_file_mode_t_mask_bit_execute_d),
    F_file_mode_t_mask_how_subtract_d & F_file_mode_t_block_owner_d & (F_file_mode_t_mask_bit_read_d | F_file_mode_t_mask_bit_write_d | F_file_mode_t_mask_bit_execute_d),
    F_file_mode_t_mask_how_subtract_d & F_file_mode_t_block_owner_d & (F_file_mode_t_mask_bit_read_d | F_file_mode_t_mask_bit_write_d | F_file_mode_t_mask_bit_execute_d),
    F_file_mode_t_mask_how_subtract_d & F_file_mode_t_block_owner_d & (F_file_mode_t_mask_bit_read_d | F_file_mode_t_mask_bit_write_d | F_file_mode_t_mask_bit_execute_d),
    F_file_mode_t_mask_how_subtract_d & F_file_mode_t_block_owner_d & (F_file_mode_t_mask_bit_read_d | F_file_mode_t_mask_bit_write_d | F_file_mode_t_mask_bit_execute_d),
    F_file_mode_t_mask_how_subtract_d & F_file_mode_t_block_owner_d & (F_file_mode_t_mask_bit_read_d | F_file_mode_t_mask_bit_write_d | F_file_mode_t_mask_bit_execute_d),
    F_file_mode_t_mask_how_add_d & F_file_mode_t_block_owner_d & (F_file_mode_t_mask_bit_read_d | F_file_mode_t_mask_bit_write_d | F_file_mode_t_mask_bit_execute_d),
    F_file_mode_t_mask_how_add_d & F_file_mode_t_block_owner_d & (F_file_mode_t_mask_bit_read_d | F_file_mode_t_mask_bit_write_d | F_file_mode_t_mask_bit_execute_d),
    F_file_mode_t_mask_how_add_d & F_file_mode_t_block_owner_d & (F_file_mode_t_mask_bit_read_d | F_file_mode_t_mask_bit_write_d | F_file_mode_t_mask_bit_execute_d),
    F_file_mode_t_mask_how_add_d & F_file_mode_t_block_owner_d & (F_file_mode_t_mask_bit_read_d | F_file_mode_t_mask_bit_write_d | F_file_mode_t_mask_bit_execute_d),
    F_file_mode_t_mask_how_add_d & F_file_mode_t_block_owner_d & (F_file_mode_t_mask_bit_read_d | F_file_mode_t_mask_bit_write_d | F_file_mode_t_mask_bit_execute_d),
    F_file_mode_t_mask_how_add_d & F_file_mode_t_block_owner_d & (F_file_mode_t_mask_bit_read_d | F_file_mode_t_mask_bit_write_d | F_file_mode_t_mask_bit_execute_d),
    F_file_mode_t_mask_how_add_d & F_file_mode_t_block_owner_d & (F_file_mode_t_mask_bit_read_d | F_file_mode_t_mask_bit_write_d | F_file_mode_t_mask_bit_execute_d),
    F_file_mode_t_mask_how_add_d & F_file_mode_t_block_group_d & (F_file_mode_t_mask_bit_read_d | F_file_mode_t_mask_bit_write_d),
    F_file_mode_t_mask_how_add_d & F_file_mode_t_block_group_d & (F_file_mode_t_mask_bit_read_d | F_file_mode_t_mask_bit_execute_d),
    F_file_mode_t_mask_how_add_d & F_file_mode_t_block_group_d & (F_file_mode_t_mask_bit_read_d | F_file_mode_t_mask_bit_write_d),
    F_file_mode_t_mask_how_add_d & F_file_mode_t_block_group_d & (F_file_mode_t_mask_bit_write_d | F_file_mode_t_mask_bit_execute_d),
    F_file_mode_t_mask_how_add_d & F_file_mode_t_block_group_d & (F_file_mode_t_mask_bit_read_d | F_file_mode_t_mask_bit_execute_d),
    F_file_mode_t_mask_how_add_d & F_file_mode_t_block_group_d & (F_file_mode_t_mask_bit_write_d | F_file_mode_t_mask_bit_execute_d),
    F_file_mode_t_mask_how_subtract_d & F_file_mode_t_block_group_d & (F_file_mode_t_mask_bit_read_d | F_file_mode_t_mask_bit_write_d),
    F_file_mode_t_mask_how_subtract_d & F_file_mode_t_block_group_d & (F_file_mode_t_mask_bit_read_d | F_file_mode_t_mask_bit_execute_d),
    F_file_mode_t_mask_how_subtract_d & F_file_mode_t_block_group_d & (F_file_mode_t_mask_bit_read_d | F_file_mode_t_mask_bit_write_d),
    F_file_mode_t_mask_how_subtract_d & F_file_mode_t_block_group_d & (F_file_mode_t_mask_bit_write_d | F_file_mode_t_mask_bit_execute_d),
    F_file_mode_t_mask_how_subtract_d & F_file_mode_t_block_group_d & (F_file_mode_t_mask_bit_read_d | F_file_mode_t_mask_bit_execute_d),
    F_file_mode_t_mask_how_subtract_d & F_file_mode_t_block_group_d & (F_file_mode_t_mask_bit_write_d | F_file_mode_t_mask_bit_execute_d),
    F_file_mode_t_mask_how_add_d & F_file_mode_t_block_group_d & (F_file_mode_t_mask_bit_read_d | F_file_mode_t_mask_bit_write_d),
    F_file_mode_t_mask_how_add_d & F_file_mode_t_block_group_d & (F_file_mode_t_mask_bit_read_d | F_file_mode_t_mask_bit_execute_d),
    F_file_mode_t_mask_how_add_d & F_file_mode_t_block_group_d & (F_file_mode_t_mask_bit_read_d | F_file_mode_t_mask_bit_write_d),
    F_file_mode_t_mask_how_add_d & F_file_mode_t_block_group_d & (F_file_mode_t_mask_bit_write_d | F_file_mode_t_mask_bit_execute_d),
    F_file_mode_t_mask_how_add_d & F_file_mode_t_block_group_d & (F_file_mode_t_mask_bit_read_d | F_file_mode_t_mask_bit_execute_d),
    F_file_mode_t_mask_how_add_d & F_file_mode_t_block_group_d & (F_file_mode_t_mask_bit_write_d | F_file_mode_t_mask_bit_execute_d),
    F_file_mode_t_mask_how_add_d & F_file_mode_t_block_group_d & (F_file_mode_t_mask_bit_read_d | F_file_mode_t_mask_bit_write_d | F_file_mode_t_mask_bit_execute_d),
    F_file_mode_t_mask_how_add_d & F_file_mode_t_block_group_d & (F_file_mode_t_mask_bit_read_d | F_file_mode_t_mask_bit_write_d | F_file_mode_t_mask_bit_execute_d),
    F_file_mode_t_mask_how_add_d & F_file_mode_t_block_group_d & (F_file_mode_t_mask_bit_read_d | F_file_mode_t_mask_bit_write_d | F_file_mode_t_mask_bit_execute_d),
    F_file_mode_t_mask_how_add_d & F_file_mode_t_block_group_d & (F_file_mode_t_mask_bit_read_d | F_file_mode_t_mask_bit_write_d | F_file_mode_t_mask_bit_execute_d),
    F_file_mode_t_mask_how_add_d & F_file_mode_t_block_group_d & (F_file_mode_t_mask_bit_read_d | F_file_mode_t_mask_bit_write_d | F_file_mode_t_mask_bit_execute_d),
    F_file_mode_t_mask_how_add_d & F_file_mode_t_block_group_d & (F_file_mode_t_mask_bit_read_d | F_file_mode_t_mask_bit_write_d | F_file_mode_t_mask_bit_execute_d),
    F_file_mode_t_mask_how_add_d & F_file_mode_t_block_group_d & (F_file_mode_t_mask_bit_read_d | F_file_mode_t_mask_bit_write_d | F_file_mode_t_mask_bit_execute_d),
    F_file_mode_t_mask_how_subtract_d & F_file_mode_t_block_group_d & (F_file_mode_t_mask_bit_read_d | F_file_mode_t_mask_bit_write_d | F_file_mode_t_mask_bit_execute_d),
    F_file_mode_t_mask_how_subtract_d & F_file_mode_t_block_group_d & (F_file_mode_t_mask_bit_read_d | F_file_mode_t_mask_bit_write_d | F_file_mode_t_mask_bit_execute_d),
    F_file_mode_t_mask_how_subtract_d & F_file_mode_t_block_group_d & (F_file_mode_t_mask_bit_read_d | F_file_mode_t_mask_bit_write_d | F_file_mode_t_mask_bit_execute_d),
    F_file_mode_t_mask_how_subtract_d & F_file_mode_t_block_group_d & (F_file_mode_t_mask_bit_read_d | F_file_mode_t_mask_bit_write_d | F_file_mode_t_mask_bit_execute_d),
    F_file_mode_t_mask_how_subtract_d & F_file_mode_t_block_group_d & (F_file_mode_t_mask_bit_read_d | F_file_mode_t_mask_bit_write_d | F_file_mode_t_mask_bit_execute_d),
    F_file_mode_t_mask_how_subtract_d & F_file_mode_t_block_group_d & (F_file_mode_t_mask_bit_read_d | F_file_mode_t_mask_bit_write_d | F_file_mode_t_mask_bit_execute_d),
    F_file_mode_t_mask_how_subtract_d & F_file_mode_t_block_group_d & (F_file_mode_t_mask_bit_read_d | F_file_mode_t_mask_bit_write_d | F_file_mode_t_mask_bit_execute_d),
    F_file_mode_t_mask_how_add_d & F_file_mode_t_block_group_d & (F_file_mode_t_mask_bit_read_d | F_file_mode_t_mask_bit_write_d | F_file_mode_t_mask_bit_execute_d),
    F_file_mode_t_mask_how_add_d & F_file_mode_t_block_group_d & (F_file_mode_t_mask_bit_read_d | F_file_mode_t_mask_bit_write_d | F_file_mode_t_mask_bit_execute_d),
    F_file_mode_t_mask_how_add_d & F_file_mode_t_block_group_d & (F_file_mode_t_mask_bit_read_d | F_file_mode_t_mask_bit_write_d | F_file_mode_t_mask_bit_execute_d),
    F_file_mode_t_mask_how_add_d & F_file_mode_t_block_group_d & (F_file_mode_t_mask_bit_read_d | F_file_mode_t_mask_bit_write_d | F_file_mode_t_mask_bit_execute_d),
    F_file_mode_t_mask_how_add_d & F_file_mode_t_block_group_d & (F_file_mode_t_mask_bit_read_d | F_file_mode_t_mask_bit_write_d | F_file_mode_t_mask_bit_execute_d),
    F_file_mode_t_mask_how_add_d & F_file_mode_t_block_group_d & (F_file_mode_t_mask_bit_read_d | F_file_mode_t_mask_bit_write_d | F_file_mode_t_mask_bit_execute_d),
    F_file_mode_t_mask_how_add_d & F_file_mode_t_block_group_d & (F_file_mode_t_mask_bit_read_d | F_file_mode_t_mask_bit_write_d | F_file_mode_t_mask_bit_execute_d),
    F_file_mode_t_mask_how_add_d & F_file_mode_t_block_world_d & (F_file_mode_t_mask_bit_read_d | F_file_mode_t_mask_bit_write_d),
    F_file_mode_t_mask_how_add_d & F_file_mode_t_block_world_d & (F_file_mode_t_mask_bit_read_d | F_file_mode_t_mask_bit_execute_d),
    F_file_mode_t_mask_how_add_d & F_file_mode_t_block_world_d & (F_file_mode_t_mask_bit_read_d | F_file_mode_t_mask_bit_write_d),
    F_file_mode_t_mask_how_add_d & F_file_mode_t_block_world_d & (F_file_mode_t_mask_bit_write_d | F_file_mode_t_mask_bit_execute_d),
    F_file_mode_t_mask_how_add_d & F_file_mode_t_block_world_d & (F_file_mode_t_mask_bit_read_d | F_file_mode_t_mask_bit_execute_d),
    F_file_mode_t_mask_how_add_d & F_file_mode_t_block_world_d & (F_file_mode_t_mask_bit_write_d | F_file_mode_t_mask_bit_execute_d),
    F_file_mode_t_mask_how_subtract_d & F_file_mode_t_block_world_d & (F_file_mode_t_mask_bit_read_d | F_file_mode_t_mask_bit_write_d),
    F_file_mode_t_mask_how_subtract_d & F_file_mode_t_block_world_d & (F_file_mode_t_mask_bit_read_d | F_file_mode_t_mask_bit_execute_d),
    F_file_mode_t_mask_how_subtract_d & F_file_mode_t_block_world_d & (F_file_mode_t_mask_bit_read_d | F_file_mode_t_mask_bit_write_d),
    F_file_mode_t_mask_how_subtract_d & F_file_mode_t_block_world_d & (F_file_mode_t_mask_bit_write_d | F_file_mode_t_mask_bit_execute_d),
    F_file_mode_t_mask_how_subtract_d & F_file_mode_t_block_world_d & (F_file_mode_t_mask_bit_read_d | F_file_mode_t_mask_bit_execute_d),
    F_file_mode_t_mask_how_subtract_d & F_file_mode_t_block_world_d & (F_file_mode_t_mask_bit_write_d | F_file_mode_t_mask_bit_execute_d),
    F_file_mode_t_mask_how_add_d & F_file_mode_t_block_world_d & (F_file_mode_t_mask_bit_read_d | F_file_mode_t_mask_bit_write_d),
    F_file_mode_t_mask_how_add_d & F_file_mode_t_block_world_d & (F_file_mode_t_mask_bit_read_d | F_file_mode_t_mask_bit_execute_d),
    F_file_mode_t_mask_how_add_d & F_file_mode_t_block_world_d & (F_file_mode_t_mask_bit_read_d | F_file_mode_t_mask_bit_write_d),
    F_file_mode_t_mask_how_add_d & F_file_mode_t_block_world_d & (F_file_mode_t_mask_bit_write_d | F_file_mode_t_mask_bit_execute_d),
    F_file_mode_t_mask_how_add_d & F_file_mode_t_block_world_d & (F_file_mode_t_mask_bit_read_d | F_file_mode_t_mask_bit_execute_d),
    F_file_mode_t_mask_how_add_d & F_file_mode_t_block_world_d & (F_file_mode_t_mask_bit_write_d | F_file_mode_t_mask_bit_execute_d),
    F_file_mode_t_mask_how_add_d & F_file_mode_t_block_world_d & (F_file_mode_t_mask_bit_read_d | F_file_mode_t_mask_bit_write_d | F_file_mode_t_mask_bit_execute_d),
    F_file_mode_t_mask_how_add_d & F_file_mode_t_block_world_d & (F_file_mode_t_mask_bit_read_d | F_file_mode_t_mask_bit_write_d | F_file_mode_t_mask_bit_execute_d),
    F_file_mode_t_mask_how_add_d & F_file_mode_t_block_world_d & (F_file_mode_t_mask_bit_read_d | F_file_mode_t_mask_bit_write_d | F_file_mode_t_mask_bit_execute_d),
    F_file_mode_t_mask_how_add_d & F_file_mode_t_block_world_d & (F_file_mode_t_mask_bit_read_d | F_file_mode_t_mask_bit_write_d | F_file_mode_t_mask_bit_execute_d),
    F_file_mode_t_mask_how_add_d & F_file_mode_t_block_world_d & (F_file_mode_t_mask_bit_read_d | F_file_mode_t_mask_bit_write_d | F_file_mode_t_mask_bit_execute_d),
    F_file_mode_t_mask_how_add_d & F_file_mode_t_block_world_d & (F_file_mode_t_mask_bit_read_d | F_file_mode_t_mask_bit_write_d | F_file_mode_t_mask_bit_execute_d),
    F_file_mode_t_mask_how_add_d & F_file_mode_t_block_world_d & (F_file_mode_t_mask_bit_read_d | F_file_mode_t_mask_bit_write_d | F_file_mode_t_mask_bit_execute_d),
    F_file_mode_t_mask_how_subtract_d & F_file_mode_t_block_world_d & (F_file_mode_t_mask_bit_read_d | F_file_mode_t_mask_bit_write_d | F_file_mode_t_mask_bit_execute_d),
    F_file_mode_t_mask_how_subtract_d & F_file_mode_t_block_world_d & (F_file_mode_t_mask_bit_read_d | F_file_mode_t_mask_bit_write_d | F_file_mode_t_mask_bit_execute_d),
    F_file_mode_t_mask_how_subtract_d & F_file_mode_t_block_world_d & (F_file_mode_t_mask_bit_read_d | F_file_mode_t_mask_bit_write_d | F_file_mode_t_mask_bit_execute_d),
    F_file_mode_t_mask_how_subtract_d & F_file_mode_t_block_world_d & (F_file_mode_t_mask_bit_read_d | F_file_mode_t_mask_bit_write_d | F_file_mode_t_mask_bit_execute_d),
    F_file_mode_t_mask_how_subtract_d & F_file_mode_t_block_world_d & (F_file_mode_t_mask_bit_read_d | F_file_mode_t_mask_bit_write_d | F_file_mode_t_mask_bit_execute_d),
    F_file_mode_t_mask_how_subtract_d & F_file_mode_t_block_world_d & (F_file_mode_t_mask_bit_read_d | F_file_mode_t_mask_bit_write_d | F_file_mode_t_mask_bit_execute_d),
    F_file_mode_t_mask_how_subtract_d & F_file_mode_t_block_world_d & (F_file_mode_t_mask_bit_read_d | F_file_mode_t_mask_bit_write_d | F_file_mode_t_mask_bit_execute_d),
    F_file_mode_t_mask_how_add_d & F_file_mode_t_block_world_d & (F_file_mode_t_mask_bit_read_d | F_file_mode_t_mask_bit_write_d | F_file_mode_t_mask_bit_execute_d),
    F_file_mode_t_mask_how_add_d & F_file_mode_t_block_world_d & (F_file_mode_t_mask_bit_read_d | F_file_mode_t_mask_bit_write_d | F_file_mode_t_mask_bit_execute_d),
    F_file_mode_t_mask_how_add_d & F_file_mode_t_block_world_d & (F_file_mode_t_mask_bit_read_d | F_file_mode_t_mask_bit_write_d | F_file_mode_t_mask_bit_execute_d),
    F_file_mode_t_mask_how_add_d & F_file_mode_t_block_world_d & (F_file_mode_t_mask_bit_read_d | F_file_mode_t_mask_bit_write_d | F_file_mode_t_mask_bit_execute_d),
    F_file_mode_t_mask_how_add_d & F_file_mode_t_block_world_d & (F_file_mode_t_mask_bit_read_d | F_file_mode_t_mask_bit_write_d | F_file_mode_t_mask_bit_execute_d),
    F_file_mode_t_mask_how_add_d & F_file_mode_t_block_world_d & (F_file_mode_t_mask_bit_read_d | F_file_mode_t_mask_bit_write_d | F_file_mode_t_mask_bit_execute_d),
    F_file_mode_t_mask_how_add_d & F_file_mode_t_block_world_d & (F_file_mode_t_mask_bit_read_d | F_file_mode_t_mask_bit_write_d | F_file_mode_t_mask_bit_execute_d),
    F_file_mode_t_mask_how_add_d & (F_file_mode_t_block_owner_d | F_file_mode_t_block_group_d) & (F_file_mode_t_mask_bit_read_d | F_file_mode_t_mask_bit_write_d),
    F_file_mode_t_mask_how_add_d & (F_file_mode_t_block_owner_d | F_file_mode_t_block_group_d) & (F_file_mode_t_mask_bit_read_d | F_file_mode_t_mask_bit_execute_d),
    F_file_mode_t_mask_how_add_d & (F_file_mode_t_block_owner_d | F_file_mode_t_block_group_d) & (F_file_mode_t_mask_bit_read_d | F_file_mode_t_mask_bit_write_d),
    F_file_mode_t_mask_how_add_d & (F_file_mode_t_block_owner_d | F_file_mode_t_block_group_d) & (F_file_mode_t_mask_bit_write_d | F_file_mode_t_mask_bit_execute_d),
    F_file_mode_t_mask_how_add_d & (F_file_mode_t_block_owner_d | F_file_mode_t_block_group_d) & (F_file_mode_t_mask_bit_read_d | F_file_mode_t_mask_bit_execute_d),
    F_file_mode_t_mask_how_add_d & (F_file_mode_t_block_owner_d | F_file_mode_t_block_group_d) & (F_file_mode_t_mask_bit_write_d | F_file_mode_t_mask_bit_execute_d),
    F_file_mode_t_mask_how_subtract_d & (F_file_mode_t_block_owner_d | F_file_mode_t_block_group_d) & (F_file_mode_t_mask_bit_read_d | F_file_mode_t_mask_bit_write_d),
    F_file_mode_t_mask_how_subtract_d & (F_file_mode_t_block_owner_d | F_file_mode_t_block_group_d) & (F_file_mode_t_mask_bit_read_d | F_file_mode_t_mask_bit_execute_d),
    F_file_mode_t_mask_how_subtract_d & (F_file_mode_t_block_owner_d | F_file_mode_t_block_group_d) & (F_file_mode_t_mask_bit_read_d | F_file_mode_t_mask_bit_write_d),
    F_file_mode_t_mask_how_subtract_d & (F_file_mode_t_block_owner_d | F_file_mode_t_block_group_d) & (F_file_mode_t_mask_bit_write_d | F_file_mode_t_mask_bit_execute_d),
    F_file_mode_t_mask_how_subtract_d & (F_file_mode_t_block_owner_d | F_file_mode_t_block_group_d) & (F_file_mode_t_mask_bit_read_d | F_file_mode_t_mask_bit_execute_d),
    F_file_mode_t_mask_how_subtract_d & (F_file_mode_t_block_owner_d | F_file_mode_t_block_group_d) & (F_file_mode_t_mask_bit_write_d | F_file_mode_t_mask_bit_execute_d),
    F_file_mode_t_mask_how_add_d & (F_file_mode_t_block_owner_d | F_file_mode_t_block_group_d) & (F_file_mode_t_mask_bit_read_d | F_file_mode_t_mask_bit_write_d),
    F_file_mode_t_mask_how_add_d & (F_file_mode_t_block_owner_d | F_file_mode_t_block_group_d) & (F_file_mode_t_mask_bit_read_d | F_file_mode_t_mask_bit_execute_d),
    F_file_mode_t_mask_how_add_d & (F_file_mode_t_block_owner_d | F_file_mode_t_block_group_d) & (F_file_mode_t_mask_bit_read_d | F_file_mode_t_mask_bit_write_d),
    F_file_mode_t_mask_how_add_d & (F_file_mode_t_block_owner_d | F_file_mode_t_block_group_d) & (F_file_mode_t_mask_bit_write_d | F_file_mode_t_mask_bit_execute_d),
    F_file_mode_t_mask_how_add_d & (F_file_mode_t_block_owner_d | F_file_mode_t_block_group_d) & (F_file_mode_t_mask_bit_read_d | F_file_mode_t_mask_bit_execute_d),
    F_file_mode_t_mask_how_add_d & (F_file_mode_t_block_owner_d | F_file_mode_t_block_group_d) & (F_file_mode_t_mask_bit_write_d | F_file_mode_t_mask_bit_execute_d),
    F_file_mode_t_mask_how_add_d & (F_file_mode_t_block_owner_d | F_file_mode_t_block_group_d) & (F_file_mode_t_mask_bit_read_d | F_file_mode_t_mask_bit_write_d | F_file_mode_t_mask_bit_execute_d),
    F_file_mode_t_mask_how_add_d & (F_file_mode_t_block_owner_d | F_file_mode_t_block_group_d) & (F_file_mode_t_mask_bit_read_d | F_file_mode_t_mask_bit_write_d | F_file_mode_t_mask_bit_execute_d),
    F_file_mode_t_mask_how_add_d & (F_file_mode_t_block_owner_d | F_file_mode_t_block_group_d) & (F_file_mode_t_mask_bit_read_d | F_file_mode_t_mask_bit_write_d | F_file_mode_t_mask_bit_execute_d),
    F_file_mode_t_mask_how_add_d & (F_file_mode_t_block_owner_d | F_file_mode_t_block_group_d) & (F_file_mode_t_mask_bit_read_d | F_file_mode_t_mask_bit_write_d | F_file_mode_t_mask_bit_execute_d),
    F_file_mode_t_mask_how_add_d & (F_file_mode_t_block_owner_d | F_file_mode_t_block_group_d) & (F_file_mode_t_mask_bit_read_d | F_file_mode_t_mask_bit_write_d | F_file_mode_t_mask_bit_execute_d),
    F_file_mode_t_mask_how_add_d & (F_file_mode_t_block_owner_d | F_file_mode_t_block_group_d) & (F_file_mode_t_mask_bit_read_d | F_file_mode_t_mask_bit_write_d | F_file_mode_t_mask_bit_execute_d),
    F_file_mode_t_mask_how_add_d & (F_file_mode_t_block_owner_d | F_file_mode_t_block_group_d) & (F_file_mode_t_mask_bit_read_d | F_file_mode_t_mask_bit_write_d | F_file_mode_t_mask_bit_execute_d),
    F_file_mode_t_mask_how_subtract_d & (F_file_mode_t_block_owner_d | F_file_mode_t_block_group_d) & (F_file_mode_t_mask_bit_read_d | F_file_mode_t_mask_bit_write_d | F_file_mode_t_mask_bit_execute_d),
    F_file_mode_t_mask_how_subtract_d & (F_file_mode_t_block_owner_d | F_file_mode_t_block_group_d) & (F_file_mode_t_mask_bit_read_d | F_file_mode_t_mask_bit_write_d | F_file_mode_t_mask_bit_execute_d),
    F_file_mode_t_mask_how_subtract_d & (F_file_mode_t_block_owner_d | F_file_mode_t_block_group_d) & (F_file_mode_t_mask_bit_read_d | F_file_mode_t_mask_bit_write_d | F_file_mode_t_mask_bit_execute_d),
    F_file_mode_t_mask_how_subtract_d & (F_file_mode_t_block_owner_d | F_file_mode_t_block_group_d) & (F_file_mode_t_mask_bit_read_d | F_file_mode_t_mask_bit_write_d | F_file_mode_t_mask_bit_execute_d),
    F_file_mode_t_mask_how_subtract_d & (F_file_mode_t_block_owner_d | F_file_mode_t_block_group_d) & (F_file_mode_t_mask_bit_read_d | F_file_mode_t_mask_bit_write_d | F_file_mode_t_mask_bit_execute_d),
    F_file_mode_t_mask_how_subtract_d & (F_file_mode_t_block_owner_d | F_file_mode_t_block_group_d) & (F_file_mode_t_mask_bit_read_d | F_file_mode_t_mask_bit_write_d | F_file_mode_t_mask_bit_execute_d),
    F_file_mode_t_mask_how_subtract_d & (F_file_mode_t_block_owner_d | F_file_mode_t_block_group_d) & (F_file_mode_t_mask_bit_read_d | F_file_mode_t_mask_bit_write_d | F_file_mode_t_mask_bit_execute_d),
    F_file_mode_t_mask_how_add_d & (F_file_mode_t_block_owner_d | F_file_mode_t_block_group_d) & (F_file_mode_t_mask_bit_read_d | F_file_mode_t_mask_bit_write_d | F_file_mode_t_mask_bit_execute_d),
    F_file_mode_t_mask_how_add_d & (F_file_mode_t_block_owner_d | F_file_mode_t_block_group_d) & (F_file_mode_t_mask_bit_read_d | F_file_mode_t_mask_bit_write_d | F_file_mode_t_mask_bit_execute_d),
    F_file_mode_t_mask_how_add_d & (F_file_mode_t_block_owner_d | F_file_mode_t_block_group_d) & (F_file_mode_t_mask_bit_read_d | F_file_mode_t_mask_bit_write_d | F_file_mode_t_mask_bit_execute_d),
    F_file_mode_t_mask_how_add_d & (F_file_mode_t_block_owner_d | F_file_mode_t_block_group_d) & (F_file_mode_t_mask_bit_read_d | F_file_mode_t_mask_bit_write_d | F_file_mode_t_mask_bit_execute_d),
    F_file_mode_t_mask_how_add_d & (F_file_mode_t_block_owner_d | F_file_mode_t_block_group_d) & (F_file_mode_t_mask_bit_read_d | F_file_mode_t_mask_bit_write_d | F_file_mode_t_mask_bit_execute_d),
    F_file_mode_t_mask_how_add_d & (F_file_mode_t_block_owner_d | F_file_mode_t_block_group_d) & (F_file_mode_t_mask_bit_read_d | F_file_mode_t_mask_bit_write_d | F_file_mode_t_mask_bit_execute_d),
    F_file_mode_t_mask_how_add_d & (F_file_mode_t_block_owner_d | F_file_mode_t_block_group_d) & (F_file_mode_t_mask_bit_read_d | F_file_mode_t_mask_bit_write_d | F_file_mode_t_mask_bit_execute_d),
    F_file_mode_t_mask_how_add_d & (F_file_mode_t_block_owner_d | F_file_mode_t_block_world_d) & (F_file_mode_t_mask_bit_read_d | F_file_mode_t_mask_bit_write_d),
    F_file_mode_t_mask_how_add_d & (F_file_mode_t_block_owner_d | F_file_mode_t_block_world_d) & (F_file_mode_t_mask_bit_read_d | F_file_mode_t_mask_bit_execute_d),
    F_file_mode_t_mask_how_add_d & (F_file_mode_t_block_owner_d | F_file_mode_t_block_world_d) & (F_file_mode_t_mask_bit_read_d | F_file_mode_t_mask_bit_write_d),
    F_file_mode_t_mask_how_add_d & (F_file_mode_t_block_owner_d | F_file_mode_t_block_world_d) & (F_file_mode_t_mask_bit_write_d | F_file_mode_t_mask_bit_execute_d),
    F_file_mode_t_mask_how_add_d & (F_file_mode_t_block_owner_d | F_file_mode_t_block_world_d) & (F_file_mode_t_mask_bit_read_d | F_file_mode_t_mask_bit_execute_d),
    F_file_mode_t_mask_how_add_d & (F_file_mode_t_block_owner_d | F_file_mode_t_block_world_d) & (F_file_mode_t_mask_bit_write_d | F_file_mode_t_mask_bit_execute_d),
    F_file_mode_t_mask_how_subtract_d & (F_file_mode_t_block_owner_d | F_file_mode_t_block_world_d) & (F_file_mode_t_mask_bit_read_d | F_file_mode_t_mask_bit_write_d),
    F_file_mode_t_mask_how_subtract_d & (F_file_mode_t_block_owner_d | F_file_mode_t_block_world_d) & (F_file_mode_t_mask_bit_read_d | F_file_mode_t_mask_bit_execute_d),
    F_file_mode_t_mask_how_subtract_d & (F_file_mode_t_block_owner_d | F_file_mode_t_block_world_d) & (F_file_mode_t_mask_bit_read_d | F_file_mode_t_mask_bit_write_d),
    F_file_mode_t_mask_how_subtract_d & (F_file_mode_t_block_owner_d | F_file_mode_t_block_world_d) & (F_file_mode_t_mask_bit_write_d | F_file_mode_t_mask_bit_execute_d),
    F_file_mode_t_mask_how_subtract_d & (F_file_mode_t_block_owner_d | F_file_mode_t_block_world_d) & (F_file_mode_t_mask_bit_read_d | F_file_mode_t_mask_bit_execute_d),
    F_file_mode_t_mask_how_subtract_d & (F_file_mode_t_block_owner_d | F_file_mode_t_block_world_d) & (F_file_mode_t_mask_bit_write_d | F_file_mode_t_mask_bit_execute_d),
    F_file_mode_t_mask_how_add_d & (F_file_mode_t_block_owner_d | F_file_mode_t_block_world_d) & (F_file_mode_t_mask_bit_read_d | F_file_mode_t_mask_bit_write_d),
    F_file_mode_t_mask_how_add_d & (F_file_mode_t_block_owner_d | F_file_mode_t_block_world_d) & (F_file_mode_t_mask_bit_read_d | F_file_mode_t_mask_bit_execute_d),
    F_file_mode_t_mask_how_add_d & (F_file_mode_t_block_owner_d | F_file_mode_t_block_world_d) & (F_file_mode_t_mask_bit_read_d | F_file_mode_t_mask_bit_write_d),
    F_file_mode_t_mask_how_add_d & (F_file_mode_t_block_owner_d | F_file_mode_t_block_world_d) & (F_file_mode_t_mask_bit_write_d | F_file_mode_t_mask_bit_execute_d),
    F_file_mode_t_mask_how_add_d & (F_file_mode_t_block_owner_d | F_file_mode_t_block_world_d) & (F_file_mode_t_mask_bit_read_d | F_file_mode_t_mask_bit_execute_d),
    F_file_mode_t_mask_how_add_d & (F_file_mode_t_block_owner_d | F_file_mode_t_block_world_d) & (F_file_mode_t_mask_bit_write_d | F_file_mode_t_mask_bit_execute_d),
    F_file_mode_t_mask_how_add_d & (F_file_mode_t_block_owner_d | F_file_mode_t_block_world_d) & (F_file_mode_t_mask_bit_read_d | F_file_mode_t_mask_bit_write_d | F_file_mode_t_mask_bit_execute_d),
    F_file_mode_t_mask_how_add_d & (F_file_mode_t_block_owner_d | F_file_mode_t_block_world_d) & (F_file_mode_t_mask_bit_read_d | F_file_mode_t_mask_bit_write_d | F_file_mode_t_mask_bit_execute_d),
    F_file_mode_t_mask_how_add_d & (F_file_mode_t_block_owner_d | F_file_mode_t_block_world_d) & (F_file_mode_t_mask_bit_read_d | F_file_mode_t_mask_bit_write_d | F_file_mode_t_mask_bit_execute_d),
    F_file_mode_t_mask_how_add_d & (F_file_mode_t_block_owner_d | F_file_mode_t_block_world_d) & (F_file_mode_t_mask_bit_read_d | F_file_mode_t_mask_bit_write_d | F_file_mode_t_mask_bit_execute_d),
    F_file_mode_t_mask_how_add_d & (F_file_mode_t_block_owner_d | F_file_mode_t_block_world_d) & (F_file_mode_t_mask_bit_read_d | F_file_mode_t_mask_bit_write_d | F_file_mode_t_mask_bit_execute_d),
    F_file_mode_t_mask_how_add_d & (F_file_mode_t_block_owner_d | F_file_mode_t_block_world_d) & (F_file_mode_t_mask_bit_read_d | F_file_mode_t_mask_bit_write_d | F_file_mode_t_mask_bit_execute_d),
    F_file_mode_t_mask_how_add_d & (F_file_mode_t_block_owner_d | F_file_mode_t_block_world_d) & (F_file_mode_t_mask_bit_read_d | F_file_mode_t_mask_bit_write_d | F_file_mode_t_mask_bit_execute_d),
    F_file_mode_t_mask_how_subtract_d & (F_file_mode_t_block_owner_d | F_file_mode_t_block_world_d) & (F_file_mode_t_mask_bit_read_d | F_file_mode_t_mask_bit_write_d | F_file_mode_t_mask_bit_execute_d),
    F_file_mode_t_mask_how_subtract_d & (F_file_mode_t_block_owner_d | F_file_mode_t_block_world_d) & (F_file_mode_t_mask_bit_read_d | F_file_mode_t_mask_bit_write_d | F_file_mode_t_mask_bit_execute_d),
    F_file_mode_t_mask_how_subtract_d & (F_file_mode_t_block_owner_d | F_file_mode_t_block_world_d) & (F_file_mode_t_mask_bit_read_d | F_file_mode_t_mask_bit_write_d | F_file_mode_t_mask_bit_execute_d),
    F_file_mode_t_mask_how_subtract_d & (F_file_mode_t_block_owner_d | F_file_mode_t_block_world_d) & (F_file_mode_t_mask_bit_read_d | F_file_mode_t_mask_bit_write_d | F_file_mode_t_mask_bit_execute_d),
    F_file_mode_t_mask_how_subtract_d & (F_file_mode_t_block_owner_d | F_file_mode_t_block_world_d) & (F_file_mode_t_mask_bit_read_d | F_file_mode_t_mask_bit_write_d | F_file_mode_t_mask_bit_execute_d),
    F_file_mode_t_mask_how_subtract_d & (F_file_mode_t_block_owner_d | F_file_mode_t_block_world_d) & (F_file_mode_t_mask_bit_read_d | F_file_mode_t_mask_bit_write_d | F_file_mode_t_mask_bit_execute_d),
    F_file_mode_t_mask_how_subtract_d & (F_file_mode_t_block_owner_d | F_file_mode_t_block_world_d) & (F_file_mode_t_mask_bit_read_d | F_file_mode_t_mask_bit_write_d | F_file_mode_t_mask_bit_execute_d),
    F_file_mode_t_mask_how_add_d & (F_file_mode_t_block_owner_d | F_file_mode_t_block_world_d) & (F_file_mode_t_mask_bit_read_d | F_file_mode_t_mask_bit_write_d | F_file_mode_t_mask_bit_execute_d),
    F_file_mode_t_mask_how_add_d & (F_file_mode_t_block_owner_d | F_file_mode_t_block_world_d) & (F_file_mode_t_mask_bit_read_d | F_file_mode_t_mask_bit_write_d | F_file_mode_t_mask_bit_execute_d),
    F_file_mode_t_mask_how_add_d & (F_file_mode_t_block_owner_d | F_file_mode_t_block_world_d) & (F_file_mode_t_mask_bit_read_d | F_file_mode_t_mask_bit_write_d | F_file_mode_t_mask_bit_execute_d),
    F_file_mode_t_mask_how_add_d & (F_file_mode_t_block_owner_d | F_file_mode_t_block_world_d) & (F_file_mode_t_mask_bit_read_d | F_file_mode_t_mask_bit_write_d | F_file_mode_t_mask_bit_execute_d),
    F_file_mode_t_mask_how_add_d & (F_file_mode_t_block_owner_d | F_file_mode_t_block_world_d) & (F_file_mode_t_mask_bit_read_d | F_file_mode_t_mask_bit_write_d | F_file_mode_t_mask_bit_execute_d),
    F_file_mode_t_mask_how_add_d & (F_file_mode_t_block_owner_d | F_file_mode_t_block_world_d) & (F_file_mode_t_mask_bit_read_d | F_file_mode_t_mask_bit_write_d | F_file_mode_t_mask_bit_execute_d),
    F_file_mode_t_mask_how_add_d & (F_file_mode_t_block_owner_d | F_file_mode_t_block_world_d) & (F_file_mode_t_mask_bit_read_d | F_file_mode_t_mask_bit_write_d | F_file_mode_t_mask_bit_execute_d),
    F_file_mode_t_mask_how_add_d & (F_file_mode_t_block_owner_d | F_file_mode_t_block_group_d) & (F_file_mode_t_mask_bit_read_d | F_file_mode_t_mask_bit_write_d),
    F_file_mode_t_mask_how_add_d & (F_file_mode_t_block_owner_d | F_file_mode_t_block_group_d) & (F_file_mode_t_mask_bit_read_d | F_file_mode_t_mask_bit_execute_d),
    F_file_mode_t_mask_how_add_d & (F_file_mode_t_block_owner_d | F_file_mode_t_block_group_d) & (F_file_mode_t_mask_bit_read_d | F_file_mode_t_mask_bit_write_d),
    F_file_mode_t_mask_how_add_d & (F_file_mode_t_block_owner_d | F_file_mode_t_block_group_d) & (F_file_mode_t_mask_bit_write_d | F_file_mode_t_mask_bit_execute_d),
    F_file_mode_t_mask_how_add_d & (F_file_mode_t_block_owner_d | F_file_mode_t_block_group_d) & (F_file_mode_t_mask_bit_read_d | F_file_mode_t_mask_bit_execute_d),
    F_file_mode_t_mask_how_add_d & (F_file_mode_t_block_owner_d | F_file_mode_t_block_group_d) & (F_file_mode_t_mask_bit_write_d | F_file_mode_t_mask_bit_execute_d),
    F_file_mode_t_mask_how_subtract_d & (F_file_mode_t_block_owner_d | F_file_mode_t_block_group_d) & (F_file_mode_t_mask_bit_read_d | F_file_mode_t_mask_bit_write_d),
    F_file_mode_t_mask_how_subtract_d & (F_file_mode_t_block_owner_d | F_file_mode_t_block_group_d) & (F_file_mode_t_mask_bit_read_d | F_file_mode_t_mask_bit_execute_d),
    F_file_mode_t_mask_how_subtract_d & (F_file_mode_t_block_owner_d | F_file_mode_t_block_group_d) & (F_file_mode_t_mask_bit_read_d | F_file_mode_t_mask_bit_write_d),
    F_file_mode_t_mask_how_subtract_d & (F_file_mode_t_block_owner_d | F_file_mode_t_block_group_d) & (F_file_mode_t_mask_bit_write_d | F_file_mode_t_mask_bit_execute_d),
    F_file_mode_t_mask_how_subtract_d & (F_file_mode_t_block_owner_d | F_file_mode_t_block_group_d) & (F_file_mode_t_mask_bit_read_d | F_file_mode_t_mask_bit_execute_d),
    F_file_mode_t_mask_how_subtract_d & (F_file_mode_t_block_owner_d | F_file_mode_t_block_group_d) & (F_file_mode_t_mask_bit_write_d | F_file_mode_t_mask_bit_execute_d),
    F_file_mode_t_mask_how_add_d & (F_file_mode_t_block_owner_d | F_file_mode_t_block_group_d) & (F_file_mode_t_mask_bit_read_d | F_file_mode_t_mask_bit_write_d),
    F_file_mode_t_mask_how_add_d & (F_file_mode_t_block_owner_d | F_file_mode_t_block_group_d) & (F_file_mode_t_mask_bit_read_d | F_file_mode_t_mask_bit_execute_d),
    F_file_mode_t_mask_how_add_d & (F_file_mode_t_block_owner_d | F_file_mode_t_block_group_d) & (F_file_mode_t_mask_bit_read_d | F_file_mode_t_mask_bit_write_d),
    F_file_mode_t_mask_how_add_d & (F_file_mode_t_block_owner_d | F_file_mode_t_block_group_d) & (F_file_mode_t_mask_bit_write_d | F_file_mode_t_mask_bit_execute_d),
    F_file_mode_t_mask_how_add_d & (F_file_mode_t_block_owner_d | F_file_mode_t_block_group_d) & (F_file_mode_t_mask_bit_read_d | F_file_mode_t_mask_bit_execute_d),
    F_file_mode_t_mask_how_add_d & (F_file_mode_t_block_owner_d | F_file_mode_t_block_group_d) & (F_file_mode_t_mask_bit_write_d | F_file_mode_t_mask_bit_execute_d),
    F_file_mode_t_mask_how_add_d & (F_file_mode_t_block_owner_d | F_file_mode_t_block_group_d) & (F_file_mode_t_mask_bit_read_d | F_file_mode_t_mask_bit_write_d | F_file_mode_t_mask_bit_execute_d),
    F_file_mode_t_mask_how_add_d & (F_file_mode_t_block_owner_d | F_file_mode_t_block_group_d) & (F_file_mode_t_mask_bit_read_d | F_file_mode_t_mask_bit_write_d | F_file_mode_t_mask_bit_execute_d),
    F_file_mode_t_mask_how_add_d & (F_file_mode_t_block_owner_d | F_file_mode_t_block_group_d) & (F_file_mode_t_mask_bit_read_d | F_file_mode_t_mask_bit_write_d | F_file_mode_t_mask_bit_execute_d),
    F_file_mode_t_mask_how_add_d & (F_file_mode_t_block_owner_d | F_file_mode_t_block_group_d) & (F_file_mode_t_mask_bit_read_d | F_file_mode_t_mask_bit_write_d | F_file_mode_t_mask_bit_execute_d),
    F_file_mode_t_mask_how_add_d & (F_file_mode_t_block_owner_d | F_file_mode_t_block_group_d) & (F_file_mode_t_mask_bit_read_d | F_file_mode_t_mask_bit_write_d | F_file_mode_t_mask_bit_execute_d),
    F_file_mode_t_mask_how_add_d & (F_file_mode_t_block_owner_d | F_file_mode_t_block_group_d) & (F_file_mode_t_mask_bit_read_d | F_file_mode_t_mask_bit_write_d | F_file_mode_t_mask_bit_execute_d),
    F_file_mode_t_mask_how_add_d & (F_file_mode_t_block_owner_d | F_file_mode_t_block_group_d) & (F_file_mode_t_mask_bit_read_d | F_file_mode_t_mask_bit_write_d | F_file_mode_t_mask_bit_execute_d),
    F_file_mode_t_mask_how_subtract_d & (F_file_mode_t_block_owner_d | F_file_mode_t_block_group_d) & (F_file_mode_t_mask_bit_read_d | F_file_mode_t_mask_bit_write_d | F_file_mode_t_mask_bit_execute_d),
    F_file_mode_t_mask_how_subtract_d & (F_file_mode_t_block_owner_d | F_file_mode_t_block_group_d) & (F_file_mode_t_mask_bit_read_d | F_file_mode_t_mask_bit_write_d | F_file_mode_t_mask_bit_execute_d),
    F_file_mode_t_mask_how_subtract_d & (F_file_mode_t_block_owner_d | F_file_mode_t_block_group_d) & (F_file_mode_t_mask_bit_read_d | F_file_mode_t_mask_bit_write_d | F_file_mode_t_mask_bit_execute_d),
    F_file_mode_t_mask_how_subtract_d & (F_file_mode_t_block_owner_d | F_file_mode_t_block_group_d) & (F_file_mode_t_mask_bit_read_d | F_file_mode_t_mask_bit_write_d | F_file_mode_t_mask_bit_execute_d),
    F_file_mode_t_mask_how_subtract_d & (F_file_mode_t_block_owner_d | F_file_mode_t_block_group_d) & (F_file_mode_t_mask_bit_read_d | F_file_mode_t_mask_bit_write_d | F_file_mode_t_mask_bit_execute_d),
    F_file_mode_t_mask_how_subtract_d & (F_file_mode_t_block_owner_d | F_file_mode_t_block_group_d) & (F_file_mode_t_mask_bit_read_d | F_file_mode_t_mask_bit_write_d | F_file_mode_t_mask_bit_execute_d),
    F_file_mode_t_mask_how_subtract_d & (F_file_mode_t_block_owner_d | F_file_mode_t_block_group_d) & (F_file_mode_t_mask_bit_read_d | F_file_mode_t_mask_bit_write_d | F_file_mode_t_mask_bit_execute_d),
    F_file_mode_t_mask_how_add_d & (F_file_mode_t_block_owner_d | F_file_mode_t_block_group_d) & (F_file_mode_t_mask_bit_read_d | F_file_mode_t_mask_bit_write_d | F_file_mode_t_mask_bit_execute_d),
    F_file_mode_t_mask_how_add_d & (F_file_mode_t_block_owner_d | F_file_mode_t_block_group_d) & (F_file_mode_t_mask_bit_read_d | F_file_mode_t_mask_bit_write_d | F_file_mode_t_mask_bit_execute_d),
    F_file_mode_t_mask_how_add_d & (F_file_mode_t_block_owner_d | F_file_mode_t_block_group_d) & (F_file_mode_t_mask_bit_read_d | F_file_mode_t_mask_bit_write_d | F_file_mode_t_mask_bit_execute_d),
    F_file_mode_t_mask_how_add_d & (F_file_mode_t_block_owner_d | F_file_mode_t_block_group_d) & (F_file_mode_t_mask_bit_read_d | F_file_mode_t_mask_bit_write_d | F_file_mode_t_mask_bit_execute_d),
    F_file_mode_t_mask_how_add_d & (F_file_mode_t_block_owner_d | F_file_mode_t_block_group_d) & (F_file_mode_t_mask_bit_read_d | F_file_mode_t_mask_bit_write_d | F_file_mode_t_mask_bit_execute_d),
    F_file_mode_t_mask_how_add_d & (F_file_mode_t_block_owner_d | F_file_mode_t_block_group_d) & (F_file_mode_t_mask_bit_read_d | F_file_mode_t_mask_bit_write_d | F_file_mode_t_mask_bit_execute_d),
    F_file_mode_t_mask_how_add_d & (F_file_mode_t_block_owner_d | F_file_mode_t_block_group_d) & (F_file_mode_t_mask_bit_read_d | F_file_mode_t_mask_bit_write_d | F_file_mode_t_mask_bit_execute_d),
    F_file_mode_t_mask_how_add_d & (F_file_mode_t_block_group_d | F_file_mode_t_block_world_d) & (F_file_mode_t_mask_bit_read_d | F_file_mode_t_mask_bit_write_d),
    F_file_mode_t_mask_how_add_d & (F_file_mode_t_block_group_d | F_file_mode_t_block_world_d) & (F_file_mode_t_mask_bit_read_d | F_file_mode_t_mask_bit_execute_d),
    F_file_mode_t_mask_how_add_d & (F_file_mode_t_block_group_d | F_file_mode_t_block_world_d) & (F_file_mode_t_mask_bit_read_d | F_file_mode_t_mask_bit_write_d),
    F_file_mode_t_mask_how_add_d & (F_file_mode_t_block_group_d | F_file_mode_t_block_world_d) & (F_file_mode_t_mask_bit_write_d | F_file_mode_t_mask_bit_execute_d),
    F_file_mode_t_mask_how_add_d & (F_file_mode_t_block_group_d | F_file_mode_t_block_world_d) & (F_file_mode_t_mask_bit_read_d | F_file_mode_t_mask_bit_execute_d),
    F_file_mode_t_mask_how_add_d & (F_file_mode_t_block_group_d | F_file_mode_t_block_world_d) & (F_file_mode_t_mask_bit_write_d | F_file_mode_t_mask_bit_execute_d),
    F_file_mode_t_mask_how_subtract_d & (F_file_mode_t_block_group_d | F_file_mode_t_block_world_d) & (F_file_mode_t_mask_bit_read_d | F_file_mode_t_mask_bit_write_d),
    F_file_mode_t_mask_how_subtract_d & (F_file_mode_t_block_group_d | F_file_mode_t_block_world_d) & (F_file_mode_t_mask_bit_read_d | F_file_mode_t_mask_bit_execute_d),
    F_file_mode_t_mask_how_subtract_d & (F_file_mode_t_block_group_d | F_file_mode_t_block_world_d) & (F_file_mode_t_mask_bit_read_d | F_file_mode_t_mask_bit_write_d),
    F_file_mode_t_mask_how_subtract_d & (F_file_mode_t_block_group_d | F_file_mode_t_block_world_d) & (F_file_mode_t_mask_bit_write_d | F_file_mode_t_mask_bit_execute_d),
    F_file_mode_t_mask_how_subtract_d & (F_file_mode_t_block_group_d | F_file_mode_t_block_world_d) & (F_file_mode_t_mask_bit_read_d | F_file_mode_t_mask_bit_execute_d),
    F_file_mode_t_mask_how_subtract_d & (F_file_mode_t_block_group_d | F_file_mode_t_block_world_d) & (F_file_mode_t_mask_bit_write_d | F_file_mode_t_mask_bit_execute_d),
    F_file_mode_t_mask_how_add_d & (F_file_mode_t_block_group_d | F_file_mode_t_block_world_d) & (F_file_mode_t_mask_bit_read_d | F_file_mode_t_mask_bit_write_d),
    F_file_mode_t_mask_how_add_d & (F_file_mode_t_block_group_d | F_file_mode_t_block_world_d) & (F_file_mode_t_mask_bit_read_d | F_file_mode_t_mask_bit_execute_d),
    F_file_mode_t_mask_how_add_d & (F_file_mode_t_block_group_d | F_file_mode_t_block_world_d) & (F_file_mode_t_mask_bit_read_d | F_file_mode_t_mask_bit_write_d),
    F_file_mode_t_mask_how_add_d & (F_file_mode_t_block_group_d | F_file_mode_t_block_world_d) & (F_file_mode_t_mask_bit_write_d | F_file_mode_t_mask_bit_execute_d),
    F_file_mode_t_mask_how_add_d & (F_file_mode_t_block_group_d | F_file_mode_t_block_world_d) & (F_file_mode_t_mask_bit_read_d | F_file_mode_t_mask_bit_execute_d),
    F_file_mode_t_mask_how_add_d & (F_file_mode_t_block_group_d | F_file_mode_t_block_world_d) & (F_file_mode_t_mask_bit_write_d | F_file_mode_t_mask_bit_execute_d),
    F_file_mode_t_mask_how_add_d & (F_file_mode_t_block_group_d | F_file_mode_t_block_world_d) & (F_file_mode_t_mask_bit_read_d | F_file_mode_t_mask_bit_write_d | F_file_mode_t_mask_bit_execute_d),
    F_file_mode_t_mask_how_add_d & (F_file_mode_t_block_group_d | F_file_mode_t_block_world_d) & (F_file_mode_t_mask_bit_read_d | F_file_mode_t_mask_bit_write_d | F_file_mode_t_mask_bit_execute_d),
    F_file_mode_t_mask_how_add_d & (F_file_mode_t_block_group_d | F_file_mode_t_block_world_d) & (F_file_mode_t_mask_bit_read_d | F_file_mode_t_mask_bit_write_d | F_file_mode_t_mask_bit_execute_d),
    F_file_mode_t_mask_how_add_d & (F_file_mode_t_block_group_d | F_file_mode_t_block_world_d) & (F_file_mode_t_mask_bit_read_d | F_file_mode_t_mask_bit_write_d | F_file_mode_t_mask_bit_execute_d),
    F_file_mode_t_mask_how_add_d & (F_file_mode_t_block_group_d | F_file_mode_t_block_world_d) & (F_file_mode_t_mask_bit_read_d | F_file_mode_t_mask_bit_write_d | F_file_mode_t_mask_bit_execute_d),
    F_file_mode_t_mask_how_add_d & (F_file_mode_t_block_group_d | F_file_mode_t_block_world_d) & (F_file_mode_t_mask_bit_read_d | F_file_mode_t_mask_bit_write_d | F_file_mode_t_mask_bit_execute_d),
    F_file_mode_t_mask_how_add_d & (F_file_mode_t_block_group_d | F_file_mode_t_block_world_d) & (F_file_mode_t_mask_bit_read_d | F_file_mode_t_mask_bit_write_d | F_file_mode_t_mask_bit_execute_d),
    F_file_mode_t_mask_how_subtract_d & (F_file_mode_t_block_group_d | F_file_mode_t_block_world_d) & (F_file_mode_t_mask_bit_read_d | F_file_mode_t_mask_bit_write_d | F_file_mode_t_mask_bit_execute_d),
    F_file_mode_t_mask_how_subtract_d & (F_file_mode_t_block_group_d | F_file_mode_t_block_world_d) & (F_file_mode_t_mask_bit_read_d | F_file_mode_t_mask_bit_write_d | F_file_mode_t_mask_bit_execute_d),
    F_file_mode_t_mask_how_subtract_d & (F_file_mode_t_block_group_d | F_file_mode_t_block_world_d) & (F_file_mode_t_mask_bit_read_d | F_file_mode_t_mask_bit_write_d | F_file_mode_t_mask_bit_execute_d),
    F_file_mode_t_mask_how_subtract_d & (F_file_mode_t_block_group_d | F_file_mode_t_block_world_d) & (F_file_mode_t_mask_bit_read_d | F_file_mode_t_mask_bit_write_d | F_file_mode_t_mask_bit_execute_d),
    F_file_mode_t_mask_how_subtract_d & (F_file_mode_t_block_group_d | F_file_mode_t_block_world_d) & (F_file_mode_t_mask_bit_read_d | F_file_mode_t_mask_bit_write_d | F_file_mode_t_mask_bit_execute_d),
    F_file_mode_t_mask_how_subtract_d & (F_file_mode_t_block_group_d | F_file_mode_t_block_world_d) & (F_file_mode_t_mask_bit_read_d | F_file_mode_t_mask_bit_write_d | F_file_mode_t_mask_bit_execute_d),
    F_file_mode_t_mask_how_subtract_d & (F_file_mode_t_block_group_d | F_file_mode_t_block_world_d) & (F_file_mode_t_mask_bit_read_d | F_file_mode_t_mask_bit_write_d | F_file_mode_t_mask_bit_execute_d),
    F_file_mode_t_mask_how_add_d & (F_file_mode_t_block_group_d | F_file_mode_t_block_world_d) & (F_file_mode_t_mask_bit_read_d | F_file_mode_t_mask_bit_write_d | F_file_mode_t_mask_bit_execute_d),
    F_file_mode_t_mask_how_add_d & (F_file_mode_t_block_group_d | F_file_mode_t_block_world_d) & (F_file_mode_t_mask_bit_read_d | F_file_mode_t_mask_bit_write_d | F_file_mode_t_mask_bit_execute_d),
    F_file_mode_t_mask_how_add_d & (F_file_mode_t_block_group_d | F_file_mode_t_block_world_d) & (F_file_mode_t_mask_bit_read_d | F_file_mode_t_mask_bit_write_d | F_file_mode_t_mask_bit_execute_d),
    F_file_mode_t_mask_how_add_d & (F_file_mode_t_block_group_d | F_file_mode_t_block_world_d) & (F_file_mode_t_mask_bit_read_d | F_file_mode_t_mask_bit_write_d | F_file_mode_t_mask_bit_execute_d),
    F_file_mode_t_mask_how_add_d & (F_file_mode_t_block_group_d | F_file_mode_t_block_world_d) & (F_file_mode_t_mask_bit_read_d | F_file_mode_t_mask_bit_write_d | F_file_mode_t_mask_bit_execute_d),
    F_file_mode_t_mask_how_add_d & (F_file_mode_t_block_group_d | F_file_mode_t_block_world_d) & (F_file_mode_t_mask_bit_read_d | F_file_mode_t_mask_bit_write_d | F_file_mode_t_mask_bit_execute_d),
    F_file_mode_t_mask_how_add_d & (F_file_mode_t_block_group_d | F_file_mode_t_block_world_d) & (F_file_mode_t_mask_bit_read_d | F_file_mode_t_mask_bit_write_d | F_file_mode_t_mask_bit_execute_d),
    F_file_mode_t_mask_how_add_d & (F_file_mode_t_block_owner_d | F_file_mode_t_block_world_d) & (F_file_mode_t_mask_bit_read_d | F_file_mode_t_mask_bit_write_d),
    F_file_mode_t_mask_how_add_d & (F_file_mode_t_block_owner_d | F_file_mode_t_block_world_d) & (F_file_mode_t_mask_bit_read_d | F_file_mode_t_mask_bit_execute_d),
    F_file_mode_t_mask_how_add_d & (F_file_mode_t_block_owner_d | F_file_mode_t_block_world_d) & (F_file_mode_t_mask_bit_read_d | F_file_mode_t_mask_bit_write_d),
    F_file_mode_t_mask_how_add_d & (F_file_mode_t_block_owner_d | F_file_mode_t_block_world_d) & (F_file_mode_t_mask_bit_write_d | F_file_mode_t_mask_bit_execute_d),
    F_file_mode_t_mask_how_add_d & (F_file_mode_t_block_owner_d | F_file_mode_t_block_world_d) & (F_file_mode_t_mask_bit_read_d | F_file_mode_t_mask_bit_execute_d),
    F_file_mode_t_mask_how_add_d & (F_file_mode_t_block_owner_d | F_file_mode_t_block_world_d) & (F_file_mode_t_mask_bit_write_d | F_file_mode_t_mask_bit_execute_d),
    F_file_mode_t_mask_how_subtract_d & (F_file_mode_t_block_owner_d | F_file_mode_t_block_world_d) & (F_file_mode_t_mask_bit_read_d | F_file_mode_t_mask_bit_write_d),
    F_file_mode_t_mask_how_subtract_d & (F_file_mode_t_block_owner_d | F_file_mode_t_block_world_d) & (F_file_mode_t_mask_bit_read_d | F_file_mode_t_mask_bit_execute_d),
    F_file_mode_t_mask_how_subtract_d & (F_file_mode_t_block_owner_d | F_file_mode_t_block_world_d) & (F_file_mode_t_mask_bit_read_d | F_file_mode_t_mask_bit_write_d),
    F_file_mode_t_mask_how_subtract_d & (F_file_mode_t_block_owner_d | F_file_mode_t_block_world_d) & (F_file_mode_t_mask_bit_write_d | F_file_mode_t_mask_bit_execute_d),
    F_file_mode_t_mask_how_subtract_d & (F_file_mode_t_block_owner_d | F_file_mode_t_block_world_d) & (F_file_mode_t_mask_bit_read_d | F_file_mode_t_mask_bit_execute_d),
    F_file_mode_t_mask_how_subtract_d & (F_file_mode_t_block_owner_d | F_file_mode_t_block_world_d) & (F_file_mode_t_mask_bit_write_d | F_file_mode_t_mask_bit_execute_d),
    F_file_mode_t_mask_how_add_d & (F_file_mode_t_block_owner_d | F_file_mode_t_block_world_d) & (F_file_mode_t_mask_bit_read_d | F_file_mode_t_mask_bit_write_d),
    F_file_mode_t_mask_how_add_d & (F_file_mode_t_block_owner_d | F_file_mode_t_block_world_d) & (F_file_mode_t_mask_bit_read_d | F_file_mode_t_mask_bit_execute_d),
    F_file_mode_t_mask_how_add_d & (F_file_mode_t_block_owner_d | F_file_mode_t_block_world_d) & (F_file_mode_t_mask_bit_read_d | F_file_mode_t_mask_bit_write_d),
    F_file_mode_t_mask_how_add_d & (F_file_mode_t_block_owner_d | F_file_mode_t_block_world_d) & (F_file_mode_t_mask_bit_write_d | F_file_mode_t_mask_bit_execute_d),
    F_file_mode_t_mask_how_add_d & (F_file_mode_t_block_owner_d | F_file_mode_t_block_world_d) & (F_file_mode_t_mask_bit_read_d | F_file_mode_t_mask_bit_execute_d),
    F_file_mode_t_mask_how_add_d & (F_file_mode_t_block_owner_d | F_file_mode_t_block_world_d) & (F_file_mode_t_mask_bit_write_d | F_file_mode_t_mask_bit_execute_d),
    F_file_mode_t_mask_how_add_d & (F_file_mode_t_block_owner_d | F_file_mode_t_block_world_d) & (F_file_mode_t_mask_bit_read_d | F_file_mode_t_mask_bit_write_d | F_file_mode_t_mask_bit_execute_d),
    F_file_mode_t_mask_how_add_d & (F_file_mode_t_block_owner_d | F_file_mode_t_block_world_d) & (F_file_mode_t_mask_bit_read_d | F_file_mode_t_mask_bit_write_d | F_file_mode_t_mask_bit_execute_d),
    F_file_mode_t_mask_how_add_d & (F_file_mode_t_block_owner_d | F_file_mode_t_block_world_d) & (F_file_mode_t_mask_bit_read_d | F_file_mode_t_mask_bit_write_d | F_file_mode_t_mask_bit_execute_d),
    F_file_mode_t_mask_how_add_d & (F_file_mode_t_block_owner_d | F_file_mode_t_block_world_d) & (F_file_mode_t_mask_bit_read_d | F_file_mode_t_mask_bit_write_d | F_file_mode_t_mask_bit_execute_d),
    F_file_mode_t_mask_how_add_d & (F_file_mode_t_block_owner_d | F_file_mode_t_block_world_d) & (F_file_mode_t_mask_bit_read_d | F_file_mode_t_mask_bit_write_d | F_file_mode_t_mask_bit_execute_d),
    F_file_mode_t_mask_how_add_d & (F_file_mode_t_block_owner_d | F_file_mode_t_block_world_d) & (F_file_mode_t_mask_bit_read_d | F_file_mode_t_mask_bit_write_d | F_file_mode_t_mask_bit_execute_d),
    F_file_mode_t_mask_how_add_d & (F_file_mode_t_block_owner_d | F_file_mode_t_block_world_d) & (F_file_mode_t_mask_bit_read_d | F_file_mode_t_mask_bit_write_d | F_file_mode_t_mask_bit_execute_d),
    F_file_mode_t_mask_how_subtract_d & (F_file_mode_t_block_owner_d | F_file_mode_t_block_world_d) & (F_file_mode_t_mask_bit_read_d | F_file_mode_t_mask_bit_write_d | F_file_mode_t_mask_bit_execute_d),
    F_file_mode_t_mask_how_subtract_d & (F_file_mode_t_block_owner_d | F_file_mode_t_block_world_d) & (F_file_mode_t_mask_bit_read_d | F_file_mode_t_mask_bit_write_d | F_file_mode_t_mask_bit_execute_d),
    F_file_mode_t_mask_how_subtract_d & (F_file_mode_t_block_owner_d | F_file_mode_t_block_world_d) & (F_file_mode_t_mask_bit_read_d | F_file_mode_t_mask_bit_write_d | F_file_mode_t_mask_bit_execute_d),
    F_file_mode_t_mask_how_subtract_d & (F_file_mode_t_block_owner_d | F_file_mode_t_block_world_d) & (F_file_mode_t_mask_bit_read_d | F_file_mode_t_mask_bit_write_d | F_file_mode_t_mask_bit_execute_d),
    F_file_mode_t_mask_how_subtract_d & (F_file_mode_t_block_owner_d | F_file_mode_t_block_world_d) & (F_file_mode_t_mask_bit_read_d | F_file_mode_t_mask_bit_write_d | F_file_mode_t_mask_bit_execute_d),
    F_file_mode_t_mask_how_subtract_d & (F_file_mode_t_block_owner_d | F_file_mode_t_block_world_d) & (F_file_mode_t_mask_bit_read_d | F_file_mode_t_mask_bit_write_d | F_file_mode_t_mask_bit_execute_d),
    F_file_mode_t_mask_how_subtract_d & (F_file_mode_t_block_owner_d | F_file_mode_t_block_world_d) & (F_file_mode_t_mask_bit_read_d | F_file_mode_t_mask_bit_write_d | F_file_mode_t_mask_bit_execute_d),
    F_file_mode_t_mask_how_add_d & (F_file_mode_t_block_owner_d | F_file_mode_t_block_world_d) & (F_file_mode_t_mask_bit_read_d | F_file_mode_t_mask_bit_write_d | F_file_mode_t_mask_bit_execute_d),
    F_file_mode_t_mask_how_add_d & (F_file_mode_t_block_owner_d | F_file_mode_t_block_world_d) & (F_file_mode_t_mask_bit_read_d | F_file_mode_t_mask_bit_write_d | F_file_mode_t_mask_bit_execute_d),
    F_file_mode_t_mask_how_add_d & (F_file_mode_t_block_owner_d | F_file_mode_t_block_world_d) & (F_file_mode_t_mask_bit_read_d | F_file_mode_t_mask_bit_write_d | F_file_mode_t_mask_bit_execute_d),
    F_file_mode_t_mask_how_add_d & (F_file_mode_t_block_owner_d | F_file_mode_t_block_world_d) & (F_file_mode_t_mask_bit_read_d | F_file_mode_t_mask_bit_write_d | F_file_mode_t_mask_bit_execute_d),
    F_file_mode_t_mask_how_add_d & (F_file_mode_t_block_owner_d | F_file_mode_t_block_world_d) & (F_file_mode_t_mask_bit_read_d | F_file_mode_t_mask_bit_write_d | F_file_mode_t_mask_bit_execute_d),
    F_file_mode_t_mask_how_add_d & (F_file_mode_t_block_owner_d | F_file_mode_t_block_world_d) & (F_file_mode_t_mask_bit_read_d | F_file_mode_t_mask_bit_write_d | F_file_mode_t_mask_bit_execute_d),
    F_file_mode_t_mask_how_add_d & (F_file_mode_t_block_owner_d | F_file_mode_t_block_world_d) & (F_file_mode_t_mask_bit_read_d | F_file_mode_t_mask_bit_write_d | F_file_mode_t_mask_bit_execute_d),
    F_file_mode_t_mask_how_add_d & (F_file_mode_t_block_group_d | F_file_mode_t_block_world_d) & (F_file_mode_t_mask_bit_read_d | F_file_mode_t_mask_bit_write_d),
    F_file_mode_t_mask_how_add_d & (F_file_mode_t_block_group_d | F_file_mode_t_block_world_d) & (F_file_mode_t_mask_bit_read_d | F_file_mode_t_mask_bit_execute_d),
    F_file_mode_t_mask_how_add_d & (F_file_mode_t_block_group_d | F_file_mode_t_block_world_d) & (F_file_mode_t_mask_bit_read_d | F_file_mode_t_mask_bit_write_d),
    F_file_mode_t_mask_how_add_d & (F_file_mode_t_block_group_d | F_file_mode_t_block_world_d) & (F_file_mode_t_mask_bit_write_d | F_file_mode_t_mask_bit_execute_d),
    F_file_mode_t_mask_how_add_d & (F_file_mode_t_block_group_d | F_file_mode_t_block_world_d) & (F_file_mode_t_mask_bit_read_d | F_file_mode_t_mask_bit_execute_d),
    F_file_mode_t_mask_how_add_d & (F_file_mode_t_block_group_d | F_file_mode_t_block_world_d) & (F_file_mode_t_mask_bit_write_d | F_file_mode_t_mask_bit_execute_d),
    F_file_mode_t_mask_how_subtract_d & (F_file_mode_t_block_group_d | F_file_mode_t_block_world_d) & (F_file_mode_t_mask_bit_read_d | F_file_mode_t_mask_bit_write_d),
    F_file_mode_t_mask_how_subtract_d & (F_file_mode_t_block_group_d | F_file_mode_t_block_world_d) & (F_file_mode_t_mask_bit_read_d | F_file_mode_t_mask_bit_execute_d),
    F_file_mode_t_mask_how_subtract_d & (F_file_mode_t_block_group_d | F_file_mode_t_block_world_d) & (F_file_mode_t_mask_bit_read_d | F_file_mode_t_mask_bit_write_d),
    F_file_mode_t_mask_how_subtract_d & (F_file_mode_t_block_group_d | F_file_mode_t_block_world_d) & (F_file_mode_t_mask_bit_write_d | F_file_mode_t_mask_bit_execute_d),
    F_file_mode_t_mask_how_subtract_d & (F_file_mode_t_block_group_d | F_file_mode_t_block_world_d) & (F_file_mode_t_mask_bit_read_d | F_file_mode_t_mask_bit_execute_d),
    F_file_mode_t_mask_how_subtract_d & (F_file_mode_t_block_group_d | F_file_mode_t_block_world_d) & (F_file_mode_t_mask_bit_write_d | F_file_mode_t_mask_bit_execute_d),
    F_file_mode_t_mask_how_add_d & (F_file_mode_t_block_group_d | F_file_mode_t_block_world_d) & (F_file_mode_t_mask_bit_read_d | F_file_mode_t_mask_bit_write_d),
    F_file_mode_t_mask_how_add_d & (F_file_mode_t_block_group_d | F_file_mode_t_block_world_d) & (F_file_mode_t_mask_bit_read_d | F_file_mode_t_mask_bit_execute_d),
    F_file_mode_t_mask_how_add_d & (F_file_mode_t_block_group_d | F_file_mode_t_block_world_d) & (F_file_mode_t_mask_bit_read_d | F_file_mode_t_mask_bit_write_d),
    F_file_mode_t_mask_how_add_d & (F_file_mode_t_block_group_d | F_file_mode_t_block_world_d) & (F_file_mode_t_mask_bit_write_d | F_file_mode_t_mask_bit_execute_d),
    F_file_mode_t_mask_how_add_d & (F_file_mode_t_block_group_d | F_file_mode_t_block_world_d) & (F_file_mode_t_mask_bit_read_d | F_file_mode_t_mask_bit_execute_d),
    F_file_mode_t_mask_how_add_d & (F_file_mode_t_block_group_d | F_file_mode_t_block_world_d) & (F_file_mode_t_mask_bit_write_d | F_file_mode_t_mask_bit_execute_d),
    F_file_mode_t_mask_how_add_d & (F_file_mode_t_block_group_d | F_file_mode_t_block_world_d) & (F_file_mode_t_mask_bit_read_d | F_file_mode_t_mask_bit_write_d | F_file_mode_t_mask_bit_execute_d),
    F_file_mode_t_mask_how_add_d & (F_file_mode_t_block_group_d | F_file_mode_t_block_world_d) & (F_file_mode_t_mask_bit_read_d | F_file_mode_t_mask_bit_write_d | F_file_mode_t_mask_bit_execute_d),
    F_file_mode_t_mask_how_add_d & (F_file_mode_t_block_group_d | F_file_mode_t_block_world_d) & (F_file_mode_t_mask_bit_read_d | F_file_mode_t_mask_bit_write_d | F_file_mode_t_mask_bit_execute_d),
    F_file_mode_t_mask_how_add_d & (F_file_mode_t_block_group_d | F_file_mode_t_block_world_d) & (F_file_mode_t_mask_bit_read_d | F_file_mode_t_mask_bit_write_d | F_file_mode_t_mask_bit_execute_d),
    F_file_mode_t_mask_how_add_d & (F_file_mode_t_block_group_d | F_file_mode_t_block_world_d) & (F_file_mode_t_mask_bit_read_d | F_file_mode_t_mask_bit_write_d | F_file_mode_t_mask_bit_execute_d),
    F_file_mode_t_mask_how_add_d & (F_file_mode_t_block_group_d | F_file_mode_t_block_world_d) & (F_file_mode_t_mask_bit_read_d | F_file_mode_t_mask_bit_write_d | F_file_mode_t_mask_bit_execute_d),
    F_file_mode_t_mask_how_add_d & (F_file_mode_t_block_group_d | F_file_mode_t_block_world_d) & (F_file_mode_t_mask_bit_read_d | F_file_mode_t_mask_bit_write_d | F_file_mode_t_mask_bit_execute_d),
    F_file_mode_t_mask_how_subtract_d & (F_file_mode_t_block_group_d | F_file_mode_t_block_world_d) & (F_file_mode_t_mask_bit_read_d | F_file_mode_t_mask_bit_write_d | F_file_mode_t_mask_bit_execute_d),
    F_file_mode_t_mask_how_subtract_d & (F_file_mode_t_block_group_d | F_file_mode_t_block_world_d) & (F_file_mode_t_mask_bit_read_d | F_file_mode_t_mask_bit_write_d | F_file_mode_t_mask_bit_execute_d),
    F_file_mode_t_mask_how_subtract_d & (F_file_mode_t_block_group_d | F_file_mode_t_block_world_d) & (F_file_mode_t_mask_bit_read_d | F_file_mode_t_mask_bit_write_d | F_file_mode_t_mask_bit_execute_d),
    F_file_mode_t_mask_how_subtract_d & (F_file_mode_t_block_group_d | F_file_mode_t_block_world_d) & (F_file_mode_t_mask_bit_read_d | F_file_mode_t_mask_bit_write_d | F_file_mode_t_mask_bit_execute_d),
    F_file_mode_t_mask_how_subtract_d & (F_file_mode_t_block_group_d | F_file_mode_t_block_world_d) & (F_file_mode_t_mask_bit_read_d | F_file_mode_t_mask_bit_write_d | F_file_mode_t_mask_bit_execute_d),
    F_file_mode_t_mask_how_subtract_d & (F_file_mode_t_block_group_d | F_file_mode_t_block_world_d) & (F_file_mode_t_mask_bit_read_d | F_file_mode_t_mask_bit_write_d | F_file_mode_t_mask_bit_execute_d),
    F_file_mode_t_mask_how_subtract_d & (F_file_mode_t_block_group_d | F_file_mode_t_block_world_d) & (F_file_mode_t_mask_bit_read_d | F_file_mode_t_mask_bit_write_d | F_file_mode_t_mask_bit_execute_d),
    F_file_mode_t_mask_how_add_d & (F_file_mode_t_block_group_d | F_file_mode_t_block_world_d) & (F_file_mode_t_mask_bit_read_d | F_file_mode_t_mask_bit_write_d | F_file_mode_t_mask_bit_execute_d),
    F_file_mode_t_mask_how_add_d & (F_file_mode_t_block_group_d | F_file_mode_t_block_world_d) & (F_file_mode_t_mask_bit_read_d | F_file_mode_t_mask_bit_write_d | F_file_mode_t_mask_bit_execute_d),
    F_file_mode_t_mask_how_add_d & (F_file_mode_t_block_group_d | F_file_mode_t_block_world_d) & (F_file_mode_t_mask_bit_read_d | F_file_mode_t_mask_bit_write_d | F_file_mode_t_mask_bit_execute_d),
    F_file_mode_t_mask_how_add_d & (F_file_mode_t_block_group_d | F_file_mode_t_block_world_d) & (F_file_mode_t_mask_bit_read_d | F_file_mode_t_mask_bit_write_d | F_file_mode_t_mask_bit_execute_d),
    F_file_mode_t_mask_how_add_d & (F_file_mode_t_block_group_d | F_file_mode_t_block_world_d) & (F_file_mode_t_mask_bit_read_d | F_file_mode_t_mask_bit_write_d | F_file_mode_t_mask_bit_execute_d),
    F_file_mode_t_mask_how_add_d & (F_file_mode_t_block_group_d | F_file_mode_t_block_world_d) & (F_file_mode_t_mask_bit_read_d | F_file_mode_t_mask_bit_write_d | F_file_mode_t_mask_bit_execute_d),
    F_file_mode_t_mask_how_add_d & (F_file_mode_t_block_group_d | F_file_mode_t_block_world_d) & (F_file_mode_t_mask_bit_read_d | F_file_mode_t_mask_bit_write_d | F_file_mode_t_mask_bit_execute_d),
    F_file_mode_t_mask_how_add_d & F_file_mode_t_block_standard_d & (F_file_mode_t_mask_bit_read_d | F_file_mode_t_mask_bit_write_d),
    F_file_mode_t_mask_how_add_d & F_file_mode_t_block_standard_d & (F_file_mode_t_mask_bit_read_d | F_file_mode_t_mask_bit_execute_d),
    F_file_mode_t_mask_how_add_d & F_file_mode_t_block_standard_d & (F_file_mode_t_mask_bit_read_d | F_file_mode_t_mask_bit_write_d),
    F_file_mode_t_mask_how_add_d & F_file_mode_t_block_standard_d & (F_file_mode_t_mask_bit_write_d | F_file_mode_t_mask_bit_execute_d),
    F_file_mode_t_mask_how_add_d & F_file_mode_t_block_standard_d & (F_file_mode_t_mask_bit_read_d | F_file_mode_t_mask_bit_execute_d),
    F_file_mode_t_mask_how_add_d & F_file_mode_t_block_standard_d & (F_file_mode_t_mask_bit_write_d | F_file_mode_t_mask_bit_execute_d),
    F_file_mode_t_mask_how_subtract_d & F_file_mode_t_block_standard_d & (F_file_mode_t_mask_bit_read_d | F_file_mode_t_mask_bit_write_d),
    F_file_mode_t_mask_how_subtract_d & F_file_mode_t_block_standard_d & (F_file_mode_t_mask_bit_read_d | F_file_mode_t_mask_bit_execute_d),
    F_file_mode_t_mask_how_subtract_d & F_file_mode_t_block_standard_d & (F_file_mode_t_mask_bit_read_d | F_file_mode_t_mask_bit_write_d),
    F_file_mode_t_mask_how_subtract_d & F_file_mode_t_block_standard_d & (F_file_mode_t_mask_bit_write_d | F_file_mode_t_mask_bit_execute_d),
    F_file_mode_t_mask_how_subtract_d & F_file_mode_t_block_standard_d & (F_file_mode_t_mask_bit_read_d | F_file_mode_t_mask_bit_execute_d),
    F_file_mode_t_mask_how_subtract_d & F_file_mode_t_block_standard_d & (F_file_mode_t_mask_bit_write_d | F_file_mode_t_mask_bit_execute_d),
    F_file_mode_t_mask_how_add_d & F_file_mode_t_block_standard_d & (F_file_mode_t_mask_bit_read_d | F_file_mode_t_mask_bit_write_d),
    F_file_mode_t_mask_how_add_d & F_file_mode_t_block_standard_d & (F_file_mode_t_mask_bit_read_d | F_file_mode_t_mask_bit_execute_d),
    F_file_mode_t_mask_how_add_d & F_file_mode_t_block_standard_d & (F_file_mode_t_mask_bit_read_d | F_file_mode_t_mask_bit_write_d),
    F_file_mode_t_mask_how_add_d & F_file_mode_t_block_standard_d & (F_file_mode_t_mask_bit_write_d | F_file_mode_t_mask_bit_execute_d),
    F_file_mode_t_mask_how_add_d & F_file_mode_t_block_standard_d & (F_file_mode_t_mask_bit_read_d | F_file_mode_t_mask_bit_execute_d),
    F_file_mode_t_mask_how_add_d & F_file_mode_t_block_standard_d & (F_file_mode_t_mask_bit_write_d | F_file_mode_t_mask_bit_execute_d),
    F_file_mode_t_mask_how_add_d & F_file_mode_t_block_standard_d & (F_file_mode_t_mask_bit_read_d | F_file_mode_t_mask_bit_write_d | F_file_mode_t_mask_bit_execute_d),
    F_file_mode_t_mask_how_add_d & F_file_mode_t_block_standard_d & (F_file_mode_t_mask_bit_read_d | F_file_mode_t_mask_bit_write_d | F_file_mode_t_mask_bit_execute_d),
    F_file_mode_t_mask_how_add_d & F_file_mode_t_block_standard_d & (F_file_mode_t_mask_bit_read_d | F_file_mode_t_mask_bit_write_d | F_file_mode_t_mask_bit_execute_d),
    F_file_mode_t_mask_how_add_d & F_file_mode_t_block_standard_d & (F_file_mode_t_mask_bit_read_d | F_file_mode_t_mask_bit_write_d | F_file_mode_t_mask_bit_execute_d),
    F_file_mode_t_mask_how_add_d & F_file_mode_t_block_standard_d & (F_file_mode_t_mask_bit_read_d | F_file_mode_t_mask_bit_write_d | F_file_mode_t_mask_bit_execute_d),
    F_file_mode_t_mask_how_add_d & F_file_mode_t_block_standard_d & (F_file_mode_t_mask_bit_read_d | F_file_mode_t_mask_bit_write_d | F_file_mode_t_mask_bit_execute_d),
    F_file_mode_t_mask_how_add_d & F_file_mode_t_block_standard_d & (F_file_mode_t_mask_bit_read_d | F_file_mode_t_mask_bit_write_d | F_file_mode_t_mask_bit_execute_d),
    F_file_mode_t_mask_how_subtract_d & F_file_mode_t_block_standard_d & (F_file_mode_t_mask_bit_read_d | F_file_mode_t_mask_bit_write_d | F_file_mode_t_mask_bit_execute_d),
    F_file_mode_t_mask_how_subtract_d & F_file_mode_t_block_standard_d & (F_file_mode_t_mask_bit_read_d | F_file_mode_t_mask_bit_write_d | F_file_mode_t_mask_bit_execute_d),
    F_file_mode_t_mask_how_subtract_d & F_file_mode_t_block_standard_d & (F_file_mode_t_mask_bit_read_d | F_file_mode_t_mask_bit_write_d | F_file_mode_t_mask_bit_execute_d),
    F_file_mode_t_mask_how_subtract_d & F_file_mode_t_block_standard_d & (F_file_mode_t_mask_bit_read_d | F_file_mode_t_mask_bit_write_d | F_file_mode_t_mask_bit_execute_d),
    F_file_mode_t_mask_how_subtract_d & F_file_mode_t_block_standard_d & (F_file_mode_t_mask_bit_read_d | F_file_mode_t_mask_bit_write_d | F_file_mode_t_mask_bit_execute_d),
    F_file_mode_t_mask_how_subtract_d & F_file_mode_t_block_standard_d & (F_file_mode_t_mask_bit_read_d | F_file_mode_t_mask_bit_write_d | F_file_mode_t_mask_bit_execute_d),
    F_file_mode_t_mask_how_subtract_d & F_file_mode_t_block_standard_d & (F_file_mode_t_mask_bit_read_d | F_file_mode_t_mask_bit_write_d | F_file_mode_t_mask_bit_execute_d),
    F_file_mode_t_mask_how_add_d & F_file_mode_t_block_standard_d & (F_file_mode_t_mask_bit_read_d | F_file_mode_t_mask_bit_write_d | F_file_mode_t_mask_bit_execute_d),
    F_file_mode_t_mask_how_add_d & F_file_mode_t_block_standard_d & (F_file_mode_t_mask_bit_read_d | F_file_mode_t_mask_bit_write_d | F_file_mode_t_mask_bit_execute_d),
    F_file_mode_t_mask_how_add_d & F_file_mode_t_block_standard_d & (F_file_mode_t_mask_bit_read_d | F_file_mode_t_mask_bit_write_d | F_file_mode_t_mask_bit_execute_d),
    F_file_mode_t_mask_how_add_d & F_file_mode_t_block_standard_d & (F_file_mode_t_mask_bit_read_d | F_file_mode_t_mask_bit_write_d | F_file_mode_t_mask_bit_execute_d),
    F_file_mode_t_mask_how_add_d & F_file_mode_t_block_standard_d & (F_file_mode_t_mask_bit_read_d | F_file_mode_t_mask_bit_write_d | F_file_mode_t_mask_bit_execute_d),
    F_file_mode_t_mask_how_add_d & F_file_mode_t_block_standard_d & (F_file_mode_t_mask_bit_read_d | F_file_mode_t_mask_bit_write_d | F_file_mode_t_mask_bit_execute_d),
    F_file_mode_t_mask_how_add_d & F_file_mode_t_block_standard_d & (F_file_mode_t_mask_bit_read_d | F_file_mode_t_mask_bit_write_d | F_file_mode_t_mask_bit_execute_d),
    F_file_mode_t_mask_how_add_d & F_file_mode_t_block_standard_d & (F_file_mode_t_mask_bit_read_d | F_file_mode_t_mask_bit_write_d | F_file_mode_t_mask_bit_execute_d),
    F_file_mode_t_mask_how_add_d & F_file_mode_t_block_standard_d & (F_file_mode_t_mask_bit_read_d | F_file_mode_t_mask_bit_write_d | F_file_mode_t_mask_bit_execute_d),
    F_file_mode_t_mask_how_add_d & F_file_mode_t_block_standard_d & (F_file_mode_t_mask_bit_read_d | F_file_mode_t_mask_bit_write_d | F_file_mode_t_mask_bit_execute_d),
    F_file_mode_t_mask_how_add_d & F_file_mode_t_block_standard_d & (F_file_mode_t_mask_bit_read_d | F_file_mode_t_mask_bit_write_d | F_file_mode_t_mask_bit_execute_d),
    F_file_mode_t_mask_how_add_d & F_file_mode_t_block_standard_d & (F_file_mode_t_mask_bit_read_d | F_file_mode_t_mask_bit_write_d | F_file_mode_t_mask_bit_execute_d),
    F_file_mode_t_mask_how_add_d & F_file_mode_t_block_standard_d & (F_file_mode_t_mask_bit_read_d | F_file_mode_t_mask_bit_write_d | F_file_mode_t_mask_bit_execute_d),
    F_file_mode_t_mask_how_add_d & F_file_mode_t_block_standard_d & (F_file_mode_t_mask_bit_read_d | F_file_mode_t_mask_bit_write_d | F_file_mode_t_mask_bit_execute_d),
    F_file_mode_t_mask_how_subtract_d & F_file_mode_t_block_standard_d & (F_file_mode_t_mask_bit_read_d | F_file_mode_t_mask_bit_write_d | F_file_mode_t_mask_bit_execute_d),
    F_file_mode_t_mask_how_subtract_d & F_file_mode_t_block_standard_d & (F_file_mode_t_mask_bit_read_d | F_file_mode_t_mask_bit_write_d | F_file_mode_t_mask_bit_execute_d),
    F_file_mode_t_mask_how_subtract_d & F_file_mode_t_block_standard_d & (F_file_mode_t_mask_bit_read_d | F_file_mode_t_mask_bit_write_d | F_file_mode_t_mask_bit_execute_d),
    F_file_mode_t_mask_how_subtract_d & F_file_mode_t_block_standard_d & (F_file_mode_t_mask_bit_read_d | F_file_mode_t_mask_bit_write_d | F_file_mode_t_mask_bit_execute_d),
    F_file_mode_t_mask_how_subtract_d & F_file_mode_t_block_standard_d & (F_file_mode_t_mask_bit_read_d | F_file_mode_t_mask_bit_write_d | F_file_mode_t_mask_bit_execute_d),
    F_file_mode_t_mask_how_subtract_d & F_file_mode_t_block_standard_d & (F_file_mode_t_mask_bit_read_d | F_file_mode_t_mask_bit_write_d | F_file_mode_t_mask_bit_execute_d),
    F_file_mode_t_mask_how_subtract_d & F_file_mode_t_block_standard_d & (F_file_mode_t_mask_bit_read_d | F_file_mode_t_mask_bit_write_d | F_file_mode_t_mask_bit_execute_d),
    F_file_mode_t_mask_how_add_d & F_file_mode_t_block_standard_d & (F_file_mode_t_mask_bit_read_d | F_file_mode_t_mask_bit_write_d | F_file_mode_t_mask_bit_execute_d),
    F_file_mode_t_mask_how_add_d & F_file_mode_t_block_standard_d & (F_file_mode_t_mask_bit_read_d | F_file_mode_t_mask_bit_write_d | F_file_mode_t_mask_bit_execute_d),
    F_file_mode_t_mask_how_add_d & F_file_mode_t_block_standard_d & (F_file_mode_t_mask_bit_read_d | F_file_mode_t_mask_bit_write_d | F_file_mode_t_mask_bit_execute_d),
    F_file_mode_t_mask_how_add_d & F_file_mode_t_block_standard_d & (F_file_mode_t_mask_bit_read_d | F_file_mode_t_mask_bit_write_d | F_file_mode_t_mask_bit_execute_d),
    F_file_mode_t_mask_how_add_d & F_file_mode_t_block_standard_d & (F_file_mode_t_mask_bit_read_d | F_file_mode_t_mask_bit_write_d | F_file_mode_t_mask_bit_execute_d),
    F_file_mode_t_mask_how_add_d & F_file_mode_t_block_standard_d & (F_file_mode_t_mask_bit_read_d | F_file_mode_t_mask_bit_write_d | F_file_mode_t_mask_bit_execute_d),
    F_file_mode_t_mask_how_add_d & F_file_mode_t_block_standard_d & (F_file_mode_t_mask_bit_read_d | F_file_mode_t_mask_bit_write_d | F_file_mode_t_mask_bit_execute_d),
    F_file_mode_t_mask_how_add_d & F_file_mode_t_block_standard_d & (F_file_mode_t_mask_bit_read_d | F_file_mode_t_mask_bit_write_d | F_file_mode_t_mask_bit_execute_d),
    F_file_mode_t_mask_how_add_d & F_file_mode_t_block_standard_d & (F_file_mode_t_mask_bit_read_d | F_file_mode_t_mask_bit_write_d | F_file_mode_t_mask_bit_execute_d),
    F_file_mode_t_mask_how_add_d & F_file_mode_t_block_standard_d & (F_file_mode_t_mask_bit_read_d | F_file_mode_t_mask_bit_write_d | F_file_mode_t_mask_bit_execute_d),
    F_file_mode_t_mask_how_add_d & F_file_mode_t_block_standard_d & (F_file_mode_t_mask_bit_read_d | F_file_mode_t_mask_bit_write_d | F_file_mode_t_mask_bit_execute_d),
    F_file_mode_t_mask_how_add_d & F_file_mode_t_block_standard_d & (F_file_mode_t_mask_bit_read_d | F_file_mode_t_mask_bit_write_d | F_file_mode_t_mask_bit_execute_d),
    F_file_mode_t_mask_how_add_d & F_file_mode_t_block_standard_d & (F_file_mode_t_mask_bit_read_d | F_file_mode_t_mask_bit_write_d | F_file_mode_t_mask_bit_execute_d),
    F_file_mode_t_mask_how_add_d & F_file_mode_t_block_standard_d & (F_file_mode_t_mask_bit_read_d | F_file_mode_t_mask_bit_write_d | F_file_mode_t_mask_bit_execute_d),
    F_file_mode_t_mask_how_subtract_d & F_file_mode_t_block_standard_d & (F_file_mode_t_mask_bit_read_d | F_file_mode_t_mask_bit_write_d | F_file_mode_t_mask_bit_execute_d),
    F_file_mode_t_mask_how_subtract_d & F_file_mode_t_block_standard_d & (F_file_mode_t_mask_bit_read_d | F_file_mode_t_mask_bit_write_d | F_file_mode_t_mask_bit_execute_d),
    F_file_mode_t_mask_how_subtract_d & F_file_mode_t_block_standard_d & (F_file_mode_t_mask_bit_read_d | F_file_mode_t_mask_bit_write_d | F_file_mode_t_mask_bit_execute_d),
    F_file_mode_t_mask_how_subtract_d & F_file_mode_t_block_standard_d & (F_file_mode_t_mask_bit_read_d | F_file_mode_t_mask_bit_write_d | F_file_mode_t_mask_bit_execute_d),
    F_file_mode_t_mask_how_subtract_d & F_file_mode_t_block_standard_d & (F_file_mode_t_mask_bit_read_d | F_file_mode_t_mask_bit_write_d | F_file_mode_t_mask_bit_execute_d),
    F_file_mode_t_mask_how_subtract_d & F_file_mode_t_block_standard_d & (F_file_mode_t_mask_bit_read_d | F_file_mode_t_mask_bit_write_d | F_file_mode_t_mask_bit_execute_d),
    F_file_mode_t_mask_how_subtract_d & F_file_mode_t_block_standard_d & (F_file_mode_t_mask_bit_read_d | F_file_mode_t_mask_bit_write_d | F_file_mode_t_mask_bit_execute_d),
    F_file_mode_t_mask_how_add_d & F_file_mode_t_block_standard_d & (F_file_mode_t_mask_bit_read_d | F_file_mode_t_mask_bit_write_d | F_file_mode_t_mask_bit_execute_d),
    F_file_mode_t_mask_how_add_d & F_file_mode_t_block_standard_d & (F_file_mode_t_mask_bit_read_d | F_file_mode_t_mask_bit_write_d | F_file_mode_t_mask_bit_execute_d),
    F_file_mode_t_mask_how_add_d & F_file_mode_t_block_standard_d & (F_file_mode_t_mask_bit_read_d | F_file_mode_t_mask_bit_write_d | F_file_mode_t_mask_bit_execute_d),
    F_file_mode_t_mask_how_add_d & F_file_mode_t_block_standard_d & (F_file_mode_t_mask_bit_read_d | F_file_mode_t_mask_bit_write_d | F_file_mode_t_mask_bit_execute_d),
    F_file_mode_t_mask_how_add_d & F_file_mode_t_block_standard_d & (F_file_mode_t_mask_bit_read_d | F_file_mode_t_mask_bit_write_d | F_file_mode_t_mask_bit_execute_d),
    F_file_mode_t_mask_how_add_d & F_file_mode_t_block_standard_d & (F_file_mode_t_mask_bit_read_d | F_file_mode_t_mask_bit_write_d | F_file_mode_t_mask_bit_execute_d),
    F_file_mode_t_mask_how_add_d & F_file_mode_t_block_standard_d & (F_file_mode_t_mask_bit_read_d | F_file_mode_t_mask_bit_write_d | F_file_mode_t_mask_bit_execute_d),
    F_file_mode_t_mask_how_add_d & F_file_mode_t_block_standard_d & (F_file_mode_t_mask_bit_read_d | F_file_mode_t_mask_bit_write_d | F_file_mode_t_mask_bit_execute_d),
    F_file_mode_t_mask_how_add_d & F_file_mode_t_block_standard_d & (F_file_mode_t_mask_bit_read_d | F_file_mode_t_mask_bit_write_d | F_file_mode_t_mask_bit_execute_d),
    F_file_mode_t_mask_how_add_d & F_file_mode_t_block_standard_d & (F_file_mode_t_mask_bit_read_d | F_file_mode_t_mask_bit_write_d | F_file_mode_t_mask_bit_execute_d),
    F_file_mode_t_mask_how_add_d & F_file_mode_t_block_standard_d & (F_file_mode_t_mask_bit_read_d | F_file_mode_t_mask_bit_write_d | F_file_mode_t_mask_bit_execute_d),
    F_file_mode_t_mask_how_add_d & F_file_mode_t_block_standard_d & (F_file_mode_t_mask_bit_read_d | F_file_mode_t_mask_bit_write_d | F_file_mode_t_mask_bit_execute_d),
    F_file_mode_t_mask_how_add_d & F_file_mode_t_block_standard_d & (F_file_mode_t_mask_bit_read_d | F_file_mode_t_mask_bit_write_d | F_file_mode_t_mask_bit_execute_d),
    F_file_mode_t_mask_how_add_d & F_file_mode_t_block_standard_d & (F_file_mode_t_mask_bit_read_d | F_file_mode_t_mask_bit_write_d | F_file_mode_t_mask_bit_execute_d),
    F_file_mode_t_mask_how_subtract_d & F_file_mode_t_block_standard_d & (F_file_mode_t_mask_bit_read_d | F_file_mode_t_mask_bit_write_d | F_file_mode_t_mask_bit_execute_d),
    F_file_mode_t_mask_how_subtract_d & F_file_mode_t_block_standard_d & (F_file_mode_t_mask_bit_read_d | F_file_mode_t_mask_bit_write_d | F_file_mode_t_mask_bit_execute_d),
    F_file_mode_t_mask_how_subtract_d & F_file_mode_t_block_standard_d & (F_file_mode_t_mask_bit_read_d | F_file_mode_t_mask_bit_write_d | F_file_mode_t_mask_bit_execute_d),
    F_file_mode_t_mask_how_subtract_d & F_file_mode_t_block_standard_d & (F_file_mode_t_mask_bit_read_d | F_file_mode_t_mask_bit_write_d | F_file_mode_t_mask_bit_execute_d),
    F_file_mode_t_mask_how_subtract_d & F_file_mode_t_block_standard_d & (F_file_mode_t_mask_bit_read_d | F_file_mode_t_mask_bit_write_d | F_file_mode_t_mask_bit_execute_d),
    F_file_mode_t_mask_how_subtract_d & F_file_mode_t_block_standard_d & (F_file_mode_t_mask_bit_read_d | F_file_mode_t_mask_bit_write_d | F_file_mode_t_mask_bit_execute_d),
    F_file_mode_t_mask_how_subtract_d & F_file_mode_t_block_standard_d & (F_file_mode_t_mask_bit_read_d | F_file_mode_t_mask_bit_write_d | F_file_mode_t_mask_bit_execute_d),
    F_file_mode_t_mask_how_add_d & F_file_mode_t_block_standard_d & (F_file_mode_t_mask_bit_read_d | F_file_mode_t_mask_bit_write_d | F_file_mode_t_mask_bit_execute_d),
    F_file_mode_t_mask_how_add_d & F_file_mode_t_block_standard_d & (F_file_mode_t_mask_bit_read_d | F_file_mode_t_mask_bit_write_d | F_file_mode_t_mask_bit_execute_d),
    F_file_mode_t_mask_how_add_d & F_file_mode_t_block_standard_d & (F_file_mode_t_mask_bit_read_d | F_file_mode_t_mask_bit_write_d | F_file_mode_t_mask_bit_execute_d),
    F_file_mode_t_mask_how_add_d & F_file_mode_t_block_standard_d & (F_file_mode_t_mask_bit_read_d | F_file_mode_t_mask_bit_write_d | F_file_mode_t_mask_bit_execute_d),
    F_file_mode_t_mask_how_add_d & F_file_mode_t_block_standard_d & (F_file_mode_t_mask_bit_read_d | F_file_mode_t_mask_bit_write_d | F_file_mode_t_mask_bit_execute_d),
    F_file_mode_t_mask_how_add_d & F_file_mode_t_block_standard_d & (F_file_mode_t_mask_bit_read_d | F_file_mode_t_mask_bit_write_d | F_file_mode_t_mask_bit_execute_d),
    F_file_mode_t_mask_how_add_d & F_file_mode_t_block_standard_d & (F_file_mode_t_mask_bit_read_d | F_file_mode_t_mask_bit_write_d | F_file_mode_t_mask_bit_execute_d),
    F_file_mode_t_mask_how_add_d & F_file_mode_t_block_standard_d & (F_file_mode_t_mask_bit_read_d | F_file_mode_t_mask_bit_write_d | F_file_mode_t_mask_bit_execute_d),
    F_file_mode_t_mask_how_add_d & F_file_mode_t_block_standard_d & (F_file_mode_t_mask_bit_read_d | F_file_mode_t_mask_bit_write_d | F_file_mode_t_mask_bit_execute_d),
    F_file_mode_t_mask_how_add_d & F_file_mode_t_block_standard_d & (F_file_mode_t_mask_bit_read_d | F_file_mode_t_mask_bit_write_d | F_file_mode_t_mask_bit_execute_d),
    F_file_mode_t_mask_how_add_d & F_file_mode_t_block_standard_d & (F_file_mode_t_mask_bit_read_d | F_file_mode_t_mask_bit_write_d | F_file_mode_t_mask_bit_execute_d),
    F_file_mode_t_mask_how_add_d & F_file_mode_t_block_standard_d & (F_file_mode_t_mask_bit_read_d | F_file_mode_t_mask_bit_write_d | F_file_mode_t_mask_bit_execute_d),
    F_file_mode_t_mask_how_add_d & F_file_mode_t_block_standard_d & (F_file_mode_t_mask_bit_read_d | F_file_mode_t_mask_bit_write_d | F_file_mode_t_mask_bit_execute_d),
    F_file_mode_t_mask_how_add_d & F_file_mode_t_block_standard_d & (F_file_mode_t_mask_bit_read_d | F_file_mode_t_mask_bit_write_d | F_file_mode_t_mask_bit_execute_d),
    F_file_mode_t_mask_how_subtract_d & F_file_mode_t_block_standard_d & (F_file_mode_t_mask_bit_read_d | F_file_mode_t_mask_bit_write_d | F_file_mode_t_mask_bit_execute_d),
    F_file_mode_t_mask_how_subtract_d & F_file_mode_t_block_standard_d & (F_file_mode_t_mask_bit_read_d | F_file_mode_t_mask_bit_write_d | F_file_mode_t_mask_bit_execute_d),
    F_file_mode_t_mask_how_subtract_d & F_file_mode_t_block_standard_d & (F_file_mode_t_mask_bit_read_d | F_file_mode_t_mask_bit_write_d | F_file_mode_t_mask_bit_execute_d),
    F_file_mode_t_mask_how_subtract_d & F_file_mode_t_block_standard_d & (F_file_mode_t_mask_bit_read_d | F_file_mode_t_mask_bit_write_d | F_file_mode_t_mask_bit_execute_d),
    F_file_mode_t_mask_how_subtract_d & F_file_mode_t_block_standard_d & (F_file_mode_t_mask_bit_read_d | F_file_mode_t_mask_bit_write_d | F_file_mode_t_mask_bit_execute_d),
    F_file_mode_t_mask_how_subtract_d & F_file_mode_t_block_standard_d & (F_file_mode_t_mask_bit_read_d | F_file_mode_t_mask_bit_write_d | F_file_mode_t_mask_bit_execute_d),
    F_file_mode_t_mask_how_subtract_d & F_file_mode_t_block_standard_d & (F_file_mode_t_mask_bit_read_d | F_file_mode_t_mask_bit_write_d | F_file_mode_t_mask_bit_execute_d),
    F_file_mode_t_mask_how_add_d & F_file_mode_t_block_standard_d & (F_file_mode_t_mask_bit_read_d | F_file_mode_t_mask_bit_write_d | F_file_mode_t_mask_bit_execute_d),
    F_file_mode_t_mask_how_add_d & F_file_mode_t_block_standard_d & (F_file_mode_t_mask_bit_read_d | F_file_mode_t_mask_bit_write_d | F_file_mode_t_mask_bit_execute_d),
    F_file_mode_t_mask_how_add_d & F_file_mode_t_block_standard_d & (F_file_mode_t_mask_bit_read_d | F_file_mode_t_mask_bit_write_d | F_file_mode_t_mask_bit_execute_d),
    F_file_mode_t_mask_how_add_d & F_file_mode_t_block_standard_d & (F_file_mode_t_mask_bit_read_d | F_file_mode_t_mask_bit_write_d | F_file_mode_t_mask_bit_execute_d),
    F_file_mode_t_mask_how_add_d & F_file_mode_t_block_standard_d & (F_file_mode_t_mask_bit_read_d | F_file_mode_t_mask_bit_write_d | F_file_mode_t_mask_bit_execute_d),
    F_file_mode_t_mask_how_add_d & F_file_mode_t_block_standard_d & (F_file_mode_t_mask_bit_read_d | F_file_mode_t_mask_bit_write_d | F_file_mode_t_mask_bit_execute_d),
    F_file_mode_t_mask_how_add_d & F_file_mode_t_block_standard_d & (F_file_mode_t_mask_bit_read_d | F_file_mode_t_mask_bit_write_d | F_file_mode_t_mask_bit_execute_d),
    F_file_mode_t_mask_how_add_d & F_file_mode_t_block_standard_d & (F_file_mode_t_mask_bit_read_d | F_file_mode_t_mask_bit_write_d | F_file_mode_t_mask_bit_execute_d),
    F_file_mode_t_mask_how_add_d & F_file_mode_t_block_standard_d & (F_file_mode_t_mask_bit_read_d | F_file_mode_t_mask_bit_write_d | F_file_mode_t_mask_bit_execute_d),
    F_file_mode_t_mask_how_add_d & F_file_mode_t_block_standard_d & (F_file_mode_t_mask_bit_read_d | F_file_mode_t_mask_bit_write_d | F_file_mode_t_mask_bit_execute_d),
    F_file_mode_t_mask_how_add_d & F_file_mode_t_block_standard_d & (F_file_mode_t_mask_bit_read_d | F_file_mode_t_mask_bit_write_d | F_file_mode_t_mask_bit_execute_d),
    F_file_mode_t_mask_how_add_d & F_file_mode_t_block_standard_d & (F_file_mode_t_mask_bit_read_d | F_file_mode_t_mask_bit_write_d | F_file_mode_t_mask_bit_execute_d),
    F_file_mode_t_mask_how_add_d & F_file_mode_t_block_standard_d & (F_file_mode_t_mask_bit_read_d | F_file_mode_t_mask_bit_write_d | F_file_mode_t_mask_bit_execute_d),
    F_file_mode_t_mask_how_add_d & F_file_mode_t_block_standard_d & (F_file_mode_t_mask_bit_read_d | F_file_mode_t_mask_bit_write_d | F_file_mode_t_mask_bit_execute_d),
    F_file_mode_t_mask_how_subtract_d & F_file_mode_t_block_standard_d & (F_file_mode_t_mask_bit_read_d | F_file_mode_t_mask_bit_write_d | F_file_mode_t_mask_bit_execute_d),
    F_file_mode_t_mask_how_subtract_d & F_file_mode_t_block_standard_d & (F_file_mode_t_mask_bit_read_d | F_file_mode_t_mask_bit_write_d | F_file_mode_t_mask_bit_execute_d),
    F_file_mode_t_mask_how_subtract_d & F_file_mode_t_block_standard_d & (F_file_mode_t_mask_bit_read_d | F_file_mode_t_mask_bit_write_d | F_file_mode_t_mask_bit_execute_d),
    F_file_mode_t_mask_how_subtract_d & F_file_mode_t_block_standard_d & (F_file_mode_t_mask_bit_read_d | F_file_mode_t_mask_bit_write_d | F_file_mode_t_mask_bit_execute_d),
    F_file_mode_t_mask_how_subtract_d & F_file_mode_t_block_standard_d & (F_file_mode_t_mask_bit_read_d | F_file_mode_t_mask_bit_write_d | F_file_mode_t_mask_bit_execute_d),
    F_file_mode_t_mask_how_subtract_d & F_file_mode_t_block_standard_d & (F_file_mode_t_mask_bit_read_d | F_file_mode_t_mask_bit_write_d | F_file_mode_t_mask_bit_execute_d),
    F_file_mode_t_mask_how_subtract_d & F_file_mode_t_block_standard_d & (F_file_mode_t_mask_bit_read_d | F_file_mode_t_mask_bit_write_d | F_file_mode_t_mask_bit_execute_d),
    F_file_mode_t_mask_how_add_d & F_file_mode_t_block_standard_d & (F_file_mode_t_mask_bit_read_d | F_file_mode_t_mask_bit_write_d | F_file_mode_t_mask_bit_execute_d),
    F_file_mode_t_mask_how_add_d & F_file_mode_t_block_standard_d & (F_file_mode_t_mask_bit_read_d | F_file_mode_t_mask_bit_write_d | F_file_mode_t_mask_bit_execute_d),
    F_file_mode_t_mask_how_add_d & F_file_mode_t_block_standard_d & (F_file_mode_t_mask_bit_read_d | F_file_mode_t_mask_bit_write_d | F_file_mode_t_mask_bit_execute_d),
    F_file_mode_t_mask_how_add_d & F_file_mode_t_block_standard_d & (F_file_mode_t_mask_bit_read_d | F_file_mode_t_mask_bit_write_d | F_file_mode_t_mask_bit_execute_d),
    F_file_mode_t_mask_how_add_d & F_file_mode_t_block_standard_d & (F_file_mode_t_mask_bit_read_d | F_file_mode_t_mask_bit_write_d | F_file_mode_t_mask_bit_execute_d),
    F_file_mode_t_mask_how_add_d & F_file_mode_t_block_standard_d & (F_file_mode_t_mask_bit_read_d | F_file_mode_t_mask_bit_write_d | F_file_mode_t_mask_bit_execute_d),
    F_file_mode_t_mask_how_add_d & F_file_mode_t_block_standard_d & (F_file_mode_t_mask_bit_read_d | F_file_mode_t_mask_bit_write_d | F_file_mode_t_mask_bit_execute_d),
    F_file_mode_t_mask_how_add_d & F_file_mode_t_block_standard_d & (F_file_mode_t_mask_bit_read_d | F_file_mode_t_mask_bit_write_d | F_file_mode_t_mask_bit_execute_d),
    F_file_mode_t_mask_how_add_d & F_file_mode_t_block_standard_d & (F_file_mode_t_mask_bit_read_d | F_file_mode_t_mask_bit_write_d | F_file_mode_t_mask_bit_execute_d),
    F_file_mode_t_mask_how_add_d & F_file_mode_t_block_standard_d & (F_file_mode_t_mask_bit_read_d | F_file_mode_t_mask_bit_write_d | F_file_mode_t_mask_bit_execute_d),
    F_file_mode_t_mask_how_add_d & F_file_mode_t_block_standard_d & (F_file_mode_t_mask_bit_read_d | F_file_mode_t_mask_bit_write_d | F_file_mode_t_mask_bit_execute_d),
    F_file_mode_t_mask_how_add_d & F_file_mode_t_block_standard_d & (F_file_mode_t_mask_bit_read_d | F_file_mode_t_mask_bit_write_d | F_file_mode_t_mask_bit_execute_d),
    F_file_mode_t_mask_how_add_d & F_file_mode_t_block_standard_d & (F_file_mode_t_mask_bit_read_d | F_file_mode_t_mask_bit_write_d | F_file_mode_t_mask_bit_execute_d),
    F_file_mode_t_mask_how_add_d & F_file_mode_t_block_standard_d & (F_file_mode_t_mask_bit_read_d | F_file_mode_t_mask_bit_write_d | F_file_mode_t_mask_bit_execute_d),
    F_file_mode_t_mask_how_subtract_d & F_file_mode_t_block_standard_d & (F_file_mode_t_mask_bit_read_d | F_file_mode_t_mask_bit_write_d | F_file_mode_t_mask_bit_execute_d),
    F_file_mode_t_mask_how_subtract_d & F_file_mode_t_block_standard_d & (F_file_mode_t_mask_bit_read_d | F_file_mode_t_mask_bit_write_d | F_file_mode_t_mask_bit_execute_d),
    F_file_mode_t_mask_how_subtract_d & F_file_mode_t_block_standard_d & (F_file_mode_t_mask_bit_read_d | F_file_mode_t_mask_bit_write_d | F_file_mode_t_mask_bit_execute_d),
    F_file_mode_t_mask_how_subtract_d & F_file_mode_t_block_standard_d & (F_file_mode_t_mask_bit_read_d | F_file_mode_t_mask_bit_write_d | F_file_mode_t_mask_bit_execute_d),
    F_file_mode_t_mask_how_subtract_d & F_file_mode_t_block_standard_d & (F_file_mode_t_mask_bit_read_d | F_file_mode_t_mask_bit_write_d | F_file_mode_t_mask_bit_execute_d),
    F_file_mode_t_mask_how_subtract_d & F_file_mode_t_block_standard_d & (F_file_mode_t_mask_bit_read_d | F_file_mode_t_mask_bit_write_d | F_file_mode_t_mask_bit_execute_d),
    F_file_mode_t_mask_how_subtract_d & F_file_mode_t_block_standard_d & (F_file_mode_t_mask_bit_read_d | F_file_mode_t_mask_bit_write_d | F_file_mode_t_mask_bit_execute_d),
    F_file_mode_t_mask_how_add_d & F_file_mode_t_block_standard_d & (F_file_mode_t_mask_bit_read_d | F_file_mode_t_mask_bit_write_d | F_file_mode_t_mask_bit_execute_d),
    F_file_mode_t_mask_how_add_d & F_file_mode_t_block_standard_d & (F_file_mode_t_mask_bit_read_d | F_file_mode_t_mask_bit_write_d | F_file_mode_t_mask_bit_execute_d),
    F_file_mode_t_mask_how_add_d & F_file_mode_t_block_standard_d & (F_file_mode_t_mask_bit_read_d | F_file_mode_t_mask_bit_write_d | F_file_mode_t_mask_bit_execute_d),
    F_file_mode_t_mask_how_add_d & F_file_mode_t_block_standard_d & (F_file_mode_t_mask_bit_read_d | F_file_mode_t_mask_bit_write_d | F_file_mode_t_mask_bit_execute_d),
    F_file_mode_t_mask_how_add_d & F_file_mode_t_block_standard_d & (F_file_mode_t_mask_bit_read_d | F_file_mode_t_mask_bit_write_d | F_file_mode_t_mask_bit_execute_d),
    F_file_mode_t_mask_how_add_d & F_file_mode_t_block_standard_d & (F_file_mode_t_mask_bit_read_d | F_file_mode_t_mask_bit_write_d | F_file_mode_t_mask_bit_execute_d),
    F_file_mode_t_mask_how_add_d & F_file_mode_t_block_standard_d & (F_file_mode_t_mask_bit_read_d | F_file_mode_t_mask_bit_write_d | F_file_mode_t_mask_bit_execute_d),
  };

  uint8_t replaces[] = {
    0,
    0,
    F_file_mode_t_replace_special_d | F_file_mode_t_replace_owner_d | F_file_mode_t_replace_group_d | F_file_mode_t_replace_world_d,
    0,
    0,
    0,
    0,
    0,
    0,
    0,
    0,
    0,
    0,
    0,
    0,
    F_file_mode_t_replace_special_d | F_file_mode_t_replace_owner_d | F_file_mode_t_replace_group_d | F_file_mode_t_replace_world_d,
    F_file_mode_t_replace_special_d | F_file_mode_t_replace_owner_d | F_file_mode_t_replace_group_d | F_file_mode_t_replace_world_d,
    F_file_mode_t_replace_special_d | F_file_mode_t_replace_owner_d | F_file_mode_t_replace_group_d | F_file_mode_t_replace_world_d,
    F_file_mode_t_replace_special_d | F_file_mode_t_replace_owner_d | F_file_mode_t_replace_group_d | F_file_mode_t_replace_world_d,
    F_file_mode_t_replace_special_d | F_file_mode_t_replace_owner_d | F_file_mode_t_replace_group_d | F_file_mode_t_replace_world_d,
    F_file_mode_t_replace_special_d | F_file_mode_t_replace_owner_d | F_file_mode_t_replace_group_d | F_file_mode_t_replace_world_d,
    0,
    0,
    0,
    0,
    0,
    0,
    0,
    0,
    0,
    0,
    0,
    0,
    0,
    0,
    F_file_mode_t_replace_special_d | F_file_mode_t_replace_owner_d | F_file_mode_t_replace_group_d | F_file_mode_t_replace_world_d,
    F_file_mode_t_replace_special_d | F_file_mode_t_replace_owner_d | F_file_mode_t_replace_group_d | F_file_mode_t_replace_world_d,
    F_file_mode_t_replace_special_d | F_file_mode_t_replace_owner_d | F_file_mode_t_replace_group_d | F_file_mode_t_replace_world_d,
    F_file_mode_t_replace_special_d | F_file_mode_t_replace_owner_d | F_file_mode_t_replace_group_d | F_file_mode_t_replace_world_d,
    F_file_mode_t_replace_special_d | F_file_mode_t_replace_owner_d | F_file_mode_t_replace_group_d | F_file_mode_t_replace_world_d,
    F_file_mode_t_replace_special_d | F_file_mode_t_replace_owner_d | F_file_mode_t_replace_group_d | F_file_mode_t_replace_world_d,
    F_file_mode_t_replace_special_d | F_file_mode_t_replace_owner_d | F_file_mode_t_replace_group_d | F_file_mode_t_replace_world_d,
    0,
    0,
    0,
    0,
    0,
    0,
    0,
    0,
    0,
    0,
    0,
    0,
    F_file_mode_t_replace_special_d | F_file_mode_t_replace_owner_d,
    F_file_mode_t_replace_special_d | F_file_mode_t_replace_owner_d,
    F_file_mode_t_replace_special_d | F_file_mode_t_replace_owner_d,
    F_file_mode_t_replace_special_d | F_file_mode_t_replace_owner_d,
    F_file_mode_t_replace_special_d | F_file_mode_t_replace_owner_d,
    F_file_mode_t_replace_special_d | F_file_mode_t_replace_owner_d,
    0,
    0,
    0,
    0,
    0,
    0,
    0,
    0,
    0,
    0,
    0,
    0,
    0,
    0,
    F_file_mode_t_replace_special_d | F_file_mode_t_replace_owner_d,
    F_file_mode_t_replace_special_d | F_file_mode_t_replace_owner_d,
    F_file_mode_t_replace_special_d | F_file_mode_t_replace_owner_d,
    F_file_mode_t_replace_special_d | F_file_mode_t_replace_owner_d,
    F_file_mode_t_replace_special_d | F_file_mode_t_replace_owner_d,
    F_file_mode_t_replace_special_d | F_file_mode_t_replace_owner_d,
    F_file_mode_t_replace_special_d | F_file_mode_t_replace_owner_d,
    0,
    0,
    0,
    0,
    0,
    0,
    0,
    0,
    0,
    0,
    0,
    0,
    F_file_mode_t_replace_special_d | F_file_mode_t_replace_group_d,
    F_file_mode_t_replace_special_d | F_file_mode_t_replace_group_d,
    F_file_mode_t_replace_special_d | F_file_mode_t_replace_group_d,
    F_file_mode_t_replace_special_d | F_file_mode_t_replace_group_d,
    F_file_mode_t_replace_special_d | F_file_mode_t_replace_group_d,
    F_file_mode_t_replace_special_d | F_file_mode_t_replace_group_d,
    0,
    0,
    0,
    0,
    0,
    0,
    0,
    0,
    0,
    0,
    0,
    0,
    0,
    0,
    F_file_mode_t_replace_special_d | F_file_mode_t_replace_group_d,
    F_file_mode_t_replace_special_d | F_file_mode_t_replace_group_d,
    F_file_mode_t_replace_special_d | F_file_mode_t_replace_group_d,
    F_file_mode_t_replace_special_d | F_file_mode_t_replace_group_d,
    F_file_mode_t_replace_special_d | F_file_mode_t_replace_group_d,
    F_file_mode_t_replace_special_d | F_file_mode_t_replace_group_d,
    F_file_mode_t_replace_special_d | F_file_mode_t_replace_group_d,
    0,
    0,
    0,
    0,
    0,
    0,
    0,
    0,
    0,
    0,
    0,
    0,
    F_file_mode_t_replace_special_d | F_file_mode_t_replace_world_d,
    F_file_mode_t_replace_special_d | F_file_mode_t_replace_world_d,
    F_file_mode_t_replace_special_d | F_file_mode_t_replace_world_d,
    F_file_mode_t_replace_special_d | F_file_mode_t_replace_world_d,
    F_file_mode_t_replace_special_d | F_file_mode_t_replace_world_d,
    F_file_mode_t_replace_special_d | F_file_mode_t_replace_world_d,
    0,
    0,
    0,
    0,
    0,
    0,
    0,
    0,
    0,
    0,
    0,
    0,
    0,
    0,
    F_file_mode_t_replace_special_d | F_file_mode_t_replace_world_d,
    F_file_mode_t_replace_special_d | F_file_mode_t_replace_world_d,
    F_file_mode_t_replace_special_d | F_file_mode_t_replace_world_d,
    F_file_mode_t_replace_special_d | F_file_mode_t_replace_world_d,
    F_file_mode_t_replace_special_d | F_file_mode_t_replace_world_d,
    F_file_mode_t_replace_special_d | F_file_mode_t_replace_world_d,
    F_file_mode_t_replace_special_d | F_file_mode_t_replace_world_d,
    0,
    0,
    0,
    0,
    0,
    0,
    0,
    0,
    0,
    0,
    0,
    0,
    F_file_mode_t_replace_special_d | F_file_mode_t_replace_owner_d | F_file_mode_t_replace_group_d,
    F_file_mode_t_replace_special_d | F_file_mode_t_replace_owner_d | F_file_mode_t_replace_group_d,
    F_file_mode_t_replace_special_d | F_file_mode_t_replace_owner_d | F_file_mode_t_replace_group_d,
    F_file_mode_t_replace_special_d | F_file_mode_t_replace_owner_d | F_file_mode_t_replace_group_d,
    F_file_mode_t_replace_special_d | F_file_mode_t_replace_owner_d | F_file_mode_t_replace_group_d,
    F_file_mode_t_replace_special_d | F_file_mode_t_replace_owner_d | F_file_mode_t_replace_group_d,
    0,
    0,
    0,
    0,
    0,
    0,
    0,
    0,
    0,
    0,
    0,
    0,
    0,
    0,
    F_file_mode_t_replace_special_d | F_file_mode_t_replace_owner_d | F_file_mode_t_replace_group_d,
    F_file_mode_t_replace_special_d | F_file_mode_t_replace_owner_d | F_file_mode_t_replace_group_d,
    F_file_mode_t_replace_special_d | F_file_mode_t_replace_owner_d | F_file_mode_t_replace_group_d,
    F_file_mode_t_replace_special_d | F_file_mode_t_replace_owner_d | F_file_mode_t_replace_group_d,
    F_file_mode_t_replace_special_d | F_file_mode_t_replace_owner_d | F_file_mode_t_replace_group_d,
    F_file_mode_t_replace_special_d | F_file_mode_t_replace_owner_d | F_file_mode_t_replace_group_d,
    F_file_mode_t_replace_special_d | F_file_mode_t_replace_owner_d | F_file_mode_t_replace_group_d,
    0,
    0,
    0,
    0,
    0,
    0,
    0,
    0,
    0,
    0,
    0,
    0,
    F_file_mode_t_replace_special_d | F_file_mode_t_replace_owner_d | F_file_mode_t_replace_world_d,
    F_file_mode_t_replace_special_d | F_file_mode_t_replace_owner_d | F_file_mode_t_replace_world_d,
    F_file_mode_t_replace_special_d | F_file_mode_t_replace_owner_d | F_file_mode_t_replace_world_d,
    F_file_mode_t_replace_special_d | F_file_mode_t_replace_owner_d | F_file_mode_t_replace_world_d,
    F_file_mode_t_replace_special_d | F_file_mode_t_replace_owner_d | F_file_mode_t_replace_world_d,
    F_file_mode_t_replace_special_d | F_file_mode_t_replace_owner_d | F_file_mode_t_replace_world_d,
    0,
    0,
    0,
    0,
    0,
    0,
    0,
    0,
    0,
    0,
    0,
    0,
    0,
    0,
    F_file_mode_t_replace_special_d | F_file_mode_t_replace_owner_d | F_file_mode_t_replace_world_d,
    F_file_mode_t_replace_special_d | F_file_mode_t_replace_owner_d | F_file_mode_t_replace_world_d,
    F_file_mode_t_replace_special_d | F_file_mode_t_replace_owner_d | F_file_mode_t_replace_world_d,
    F_file_mode_t_replace_special_d | F_file_mode_t_replace_owner_d | F_file_mode_t_replace_world_d,
    F_file_mode_t_replace_special_d | F_file_mode_t_replace_owner_d | F_file_mode_t_replace_world_d,
    F_file_mode_t_replace_special_d | F_file_mode_t_replace_owner_d | F_file_mode_t_replace_world_d,
    F_file_mode_t_replace_special_d | F_file_mode_t_replace_owner_d | F_file_mode_t_replace_world_d,
    0,
    0,
    0,
    0,
    0,
    0,
    0,
    0,
    0,
    0,
    0,
    0,
    F_file_mode_t_replace_special_d | F_file_mode_t_replace_owner_d | F_file_mode_t_replace_group_d,
    F_file_mode_t_replace_special_d | F_file_mode_t_replace_owner_d | F_file_mode_t_replace_group_d,
    F_file_mode_t_replace_special_d | F_file_mode_t_replace_owner_d | F_file_mode_t_replace_group_d,
    F_file_mode_t_replace_special_d | F_file_mode_t_replace_owner_d | F_file_mode_t_replace_group_d,
    F_file_mode_t_replace_special_d | F_file_mode_t_replace_owner_d | F_file_mode_t_replace_group_d,
    F_file_mode_t_replace_special_d | F_file_mode_t_replace_owner_d | F_file_mode_t_replace_group_d,
    0,
    0,
    0,
    0,
    0,
    0,
    0,
    0,
    0,
    0,
    0,
    0,
    0,
    0,
    F_file_mode_t_replace_special_d | F_file_mode_t_replace_owner_d | F_file_mode_t_replace_group_d,
    F_file_mode_t_replace_special_d | F_file_mode_t_replace_owner_d | F_file_mode_t_replace_group_d,
    F_file_mode_t_replace_special_d | F_file_mode_t_replace_owner_d | F_file_mode_t_replace_group_d,
    F_file_mode_t_replace_special_d | F_file_mode_t_replace_owner_d | F_file_mode_t_replace_group_d,
    F_file_mode_t_replace_special_d | F_file_mode_t_replace_owner_d | F_file_mode_t_replace_group_d,
    F_file_mode_t_replace_special_d | F_file_mode_t_replace_owner_d | F_file_mode_t_replace_group_d,
    F_file_mode_t_replace_special_d | F_file_mode_t_replace_owner_d | F_file_mode_t_replace_group_d,
    0,
    0,
    0,
    0,
    0,
    0,
    0,
    0,
    0,
    0,
    0,
    0,
    F_file_mode_t_replace_special_d | F_file_mode_t_replace_group_d | F_file_mode_t_replace_world_d,
    F_file_mode_t_replace_special_d | F_file_mode_t_replace_group_d | F_file_mode_t_replace_world_d,
    F_file_mode_t_replace_special_d | F_file_mode_t_replace_group_d | F_file_mode_t_replace_world_d,
    F_file_mode_t_replace_special_d | F_file_mode_t_replace_group_d | F_file_mode_t_replace_world_d,
    F_file_mode_t_replace_special_d | F_file_mode_t_replace_group_d | F_file_mode_t_replace_world_d,
    F_file_mode_t_replace_special_d | F_file_mode_t_replace_group_d | F_file_mode_t_replace_world_d,
    0,
    0,
    0,
    0,
    0,
    0,
    0,
    0,
    0,
    0,
    0,
    0,
    0,
    0,
    F_file_mode_t_replace_special_d | F_file_mode_t_replace_group_d | F_file_mode_t_replace_world_d,
    F_file_mode_t_replace_special_d | F_file_mode_t_replace_group_d | F_file_mode_t_replace_world_d,
    F_file_mode_t_replace_special_d | F_file_mode_t_replace_group_d | F_file_mode_t_replace_world_d,
    F_file_mode_t_replace_special_d | F_file_mode_t_replace_group_d | F_file_mode_t_replace_world_d,
    F_file_mode_t_replace_special_d | F_file_mode_t_replace_group_d | F_file_mode_t_replace_world_d,
    F_file_mode_t_replace_special_d | F_file_mode_t_replace_group_d | F_file_mode_t_replace_world_d,
    F_file_mode_t_replace_special_d | F_file_mode_t_replace_group_d | F_file_mode_t_replace_world_d,
    0,
    0,
    0,
    0,
    0,
    0,
    0,
    0,
    0,
    0,
    0,
    0,
    F_file_mode_t_replace_special_d | F_file_mode_t_replace_owner_d | F_file_mode_t_replace_world_d,
    F_file_mode_t_replace_special_d | F_file_mode_t_replace_owner_d | F_file_mode_t_replace_world_d,
    F_file_mode_t_replace_special_d | F_file_mode_t_replace_owner_d | F_file_mode_t_replace_world_d,
    F_file_mode_t_replace_special_d | F_file_mode_t_replace_owner_d | F_file_mode_t_replace_world_d,
    F_file_mode_t_replace_special_d | F_file_mode_t_replace_owner_d | F_file_mode_t_replace_world_d,
    F_file_mode_t_replace_special_d | F_file_mode_t_replace_owner_d | F_file_mode_t_replace_world_d,
    0,
    0,
    0,
    0,
    0,
    0,
    0,
    0,
    0,
    0,
    0,
    0,
    0,
    0,
    F_file_mode_t_replace_special_d | F_file_mode_t_replace_owner_d | F_file_mode_t_replace_world_d,
    F_file_mode_t_replace_special_d | F_file_mode_t_replace_owner_d | F_file_mode_t_replace_world_d,
    F_file_mode_t_replace_special_d | F_file_mode_t_replace_owner_d | F_file_mode_t_replace_world_d,
    F_file_mode_t_replace_special_d | F_file_mode_t_replace_owner_d | F_file_mode_t_replace_world_d,
    F_file_mode_t_replace_special_d | F_file_mode_t_replace_owner_d | F_file_mode_t_replace_world_d,
    F_file_mode_t_replace_special_d | F_file_mode_t_replace_owner_d | F_file_mode_t_replace_world_d,
    F_file_mode_t_replace_special_d | F_file_mode_t_replace_owner_d | F_file_mode_t_replace_world_d,
    0,
    0,
    0,
    0,
    0,
    0,
    0,
    0,
    0,
    0,
    0,
    0,
    F_file_mode_t_replace_special_d | F_file_mode_t_replace_group_d | F_file_mode_t_replace_world_d,
    F_file_mode_t_replace_special_d | F_file_mode_t_replace_group_d | F_file_mode_t_replace_world_d,
    F_file_mode_t_replace_special_d | F_file_mode_t_replace_group_d | F_file_mode_t_replace_world_d,
    F_file_mode_t_replace_special_d | F_file_mode_t_replace_group_d | F_file_mode_t_replace_world_d,
    F_file_mode_t_replace_special_d | F_file_mode_t_replace_group_d | F_file_mode_t_replace_world_d,
    F_file_mode_t_replace_special_d | F_file_mode_t_replace_group_d | F_file_mode_t_replace_world_d,
    0,
    0,
    0,
    0,
    0,
    0,
    0,
    0,
    0,
    0,
    0,
    0,
    0,
    0,
    F_file_mode_t_replace_special_d | F_file_mode_t_replace_group_d | F_file_mode_t_replace_world_d,
    F_file_mode_t_replace_special_d | F_file_mode_t_replace_group_d | F_file_mode_t_replace_world_d,
    F_file_mode_t_replace_special_d | F_file_mode_t_replace_group_d | F_file_mode_t_replace_world_d,
    F_file_mode_t_replace_special_d | F_file_mode_t_replace_group_d | F_file_mode_t_replace_world_d,
    F_file_mode_t_replace_special_d | F_file_mode_t_replace_group_d | F_file_mode_t_replace_world_d,
    F_file_mode_t_replace_special_d | F_file_mode_t_replace_group_d | F_file_mode_t_replace_world_d,
    F_file_mode_t_replace_special_d | F_file_mode_t_replace_group_d | F_file_mode_t_replace_world_d,
    0,
    0,
    0,
    0,
    0,
    0,
    0,
    0,
    0,
    0,
    0,
    0,
    F_file_mode_t_replace_special_d | F_file_mode_t_replace_owner_d | F_file_mode_t_replace_group_d | F_file_mode_t_replace_world_d,
    F_file_mode_t_replace_special_d | F_file_mode_t_replace_owner_d | F_file_mode_t_replace_group_d | F_file_mode_t_replace_world_d,
    F_file_mode_t_replace_special_d | F_file_mode_t_replace_owner_d | F_file_mode_t_replace_group_d | F_file_mode_t_replace_world_d,
    F_file_mode_t_replace_special_d | F_file_mode_t_replace_owner_d | F_file_mode_t_replace_group_d | F_file_mode_t_replace_world_d,
    F_file_mode_t_replace_special_d | F_file_mode_t_replace_owner_d | F_file_mode_t_replace_group_d | F_file_mode_t_replace_world_d,
    F_file_mode_t_replace_special_d | F_file_mode_t_replace_owner_d | F_file_mode_t_replace_group_d | F_file_mode_t_replace_world_d,
    0,
    0,
    0,
    0,
    0,
    0,
    0,
    0,
    0,
    0,
    0,
    0,
    0,
    0,
    F_file_mode_t_replace_special_d | F_file_mode_t_replace_owner_d | F_file_mode_t_replace_group_d | F_file_mode_t_replace_world_d,
    F_file_mode_t_replace_special_d | F_file_mode_t_replace_owner_d | F_file_mode_t_replace_group_d | F_file_mode_t_replace_world_d,
    F_file_mode_t_replace_special_d | F_file_mode_t_replace_owner_d | F_file_mode_t_replace_group_d | F_file_mode_t_replace_world_d,
    F_file_mode_t_replace_special_d | F_file_mode_t_replace_owner_d | F_file_mode_t_replace_group_d | F_file_mode_t_replace_world_d,
    F_file_mode_t_replace_special_d | F_file_mode_t_replace_owner_d | F_file_mode_t_replace_group_d | F_file_mode_t_replace_world_d,
    F_file_mode_t_replace_special_d | F_file_mode_t_replace_owner_d | F_file_mode_t_replace_group_d | F_file_mode_t_replace_world_d,
    F_file_mode_t_replace_special_d | F_file_mode_t_replace_owner_d | F_file_mode_t_replace_group_d | F_file_mode_t_replace_world_d,
    0,
    0,
    0,
    0,
    0,
    0,
    0,
    0,
    0,
    0,
    0,
    0,
    0,
    0,
    F_file_mode_t_replace_special_d | F_file_mode_t_replace_owner_d | F_file_mode_t_replace_group_d | F_file_mode_t_replace_world_d,
    F_file_mode_t_replace_special_d | F_file_mode_t_replace_owner_d | F_file_mode_t_replace_group_d | F_file_mode_t_replace_world_d,
    F_file_mode_t_replace_special_d | F_file_mode_t_replace_owner_d | F_file_mode_t_replace_group_d | F_file_mode_t_replace_world_d,
    F_file_mode_t_replace_special_d | F_file_mode_t_replace_owner_d | F_file_mode_t_replace_group_d | F_file_mode_t_replace_world_d,
    F_file_mode_t_replace_special_d | F_file_mode_t_replace_owner_d | F_file_mode_t_replace_group_d | F_file_mode_t_replace_world_d,
    F_file_mode_t_replace_special_d | F_file_mode_t_replace_owner_d | F_file_mode_t_replace_group_d | F_file_mode_t_replace_world_d,
    F_file_mode_t_replace_special_d | F_file_mode_t_replace_owner_d | F_file_mode_t_replace_group_d | F_file_mode_t_replace_world_d,
    0,
    0,
    0,
    0,
    0,
    0,
    0,
    0,
    0,
    0,
    0,
    0,
    0,
    0,
    F_file_mode_t_replace_special_d | F_file_mode_t_replace_owner_d | F_file_mode_t_replace_group_d | F_file_mode_t_replace_world_d,
    F_file_mode_t_replace_special_d | F_file_mode_t_replace_owner_d | F_file_mode_t_replace_group_d | F_file_mode_t_replace_world_d,
    F_file_mode_t_replace_special_d | F_file_mode_t_replace_owner_d | F_file_mode_t_replace_group_d | F_file_mode_t_replace_world_d,
    F_file_mode_t_replace_special_d | F_file_mode_t_replace_owner_d | F_file_mode_t_replace_group_d | F_file_mode_t_replace_world_d,
    F_file_mode_t_replace_special_d | F_file_mode_t_replace_owner_d | F_file_mode_t_replace_group_d | F_file_mode_t_replace_world_d,
    F_file_mode_t_replace_special_d | F_file_mode_t_replace_owner_d | F_file_mode_t_replace_group_d | F_file_mode_t_replace_world_d,
    F_file_mode_t_replace_special_d | F_file_mode_t_replace_owner_d | F_file_mode_t_replace_group_d | F_file_mode_t_replace_world_d,
    0,
    0,
    0,
    0,
    0,
    0,
    0,
    0,
    0,
    0,
    0,
    0,
    0,
    0,
    F_file_mode_t_replace_special_d | F_file_mode_t_replace_owner_d | F_file_mode_t_replace_group_d | F_file_mode_t_replace_world_d,
    F_file_mode_t_replace_special_d | F_file_mode_t_replace_owner_d | F_file_mode_t_replace_group_d | F_file_mode_t_replace_world_d,
    F_file_mode_t_replace_special_d | F_file_mode_t_replace_owner_d | F_file_mode_t_replace_group_d | F_file_mode_t_replace_world_d,
    F_file_mode_t_replace_special_d | F_file_mode_t_replace_owner_d | F_file_mode_t_replace_group_d | F_file_mode_t_replace_world_d,
    F_file_mode_t_replace_special_d | F_file_mode_t_replace_owner_d | F_file_mode_t_replace_group_d | F_file_mode_t_replace_world_d,
    F_file_mode_t_replace_special_d | F_file_mode_t_replace_owner_d | F_file_mode_t_replace_group_d | F_file_mode_t_replace_world_d,
    F_file_mode_t_replace_special_d | F_file_mode_t_replace_owner_d | F_file_mode_t_replace_group_d | F_file_mode_t_replace_world_d,
    0,
    0,
    0,
    0,
    0,
    0,
    0,
    0,
    0,
    0,
    0,
    0,
    0,
    0,
    F_file_mode_t_replace_special_d | F_file_mode_t_replace_owner_d | F_file_mode_t_replace_group_d | F_file_mode_t_replace_world_d,
    F_file_mode_t_replace_special_d | F_file_mode_t_replace_owner_d | F_file_mode_t_replace_group_d | F_file_mode_t_replace_world_d,
    F_file_mode_t_replace_special_d | F_file_mode_t_replace_owner_d | F_file_mode_t_replace_group_d | F_file_mode_t_replace_world_d,
    F_file_mode_t_replace_special_d | F_file_mode_t_replace_owner_d | F_file_mode_t_replace_group_d | F_file_mode_t_replace_world_d,
    F_file_mode_t_replace_special_d | F_file_mode_t_replace_owner_d | F_file_mode_t_replace_group_d | F_file_mode_t_replace_world_d,
    F_file_mode_t_replace_special_d | F_file_mode_t_replace_owner_d | F_file_mode_t_replace_group_d | F_file_mode_t_replace_world_d,
    F_file_mode_t_replace_special_d | F_file_mode_t_replace_owner_d | F_file_mode_t_replace_group_d | F_file_mode_t_replace_world_d,
    0,
    0,
    0,
    0,
    0,
    0,
    0,
    0,
    0,
    0,
    0,
    0,
    0,
    0,
    F_file_mode_t_replace_special_d | F_file_mode_t_replace_owner_d | F_file_mode_t_replace_group_d | F_file_mode_t_replace_world_d,
    F_file_mode_t_replace_special_d | F_file_mode_t_replace_owner_d | F_file_mode_t_replace_group_d | F_file_mode_t_replace_world_d,
    F_file_mode_t_replace_special_d | F_file_mode_t_replace_owner_d | F_file_mode_t_replace_group_d | F_file_mode_t_replace_world_d,
    F_file_mode_t_replace_special_d | F_file_mode_t_replace_owner_d | F_file_mode_t_replace_group_d | F_file_mode_t_replace_world_d,
    F_file_mode_t_replace_special_d | F_file_mode_t_replace_owner_d | F_file_mode_t_replace_group_d | F_file_mode_t_replace_world_d,
    F_file_mode_t_replace_special_d | F_file_mode_t_replace_owner_d | F_file_mode_t_replace_group_d | F_file_mode_t_replace_world_d,
    F_file_mode_t_replace_special_d | F_file_mode_t_replace_owner_d | F_file_mode_t_replace_group_d | F_file_mode_t_replace_world_d,
    0,
    0,
    0,
    0,
    0,
    0,
    0,
    0,
    0,
    0,
    0,
    0,
    0,
    0,
    F_file_mode_t_replace_special_d | F_file_mode_t_replace_owner_d | F_file_mode_t_replace_group_d | F_file_mode_t_replace_world_d,
    F_file_mode_t_replace_special_d | F_file_mode_t_replace_owner_d | F_file_mode_t_replace_group_d | F_file_mode_t_replace_world_d,
    F_file_mode_t_replace_special_d | F_file_mode_t_replace_owner_d | F_file_mode_t_replace_group_d | F_file_mode_t_replace_world_d,
    F_file_mode_t_replace_special_d | F_file_mode_t_replace_owner_d | F_file_mode_t_replace_group_d | F_file_mode_t_replace_world_d,
    F_file_mode_t_replace_special_d | F_file_mode_t_replace_owner_d | F_file_mode_t_replace_group_d | F_file_mode_t_replace_world_d,
    F_file_mode_t_replace_special_d | F_file_mode_t_replace_owner_d | F_file_mode_t_replace_group_d | F_file_mode_t_replace_world_d,
    F_file_mode_t_replace_special_d | F_file_mode_t_replace_owner_d | F_file_mode_t_replace_group_d | F_file_mode_t_replace_world_d,
  };

  for (int i = 0; i < 558; ++i) {

    f_file_mode_t mode = 0;
    uint8_t replace = 0;

    const f_status_t status = f_file_mode_from_string(codes[i], 0, &mode, &replace);

    assert_int_equal(status, F_okay);
    assert_int_equal(mode, modes[i]);
    assert_int_equal(replace, replaces[i]);
  } // for
}

void test__f_file_mode_from_string__works_basic_digit(void **state) {

  f_string_static_t codes[] = {
    macro_f_string_static_t_initialize_1("0", 0, 1),
    macro_f_string_static_t_initialize_1("1", 0, 1),
    macro_f_string_static_t_initialize_1("2", 0, 1),
    macro_f_string_static_t_initialize_1("3", 0, 1),
    macro_f_string_static_t_initialize_1("4", 0, 1),
    macro_f_string_static_t_initialize_1("5", 0, 1),
    macro_f_string_static_t_initialize_1("6", 0, 1),
    macro_f_string_static_t_initialize_1("7", 0, 1),
    macro_f_string_static_t_initialize_1("111", 0, 3),
    macro_f_string_static_t_initialize_1("222", 0, 3),
    macro_f_string_static_t_initialize_1("333", 0, 3),
    macro_f_string_static_t_initialize_1("444", 0, 3),
    macro_f_string_static_t_initialize_1("555", 0, 3),
    macro_f_string_static_t_initialize_1("666", 0, 3),
    macro_f_string_static_t_initialize_1("777", 0, 3),
    macro_f_string_static_t_initialize_1("100", 0, 3),
    macro_f_string_static_t_initialize_1("200", 0, 3),
    macro_f_string_static_t_initialize_1("300", 0, 3),
    macro_f_string_static_t_initialize_1("400", 0, 3),
    macro_f_string_static_t_initialize_1("500", 0, 3),
    macro_f_string_static_t_initialize_1("600", 0, 3),
    macro_f_string_static_t_initialize_1("700", 0, 3),
    macro_f_string_static_t_initialize_1("010", 0, 3),
    macro_f_string_static_t_initialize_1("020", 0, 3),
    macro_f_string_static_t_initialize_1("030", 0, 3),
    macro_f_string_static_t_initialize_1("040", 0, 3),
    macro_f_string_static_t_initialize_1("050", 0, 3),
    macro_f_string_static_t_initialize_1("060", 0, 3),
    macro_f_string_static_t_initialize_1("070", 0, 3),
    macro_f_string_static_t_initialize_1("001", 0, 3),
    macro_f_string_static_t_initialize_1("002", 0, 3),
    macro_f_string_static_t_initialize_1("003", 0, 3),
    macro_f_string_static_t_initialize_1("004", 0, 3),
    macro_f_string_static_t_initialize_1("005", 0, 3),
    macro_f_string_static_t_initialize_1("006", 0, 3),
    macro_f_string_static_t_initialize_1("007", 0, 3),
    macro_f_string_static_t_initialize_1("00000000", 0, 8),
    macro_f_string_static_t_initialize_1("00000100", 0, 8),
    macro_f_string_static_t_initialize_1("00000200", 0, 8),
    macro_f_string_static_t_initialize_1("00000300", 0, 8),
    macro_f_string_static_t_initialize_1("00000400", 0, 8),
    macro_f_string_static_t_initialize_1("00000500", 0, 8),
    macro_f_string_static_t_initialize_1("00000600", 0, 8),
    macro_f_string_static_t_initialize_1("00000700", 0, 8),
    macro_f_string_static_t_initialize_1("=0", 0, 2),
    macro_f_string_static_t_initialize_1("=1", 0, 2),
    macro_f_string_static_t_initialize_1("=2", 0, 2),
    macro_f_string_static_t_initialize_1("=3", 0, 2),
    macro_f_string_static_t_initialize_1("=4", 0, 2),
    macro_f_string_static_t_initialize_1("=5", 0, 2),
    macro_f_string_static_t_initialize_1("=6", 0, 2),
    macro_f_string_static_t_initialize_1("=7", 0, 2),
    macro_f_string_static_t_initialize_1("=111", 0, 4),
    macro_f_string_static_t_initialize_1("=222", 0, 4),
    macro_f_string_static_t_initialize_1("=333", 0, 4),
    macro_f_string_static_t_initialize_1("=444", 0, 4),
    macro_f_string_static_t_initialize_1("=555", 0, 4),
    macro_f_string_static_t_initialize_1("=666", 0, 4),
    macro_f_string_static_t_initialize_1("=777", 0, 4),
    macro_f_string_static_t_initialize_1("=100", 0, 4),
    macro_f_string_static_t_initialize_1("=200", 0, 4),
    macro_f_string_static_t_initialize_1("=300", 0, 4),
    macro_f_string_static_t_initialize_1("=400", 0, 4),
    macro_f_string_static_t_initialize_1("=500", 0, 4),
    macro_f_string_static_t_initialize_1("=600", 0, 4),
    macro_f_string_static_t_initialize_1("=700", 0, 4),
    macro_f_string_static_t_initialize_1("=010", 0, 4),
    macro_f_string_static_t_initialize_1("=020", 0, 4),
    macro_f_string_static_t_initialize_1("=030", 0, 4),
    macro_f_string_static_t_initialize_1("=040", 0, 4),
    macro_f_string_static_t_initialize_1("=050", 0, 4),
    macro_f_string_static_t_initialize_1("=060", 0, 4),
    macro_f_string_static_t_initialize_1("=070", 0, 4),
    macro_f_string_static_t_initialize_1("=001", 0, 4),
    macro_f_string_static_t_initialize_1("=002", 0, 4),
    macro_f_string_static_t_initialize_1("=003", 0, 4),
    macro_f_string_static_t_initialize_1("=004", 0, 4),
    macro_f_string_static_t_initialize_1("=005", 0, 4),
    macro_f_string_static_t_initialize_1("=006", 0, 4),
    macro_f_string_static_t_initialize_1("=007", 0, 4),
    macro_f_string_static_t_initialize_1("=00000000", 0, 9),
    macro_f_string_static_t_initialize_1("=00000100", 0, 9),
    macro_f_string_static_t_initialize_1("=00000200", 0, 9),
    macro_f_string_static_t_initialize_1("=00000300", 0, 9),
    macro_f_string_static_t_initialize_1("=00000400", 0, 9),
    macro_f_string_static_t_initialize_1("=00000500", 0, 9),
    macro_f_string_static_t_initialize_1("=00000600", 0, 9),
    macro_f_string_static_t_initialize_1("=00000700", 0, 9),
    macro_f_string_static_t_initialize_1("+0", 0, 2),
    macro_f_string_static_t_initialize_1("+1", 0, 2),
    macro_f_string_static_t_initialize_1("+2", 0, 2),
    macro_f_string_static_t_initialize_1("+3", 0, 2),
    macro_f_string_static_t_initialize_1("+4", 0, 2),
    macro_f_string_static_t_initialize_1("+5", 0, 2),
    macro_f_string_static_t_initialize_1("+6", 0, 2),
    macro_f_string_static_t_initialize_1("+7", 0, 2),
    macro_f_string_static_t_initialize_1("+111", 0, 4),
    macro_f_string_static_t_initialize_1("+222", 0, 4),
    macro_f_string_static_t_initialize_1("+333", 0, 4),
    macro_f_string_static_t_initialize_1("+444", 0, 4),
    macro_f_string_static_t_initialize_1("+555", 0, 4),
    macro_f_string_static_t_initialize_1("+666", 0, 4),
    macro_f_string_static_t_initialize_1("+777", 0, 4),
    macro_f_string_static_t_initialize_1("+100", 0, 4),
    macro_f_string_static_t_initialize_1("+200", 0, 4),
    macro_f_string_static_t_initialize_1("+300", 0, 4),
    macro_f_string_static_t_initialize_1("+400", 0, 4),
    macro_f_string_static_t_initialize_1("+500", 0, 4),
    macro_f_string_static_t_initialize_1("+600", 0, 4),
    macro_f_string_static_t_initialize_1("+700", 0, 4),
    macro_f_string_static_t_initialize_1("+010", 0, 4),
    macro_f_string_static_t_initialize_1("+020", 0, 4),
    macro_f_string_static_t_initialize_1("+030", 0, 4),
    macro_f_string_static_t_initialize_1("+040", 0, 4),
    macro_f_string_static_t_initialize_1("+050", 0, 4),
    macro_f_string_static_t_initialize_1("+060", 0, 4),
    macro_f_string_static_t_initialize_1("+070", 0, 4),
    macro_f_string_static_t_initialize_1("+001", 0, 4),
    macro_f_string_static_t_initialize_1("+002", 0, 4),
    macro_f_string_static_t_initialize_1("+003", 0, 4),
    macro_f_string_static_t_initialize_1("+004", 0, 4),
    macro_f_string_static_t_initialize_1("+005", 0, 4),
    macro_f_string_static_t_initialize_1("+006", 0, 4),
    macro_f_string_static_t_initialize_1("+007", 0, 4),
    macro_f_string_static_t_initialize_1("+00000000", 0, 9),
    macro_f_string_static_t_initialize_1("+00000100", 0, 9),
    macro_f_string_static_t_initialize_1("+00000200", 0, 9),
    macro_f_string_static_t_initialize_1("+00000300", 0, 9),
    macro_f_string_static_t_initialize_1("+00000400", 0, 9),
    macro_f_string_static_t_initialize_1("+00000500", 0, 9),
    macro_f_string_static_t_initialize_1("+00000600", 0, 9),
    macro_f_string_static_t_initialize_1("+00000700", 0, 9),
    macro_f_string_static_t_initialize_1("-0", 0, 2),
    macro_f_string_static_t_initialize_1("-1", 0, 2),
    macro_f_string_static_t_initialize_1("-2", 0, 2),
    macro_f_string_static_t_initialize_1("-3", 0, 2),
    macro_f_string_static_t_initialize_1("-4", 0, 2),
    macro_f_string_static_t_initialize_1("-5", 0, 2),
    macro_f_string_static_t_initialize_1("-6", 0, 2),
    macro_f_string_static_t_initialize_1("-7", 0, 2),
    macro_f_string_static_t_initialize_1("-111", 0, 4),
    macro_f_string_static_t_initialize_1("-222", 0, 4),
    macro_f_string_static_t_initialize_1("-333", 0, 4),
    macro_f_string_static_t_initialize_1("-444", 0, 4),
    macro_f_string_static_t_initialize_1("-555", 0, 4),
    macro_f_string_static_t_initialize_1("-666", 0, 4),
    macro_f_string_static_t_initialize_1("-777", 0, 4),
    macro_f_string_static_t_initialize_1("-100", 0, 4),
    macro_f_string_static_t_initialize_1("-200", 0, 4),
    macro_f_string_static_t_initialize_1("-300", 0, 4),
    macro_f_string_static_t_initialize_1("-400", 0, 4),
    macro_f_string_static_t_initialize_1("-500", 0, 4),
    macro_f_string_static_t_initialize_1("-600", 0, 4),
    macro_f_string_static_t_initialize_1("-700", 0, 4),
    macro_f_string_static_t_initialize_1("-010", 0, 4),
    macro_f_string_static_t_initialize_1("-020", 0, 4),
    macro_f_string_static_t_initialize_1("-030", 0, 4),
    macro_f_string_static_t_initialize_1("-040", 0, 4),
    macro_f_string_static_t_initialize_1("-050", 0, 4),
    macro_f_string_static_t_initialize_1("-060", 0, 4),
    macro_f_string_static_t_initialize_1("-070", 0, 4),
    macro_f_string_static_t_initialize_1("-001", 0, 4),
    macro_f_string_static_t_initialize_1("-002", 0, 4),
    macro_f_string_static_t_initialize_1("-003", 0, 4),
    macro_f_string_static_t_initialize_1("-004", 0, 4),
    macro_f_string_static_t_initialize_1("-005", 0, 4),
    macro_f_string_static_t_initialize_1("-006", 0, 4),
    macro_f_string_static_t_initialize_1("-007", 0, 4),
    macro_f_string_static_t_initialize_1("-00000000", 0, 9),
    macro_f_string_static_t_initialize_1("-00000100", 0, 9),
    macro_f_string_static_t_initialize_1("-00000200", 0, 9),
    macro_f_string_static_t_initialize_1("-00000300", 0, 9),
    macro_f_string_static_t_initialize_1("-00000400", 0, 9),
    macro_f_string_static_t_initialize_1("-00000500", 0, 9),
    macro_f_string_static_t_initialize_1("-00000600", 0, 9),
    macro_f_string_static_t_initialize_1("-00000700", 0, 9),
  };

  f_file_mode_t modes[] = {
    0,
    F_file_mode_t_mask_how_add_d & F_file_mode_t_block_world_d & F_file_mode_t_mask_bit_execute_d,
    F_file_mode_t_mask_how_add_d & F_file_mode_t_block_world_d & F_file_mode_t_mask_bit_write_d,
    F_file_mode_t_mask_how_add_d & F_file_mode_t_block_world_d & (F_file_mode_t_mask_bit_write_d | F_file_mode_t_mask_bit_execute_d),
    F_file_mode_t_mask_how_add_d & F_file_mode_t_block_world_d & F_file_mode_t_mask_bit_read_d,
    F_file_mode_t_mask_how_add_d & F_file_mode_t_block_world_d & (F_file_mode_t_mask_bit_read_d | F_file_mode_t_mask_bit_execute_d),
    F_file_mode_t_mask_how_add_d & F_file_mode_t_block_world_d & (F_file_mode_t_mask_bit_read_d | F_file_mode_t_mask_bit_write_d),
    F_file_mode_t_mask_how_add_d & F_file_mode_t_block_world_d & (F_file_mode_t_mask_bit_read_d | F_file_mode_t_mask_bit_write_d | F_file_mode_t_mask_bit_execute_d),
    F_file_mode_t_mask_how_add_d & F_file_mode_t_block_standard_d & F_file_mode_t_mask_bit_execute_d,
    F_file_mode_t_mask_how_add_d & F_file_mode_t_block_standard_d & F_file_mode_t_mask_bit_write_d,
    F_file_mode_t_mask_how_add_d & F_file_mode_t_block_standard_d & (F_file_mode_t_mask_bit_write_d | F_file_mode_t_mask_bit_execute_d),
    F_file_mode_t_mask_how_add_d & F_file_mode_t_block_standard_d & F_file_mode_t_mask_bit_read_d,
    F_file_mode_t_mask_how_add_d & F_file_mode_t_block_standard_d & (F_file_mode_t_mask_bit_read_d | F_file_mode_t_mask_bit_execute_d),
    F_file_mode_t_mask_how_add_d & F_file_mode_t_block_standard_d & (F_file_mode_t_mask_bit_read_d | F_file_mode_t_mask_bit_write_d),
    F_file_mode_t_mask_how_add_d & F_file_mode_t_block_standard_d & (F_file_mode_t_mask_bit_read_d | F_file_mode_t_mask_bit_write_d | F_file_mode_t_mask_bit_execute_d),
    F_file_mode_t_mask_how_add_d & F_file_mode_t_block_owner_d & F_file_mode_t_mask_bit_execute_d,
    F_file_mode_t_mask_how_add_d & F_file_mode_t_block_owner_d & F_file_mode_t_mask_bit_write_d,
    F_file_mode_t_mask_how_add_d & F_file_mode_t_block_owner_d & (F_file_mode_t_mask_bit_write_d | F_file_mode_t_mask_bit_execute_d),
    F_file_mode_t_mask_how_add_d & F_file_mode_t_block_owner_d & F_file_mode_t_mask_bit_read_d,
    F_file_mode_t_mask_how_add_d & F_file_mode_t_block_owner_d & (F_file_mode_t_mask_bit_read_d | F_file_mode_t_mask_bit_execute_d),
    F_file_mode_t_mask_how_add_d & F_file_mode_t_block_owner_d & (F_file_mode_t_mask_bit_read_d | F_file_mode_t_mask_bit_write_d),
    F_file_mode_t_mask_how_add_d & F_file_mode_t_block_owner_d & (F_file_mode_t_mask_bit_read_d | F_file_mode_t_mask_bit_write_d | F_file_mode_t_mask_bit_execute_d),
    F_file_mode_t_mask_how_add_d & F_file_mode_t_block_group_d & F_file_mode_t_mask_bit_execute_d,
    F_file_mode_t_mask_how_add_d & F_file_mode_t_block_group_d & F_file_mode_t_mask_bit_write_d,
    F_file_mode_t_mask_how_add_d & F_file_mode_t_block_group_d & (F_file_mode_t_mask_bit_write_d | F_file_mode_t_mask_bit_execute_d),
    F_file_mode_t_mask_how_add_d & F_file_mode_t_block_group_d & F_file_mode_t_mask_bit_read_d,
    F_file_mode_t_mask_how_add_d & F_file_mode_t_block_group_d & (F_file_mode_t_mask_bit_read_d | F_file_mode_t_mask_bit_execute_d),
    F_file_mode_t_mask_how_add_d & F_file_mode_t_block_group_d & (F_file_mode_t_mask_bit_read_d | F_file_mode_t_mask_bit_write_d),
    F_file_mode_t_mask_how_add_d & F_file_mode_t_block_group_d & (F_file_mode_t_mask_bit_read_d | F_file_mode_t_mask_bit_write_d | F_file_mode_t_mask_bit_execute_d),
    F_file_mode_t_mask_how_add_d & F_file_mode_t_block_world_d & F_file_mode_t_mask_bit_execute_d,
    F_file_mode_t_mask_how_add_d & F_file_mode_t_block_world_d & F_file_mode_t_mask_bit_write_d,
    F_file_mode_t_mask_how_add_d & F_file_mode_t_block_world_d & (F_file_mode_t_mask_bit_write_d | F_file_mode_t_mask_bit_execute_d),
    F_file_mode_t_mask_how_add_d & F_file_mode_t_block_world_d & F_file_mode_t_mask_bit_read_d,
    F_file_mode_t_mask_how_add_d & F_file_mode_t_block_world_d & (F_file_mode_t_mask_bit_read_d | F_file_mode_t_mask_bit_execute_d),
    F_file_mode_t_mask_how_add_d & F_file_mode_t_block_world_d & (F_file_mode_t_mask_bit_read_d | F_file_mode_t_mask_bit_write_d),
    F_file_mode_t_mask_how_add_d & F_file_mode_t_block_world_d & (F_file_mode_t_mask_bit_read_d | F_file_mode_t_mask_bit_write_d | F_file_mode_t_mask_bit_execute_d),
    0,
    F_file_mode_t_mask_how_add_d & F_file_mode_t_block_owner_d & F_file_mode_t_mask_bit_execute_d,
    F_file_mode_t_mask_how_add_d & F_file_mode_t_block_owner_d & F_file_mode_t_mask_bit_write_d,
    F_file_mode_t_mask_how_add_d & F_file_mode_t_block_owner_d & (F_file_mode_t_mask_bit_write_d | F_file_mode_t_mask_bit_execute_d),
    F_file_mode_t_mask_how_add_d & F_file_mode_t_block_owner_d & F_file_mode_t_mask_bit_read_d,
    F_file_mode_t_mask_how_add_d & F_file_mode_t_block_owner_d & (F_file_mode_t_mask_bit_read_d | F_file_mode_t_mask_bit_execute_d),
    F_file_mode_t_mask_how_add_d & F_file_mode_t_block_owner_d & (F_file_mode_t_mask_bit_read_d | F_file_mode_t_mask_bit_write_d),
    F_file_mode_t_mask_how_add_d & F_file_mode_t_block_owner_d & (F_file_mode_t_mask_bit_read_d | F_file_mode_t_mask_bit_write_d | F_file_mode_t_mask_bit_execute_d),
    0,
    F_file_mode_t_mask_how_add_d & F_file_mode_t_block_world_d & F_file_mode_t_mask_bit_execute_d,
    F_file_mode_t_mask_how_add_d & F_file_mode_t_block_world_d & F_file_mode_t_mask_bit_write_d,
    F_file_mode_t_mask_how_add_d & F_file_mode_t_block_world_d & (F_file_mode_t_mask_bit_write_d | F_file_mode_t_mask_bit_execute_d),
    F_file_mode_t_mask_how_add_d & F_file_mode_t_block_world_d & F_file_mode_t_mask_bit_read_d,
    F_file_mode_t_mask_how_add_d & F_file_mode_t_block_world_d & (F_file_mode_t_mask_bit_read_d | F_file_mode_t_mask_bit_execute_d),
    F_file_mode_t_mask_how_add_d & F_file_mode_t_block_world_d & (F_file_mode_t_mask_bit_read_d | F_file_mode_t_mask_bit_write_d),
    F_file_mode_t_mask_how_add_d & F_file_mode_t_block_world_d & (F_file_mode_t_mask_bit_read_d | F_file_mode_t_mask_bit_write_d | F_file_mode_t_mask_bit_execute_d),
    F_file_mode_t_mask_how_add_d & F_file_mode_t_block_standard_d & F_file_mode_t_mask_bit_execute_d,
    F_file_mode_t_mask_how_add_d & F_file_mode_t_block_standard_d & F_file_mode_t_mask_bit_write_d,
    F_file_mode_t_mask_how_add_d & F_file_mode_t_block_standard_d & (F_file_mode_t_mask_bit_write_d | F_file_mode_t_mask_bit_execute_d),
    F_file_mode_t_mask_how_add_d & F_file_mode_t_block_standard_d & F_file_mode_t_mask_bit_read_d,
    F_file_mode_t_mask_how_add_d & F_file_mode_t_block_standard_d & (F_file_mode_t_mask_bit_read_d | F_file_mode_t_mask_bit_execute_d),
    F_file_mode_t_mask_how_add_d & F_file_mode_t_block_standard_d & (F_file_mode_t_mask_bit_read_d | F_file_mode_t_mask_bit_write_d),
    F_file_mode_t_mask_how_add_d & F_file_mode_t_block_standard_d & (F_file_mode_t_mask_bit_read_d | F_file_mode_t_mask_bit_write_d | F_file_mode_t_mask_bit_execute_d),
    F_file_mode_t_mask_how_add_d & F_file_mode_t_block_owner_d & F_file_mode_t_mask_bit_execute_d,
    F_file_mode_t_mask_how_add_d & F_file_mode_t_block_owner_d & F_file_mode_t_mask_bit_write_d,
    F_file_mode_t_mask_how_add_d & F_file_mode_t_block_owner_d & (F_file_mode_t_mask_bit_write_d | F_file_mode_t_mask_bit_execute_d),
    F_file_mode_t_mask_how_add_d & F_file_mode_t_block_owner_d & F_file_mode_t_mask_bit_read_d,
    F_file_mode_t_mask_how_add_d & F_file_mode_t_block_owner_d & (F_file_mode_t_mask_bit_read_d | F_file_mode_t_mask_bit_execute_d),
    F_file_mode_t_mask_how_add_d & F_file_mode_t_block_owner_d & (F_file_mode_t_mask_bit_read_d | F_file_mode_t_mask_bit_write_d),
    F_file_mode_t_mask_how_add_d & F_file_mode_t_block_owner_d & (F_file_mode_t_mask_bit_read_d | F_file_mode_t_mask_bit_write_d | F_file_mode_t_mask_bit_execute_d),
    F_file_mode_t_mask_how_add_d & F_file_mode_t_block_group_d & F_file_mode_t_mask_bit_execute_d,
    F_file_mode_t_mask_how_add_d & F_file_mode_t_block_group_d & F_file_mode_t_mask_bit_write_d,
    F_file_mode_t_mask_how_add_d & F_file_mode_t_block_group_d & (F_file_mode_t_mask_bit_write_d | F_file_mode_t_mask_bit_execute_d),
    F_file_mode_t_mask_how_add_d & F_file_mode_t_block_group_d & F_file_mode_t_mask_bit_read_d,
    F_file_mode_t_mask_how_add_d & F_file_mode_t_block_group_d & (F_file_mode_t_mask_bit_read_d | F_file_mode_t_mask_bit_execute_d),
    F_file_mode_t_mask_how_add_d & F_file_mode_t_block_group_d & (F_file_mode_t_mask_bit_read_d | F_file_mode_t_mask_bit_write_d),
    F_file_mode_t_mask_how_add_d & F_file_mode_t_block_group_d & (F_file_mode_t_mask_bit_read_d | F_file_mode_t_mask_bit_write_d | F_file_mode_t_mask_bit_execute_d),
    F_file_mode_t_mask_how_add_d & F_file_mode_t_block_world_d & F_file_mode_t_mask_bit_execute_d,
    F_file_mode_t_mask_how_add_d & F_file_mode_t_block_world_d & F_file_mode_t_mask_bit_write_d,
    F_file_mode_t_mask_how_add_d & F_file_mode_t_block_world_d & (F_file_mode_t_mask_bit_write_d | F_file_mode_t_mask_bit_execute_d),
    F_file_mode_t_mask_how_add_d & F_file_mode_t_block_world_d & F_file_mode_t_mask_bit_read_d,
    F_file_mode_t_mask_how_add_d & F_file_mode_t_block_world_d & (F_file_mode_t_mask_bit_read_d | F_file_mode_t_mask_bit_execute_d),
    F_file_mode_t_mask_how_add_d & F_file_mode_t_block_world_d & (F_file_mode_t_mask_bit_read_d | F_file_mode_t_mask_bit_write_d),
    F_file_mode_t_mask_how_add_d & F_file_mode_t_block_world_d & (F_file_mode_t_mask_bit_read_d | F_file_mode_t_mask_bit_write_d | F_file_mode_t_mask_bit_execute_d),
    0,
    F_file_mode_t_mask_how_add_d & F_file_mode_t_block_owner_d & F_file_mode_t_mask_bit_execute_d,
    F_file_mode_t_mask_how_add_d & F_file_mode_t_block_owner_d & F_file_mode_t_mask_bit_write_d,
    F_file_mode_t_mask_how_add_d & F_file_mode_t_block_owner_d & (F_file_mode_t_mask_bit_write_d | F_file_mode_t_mask_bit_execute_d),
    F_file_mode_t_mask_how_add_d & F_file_mode_t_block_owner_d & F_file_mode_t_mask_bit_read_d,
    F_file_mode_t_mask_how_add_d & F_file_mode_t_block_owner_d & (F_file_mode_t_mask_bit_read_d | F_file_mode_t_mask_bit_execute_d),
    F_file_mode_t_mask_how_add_d & F_file_mode_t_block_owner_d & (F_file_mode_t_mask_bit_read_d | F_file_mode_t_mask_bit_write_d),
    F_file_mode_t_mask_how_add_d & F_file_mode_t_block_owner_d & (F_file_mode_t_mask_bit_read_d | F_file_mode_t_mask_bit_write_d | F_file_mode_t_mask_bit_execute_d),
    0,
    F_file_mode_t_mask_how_add_d & F_file_mode_t_block_world_d & F_file_mode_t_mask_bit_execute_d,
    F_file_mode_t_mask_how_add_d & F_file_mode_t_block_world_d & F_file_mode_t_mask_bit_write_d,
    F_file_mode_t_mask_how_add_d & F_file_mode_t_block_world_d & (F_file_mode_t_mask_bit_write_d | F_file_mode_t_mask_bit_execute_d),
    F_file_mode_t_mask_how_add_d & F_file_mode_t_block_world_d & F_file_mode_t_mask_bit_read_d,
    F_file_mode_t_mask_how_add_d & F_file_mode_t_block_world_d & (F_file_mode_t_mask_bit_read_d | F_file_mode_t_mask_bit_execute_d),
    F_file_mode_t_mask_how_add_d & F_file_mode_t_block_world_d & (F_file_mode_t_mask_bit_read_d | F_file_mode_t_mask_bit_write_d),
    F_file_mode_t_mask_how_add_d & F_file_mode_t_block_world_d & (F_file_mode_t_mask_bit_read_d | F_file_mode_t_mask_bit_write_d | F_file_mode_t_mask_bit_execute_d),
    F_file_mode_t_mask_how_add_d & F_file_mode_t_block_standard_d & F_file_mode_t_mask_bit_execute_d,
    F_file_mode_t_mask_how_add_d & F_file_mode_t_block_standard_d & F_file_mode_t_mask_bit_write_d,
    F_file_mode_t_mask_how_add_d & F_file_mode_t_block_standard_d & (F_file_mode_t_mask_bit_write_d | F_file_mode_t_mask_bit_execute_d),
    F_file_mode_t_mask_how_add_d & F_file_mode_t_block_standard_d & F_file_mode_t_mask_bit_read_d,
    F_file_mode_t_mask_how_add_d & F_file_mode_t_block_standard_d & (F_file_mode_t_mask_bit_read_d | F_file_mode_t_mask_bit_execute_d),
    F_file_mode_t_mask_how_add_d & F_file_mode_t_block_standard_d & (F_file_mode_t_mask_bit_read_d | F_file_mode_t_mask_bit_write_d),
    F_file_mode_t_mask_how_add_d & F_file_mode_t_block_standard_d & (F_file_mode_t_mask_bit_read_d | F_file_mode_t_mask_bit_write_d | F_file_mode_t_mask_bit_execute_d),
    F_file_mode_t_mask_how_add_d & F_file_mode_t_block_owner_d & F_file_mode_t_mask_bit_execute_d,
    F_file_mode_t_mask_how_add_d & F_file_mode_t_block_owner_d & F_file_mode_t_mask_bit_write_d,
    F_file_mode_t_mask_how_add_d & F_file_mode_t_block_owner_d & (F_file_mode_t_mask_bit_write_d | F_file_mode_t_mask_bit_execute_d),
    F_file_mode_t_mask_how_add_d & F_file_mode_t_block_owner_d & F_file_mode_t_mask_bit_read_d,
    F_file_mode_t_mask_how_add_d & F_file_mode_t_block_owner_d & (F_file_mode_t_mask_bit_read_d | F_file_mode_t_mask_bit_execute_d),
    F_file_mode_t_mask_how_add_d & F_file_mode_t_block_owner_d & (F_file_mode_t_mask_bit_read_d | F_file_mode_t_mask_bit_write_d),
    F_file_mode_t_mask_how_add_d & F_file_mode_t_block_owner_d & (F_file_mode_t_mask_bit_read_d | F_file_mode_t_mask_bit_write_d | F_file_mode_t_mask_bit_execute_d),
    F_file_mode_t_mask_how_add_d & F_file_mode_t_block_group_d & F_file_mode_t_mask_bit_execute_d,
    F_file_mode_t_mask_how_add_d & F_file_mode_t_block_group_d & F_file_mode_t_mask_bit_write_d,
    F_file_mode_t_mask_how_add_d & F_file_mode_t_block_group_d & (F_file_mode_t_mask_bit_write_d | F_file_mode_t_mask_bit_execute_d),
    F_file_mode_t_mask_how_add_d & F_file_mode_t_block_group_d & F_file_mode_t_mask_bit_read_d,
    F_file_mode_t_mask_how_add_d & F_file_mode_t_block_group_d & (F_file_mode_t_mask_bit_read_d | F_file_mode_t_mask_bit_execute_d),
    F_file_mode_t_mask_how_add_d & F_file_mode_t_block_group_d & (F_file_mode_t_mask_bit_read_d | F_file_mode_t_mask_bit_write_d),
    F_file_mode_t_mask_how_add_d & F_file_mode_t_block_group_d & (F_file_mode_t_mask_bit_read_d | F_file_mode_t_mask_bit_write_d | F_file_mode_t_mask_bit_execute_d),
    F_file_mode_t_mask_how_add_d & F_file_mode_t_block_world_d & F_file_mode_t_mask_bit_execute_d,
    F_file_mode_t_mask_how_add_d & F_file_mode_t_block_world_d & F_file_mode_t_mask_bit_write_d,
    F_file_mode_t_mask_how_add_d & F_file_mode_t_block_world_d & (F_file_mode_t_mask_bit_write_d | F_file_mode_t_mask_bit_execute_d),
    F_file_mode_t_mask_how_add_d & F_file_mode_t_block_world_d & F_file_mode_t_mask_bit_read_d,
    F_file_mode_t_mask_how_add_d & F_file_mode_t_block_world_d & (F_file_mode_t_mask_bit_read_d | F_file_mode_t_mask_bit_execute_d),
    F_file_mode_t_mask_how_add_d & F_file_mode_t_block_world_d & (F_file_mode_t_mask_bit_read_d | F_file_mode_t_mask_bit_write_d),
    F_file_mode_t_mask_how_add_d & F_file_mode_t_block_world_d & (F_file_mode_t_mask_bit_read_d | F_file_mode_t_mask_bit_write_d | F_file_mode_t_mask_bit_execute_d),
    0,
    F_file_mode_t_mask_how_add_d & F_file_mode_t_block_owner_d & F_file_mode_t_mask_bit_execute_d,
    F_file_mode_t_mask_how_add_d & F_file_mode_t_block_owner_d & F_file_mode_t_mask_bit_write_d,
    F_file_mode_t_mask_how_add_d & F_file_mode_t_block_owner_d & (F_file_mode_t_mask_bit_write_d | F_file_mode_t_mask_bit_execute_d),
    F_file_mode_t_mask_how_add_d & F_file_mode_t_block_owner_d & F_file_mode_t_mask_bit_read_d,
    F_file_mode_t_mask_how_add_d & F_file_mode_t_block_owner_d & (F_file_mode_t_mask_bit_read_d | F_file_mode_t_mask_bit_execute_d),
    F_file_mode_t_mask_how_add_d & F_file_mode_t_block_owner_d & (F_file_mode_t_mask_bit_read_d | F_file_mode_t_mask_bit_write_d),
    F_file_mode_t_mask_how_add_d & F_file_mode_t_block_owner_d & (F_file_mode_t_mask_bit_read_d | F_file_mode_t_mask_bit_write_d | F_file_mode_t_mask_bit_execute_d),
    0,
    F_file_mode_t_mask_how_subtract_d & F_file_mode_t_block_world_d & F_file_mode_t_mask_bit_execute_d,
    F_file_mode_t_mask_how_subtract_d & F_file_mode_t_block_world_d & F_file_mode_t_mask_bit_write_d,
    F_file_mode_t_mask_how_subtract_d & F_file_mode_t_block_world_d & (F_file_mode_t_mask_bit_write_d | F_file_mode_t_mask_bit_execute_d),
    F_file_mode_t_mask_how_subtract_d & F_file_mode_t_block_world_d & F_file_mode_t_mask_bit_read_d,
    F_file_mode_t_mask_how_subtract_d & F_file_mode_t_block_world_d & (F_file_mode_t_mask_bit_read_d | F_file_mode_t_mask_bit_execute_d),
    F_file_mode_t_mask_how_subtract_d & F_file_mode_t_block_world_d & (F_file_mode_t_mask_bit_read_d | F_file_mode_t_mask_bit_write_d),
    F_file_mode_t_mask_how_subtract_d & F_file_mode_t_block_world_d & (F_file_mode_t_mask_bit_read_d | F_file_mode_t_mask_bit_write_d | F_file_mode_t_mask_bit_execute_d),
    F_file_mode_t_mask_how_subtract_d & F_file_mode_t_block_standard_d & F_file_mode_t_mask_bit_execute_d,
    F_file_mode_t_mask_how_subtract_d & F_file_mode_t_block_standard_d & F_file_mode_t_mask_bit_write_d,
    F_file_mode_t_mask_how_subtract_d & F_file_mode_t_block_standard_d & (F_file_mode_t_mask_bit_write_d | F_file_mode_t_mask_bit_execute_d),
    F_file_mode_t_mask_how_subtract_d & F_file_mode_t_block_standard_d & F_file_mode_t_mask_bit_read_d,
    F_file_mode_t_mask_how_subtract_d & F_file_mode_t_block_standard_d & (F_file_mode_t_mask_bit_read_d | F_file_mode_t_mask_bit_execute_d),
    F_file_mode_t_mask_how_subtract_d & F_file_mode_t_block_standard_d & (F_file_mode_t_mask_bit_read_d | F_file_mode_t_mask_bit_write_d),
    F_file_mode_t_mask_how_subtract_d & F_file_mode_t_block_standard_d & (F_file_mode_t_mask_bit_read_d | F_file_mode_t_mask_bit_write_d | F_file_mode_t_mask_bit_execute_d),
    F_file_mode_t_mask_how_subtract_d & F_file_mode_t_block_owner_d & F_file_mode_t_mask_bit_execute_d,
    F_file_mode_t_mask_how_subtract_d & F_file_mode_t_block_owner_d & F_file_mode_t_mask_bit_write_d,
    F_file_mode_t_mask_how_subtract_d & F_file_mode_t_block_owner_d & (F_file_mode_t_mask_bit_write_d | F_file_mode_t_mask_bit_execute_d),
    F_file_mode_t_mask_how_subtract_d & F_file_mode_t_block_owner_d & F_file_mode_t_mask_bit_read_d,
    F_file_mode_t_mask_how_subtract_d & F_file_mode_t_block_owner_d & (F_file_mode_t_mask_bit_read_d | F_file_mode_t_mask_bit_execute_d),
    F_file_mode_t_mask_how_subtract_d & F_file_mode_t_block_owner_d & (F_file_mode_t_mask_bit_read_d | F_file_mode_t_mask_bit_write_d),
    F_file_mode_t_mask_how_subtract_d & F_file_mode_t_block_owner_d & (F_file_mode_t_mask_bit_read_d | F_file_mode_t_mask_bit_write_d | F_file_mode_t_mask_bit_execute_d),
    F_file_mode_t_mask_how_subtract_d & F_file_mode_t_block_group_d & F_file_mode_t_mask_bit_execute_d,
    F_file_mode_t_mask_how_subtract_d & F_file_mode_t_block_group_d & F_file_mode_t_mask_bit_write_d,
    F_file_mode_t_mask_how_subtract_d & F_file_mode_t_block_group_d & (F_file_mode_t_mask_bit_write_d | F_file_mode_t_mask_bit_execute_d),
    F_file_mode_t_mask_how_subtract_d & F_file_mode_t_block_group_d & F_file_mode_t_mask_bit_read_d,
    F_file_mode_t_mask_how_subtract_d & F_file_mode_t_block_group_d & (F_file_mode_t_mask_bit_read_d | F_file_mode_t_mask_bit_execute_d),
    F_file_mode_t_mask_how_subtract_d & F_file_mode_t_block_group_d & (F_file_mode_t_mask_bit_read_d | F_file_mode_t_mask_bit_write_d),
    F_file_mode_t_mask_how_subtract_d & F_file_mode_t_block_group_d & (F_file_mode_t_mask_bit_read_d | F_file_mode_t_mask_bit_write_d | F_file_mode_t_mask_bit_execute_d),
    F_file_mode_t_mask_how_subtract_d & F_file_mode_t_block_world_d & F_file_mode_t_mask_bit_execute_d,
    F_file_mode_t_mask_how_subtract_d & F_file_mode_t_block_world_d & F_file_mode_t_mask_bit_write_d,
    F_file_mode_t_mask_how_subtract_d & F_file_mode_t_block_world_d & (F_file_mode_t_mask_bit_write_d | F_file_mode_t_mask_bit_execute_d),
    F_file_mode_t_mask_how_subtract_d & F_file_mode_t_block_world_d & F_file_mode_t_mask_bit_read_d,
    F_file_mode_t_mask_how_subtract_d & F_file_mode_t_block_world_d & (F_file_mode_t_mask_bit_read_d | F_file_mode_t_mask_bit_execute_d),
    F_file_mode_t_mask_how_subtract_d & F_file_mode_t_block_world_d & (F_file_mode_t_mask_bit_read_d | F_file_mode_t_mask_bit_write_d),
    F_file_mode_t_mask_how_subtract_d & F_file_mode_t_block_world_d & (F_file_mode_t_mask_bit_read_d | F_file_mode_t_mask_bit_write_d | F_file_mode_t_mask_bit_execute_d),
    0,
    F_file_mode_t_mask_how_subtract_d & F_file_mode_t_block_owner_d & F_file_mode_t_mask_bit_execute_d,
    F_file_mode_t_mask_how_subtract_d & F_file_mode_t_block_owner_d & F_file_mode_t_mask_bit_write_d,
    F_file_mode_t_mask_how_subtract_d & F_file_mode_t_block_owner_d & (F_file_mode_t_mask_bit_write_d | F_file_mode_t_mask_bit_execute_d),
    F_file_mode_t_mask_how_subtract_d & F_file_mode_t_block_owner_d & F_file_mode_t_mask_bit_read_d,
    F_file_mode_t_mask_how_subtract_d & F_file_mode_t_block_owner_d & (F_file_mode_t_mask_bit_read_d | F_file_mode_t_mask_bit_execute_d),
    F_file_mode_t_mask_how_subtract_d & F_file_mode_t_block_owner_d & (F_file_mode_t_mask_bit_read_d | F_file_mode_t_mask_bit_write_d),
    F_file_mode_t_mask_how_subtract_d & F_file_mode_t_block_owner_d & (F_file_mode_t_mask_bit_read_d | F_file_mode_t_mask_bit_write_d | F_file_mode_t_mask_bit_execute_d),
  };

  uint8_t replaces[] = {
    F_file_mode_t_replace_special_d | F_file_mode_t_replace_owner_d | F_file_mode_t_replace_group_d | F_file_mode_t_replace_world_d,
    F_file_mode_t_replace_special_d | F_file_mode_t_replace_owner_d | F_file_mode_t_replace_group_d | F_file_mode_t_replace_world_d,
    F_file_mode_t_replace_special_d | F_file_mode_t_replace_owner_d | F_file_mode_t_replace_group_d | F_file_mode_t_replace_world_d,
    F_file_mode_t_replace_special_d | F_file_mode_t_replace_owner_d | F_file_mode_t_replace_group_d | F_file_mode_t_replace_world_d,
    F_file_mode_t_replace_special_d | F_file_mode_t_replace_owner_d | F_file_mode_t_replace_group_d | F_file_mode_t_replace_world_d,
    F_file_mode_t_replace_special_d | F_file_mode_t_replace_owner_d | F_file_mode_t_replace_group_d | F_file_mode_t_replace_world_d,
    F_file_mode_t_replace_special_d | F_file_mode_t_replace_owner_d | F_file_mode_t_replace_group_d | F_file_mode_t_replace_world_d,
    F_file_mode_t_replace_special_d | F_file_mode_t_replace_owner_d | F_file_mode_t_replace_group_d | F_file_mode_t_replace_world_d,
    F_file_mode_t_replace_special_d | F_file_mode_t_replace_owner_d | F_file_mode_t_replace_group_d | F_file_mode_t_replace_world_d,
    F_file_mode_t_replace_special_d | F_file_mode_t_replace_owner_d | F_file_mode_t_replace_group_d | F_file_mode_t_replace_world_d,
    F_file_mode_t_replace_special_d | F_file_mode_t_replace_owner_d | F_file_mode_t_replace_group_d | F_file_mode_t_replace_world_d,
    F_file_mode_t_replace_special_d | F_file_mode_t_replace_owner_d | F_file_mode_t_replace_group_d | F_file_mode_t_replace_world_d,
    F_file_mode_t_replace_special_d | F_file_mode_t_replace_owner_d | F_file_mode_t_replace_group_d | F_file_mode_t_replace_world_d,
    F_file_mode_t_replace_special_d | F_file_mode_t_replace_owner_d | F_file_mode_t_replace_group_d | F_file_mode_t_replace_world_d,
    F_file_mode_t_replace_special_d | F_file_mode_t_replace_owner_d | F_file_mode_t_replace_group_d | F_file_mode_t_replace_world_d,
    F_file_mode_t_replace_special_d | F_file_mode_t_replace_owner_d | F_file_mode_t_replace_group_d | F_file_mode_t_replace_world_d,
    F_file_mode_t_replace_special_d | F_file_mode_t_replace_owner_d | F_file_mode_t_replace_group_d | F_file_mode_t_replace_world_d,
    F_file_mode_t_replace_special_d | F_file_mode_t_replace_owner_d | F_file_mode_t_replace_group_d | F_file_mode_t_replace_world_d,
    F_file_mode_t_replace_special_d | F_file_mode_t_replace_owner_d | F_file_mode_t_replace_group_d | F_file_mode_t_replace_world_d,
    F_file_mode_t_replace_special_d | F_file_mode_t_replace_owner_d | F_file_mode_t_replace_group_d | F_file_mode_t_replace_world_d,
    F_file_mode_t_replace_special_d | F_file_mode_t_replace_owner_d | F_file_mode_t_replace_group_d | F_file_mode_t_replace_world_d,
    F_file_mode_t_replace_special_d | F_file_mode_t_replace_owner_d | F_file_mode_t_replace_group_d | F_file_mode_t_replace_world_d,
    F_file_mode_t_replace_special_d | F_file_mode_t_replace_owner_d | F_file_mode_t_replace_group_d | F_file_mode_t_replace_world_d,
    F_file_mode_t_replace_special_d | F_file_mode_t_replace_owner_d | F_file_mode_t_replace_group_d | F_file_mode_t_replace_world_d,
    F_file_mode_t_replace_special_d | F_file_mode_t_replace_owner_d | F_file_mode_t_replace_group_d | F_file_mode_t_replace_world_d,
    F_file_mode_t_replace_special_d | F_file_mode_t_replace_owner_d | F_file_mode_t_replace_group_d | F_file_mode_t_replace_world_d,
    F_file_mode_t_replace_special_d | F_file_mode_t_replace_owner_d | F_file_mode_t_replace_group_d | F_file_mode_t_replace_world_d,
    F_file_mode_t_replace_special_d | F_file_mode_t_replace_owner_d | F_file_mode_t_replace_group_d | F_file_mode_t_replace_world_d,
    F_file_mode_t_replace_special_d | F_file_mode_t_replace_owner_d | F_file_mode_t_replace_group_d | F_file_mode_t_replace_world_d,
    F_file_mode_t_replace_special_d | F_file_mode_t_replace_owner_d | F_file_mode_t_replace_group_d | F_file_mode_t_replace_world_d,
    F_file_mode_t_replace_special_d | F_file_mode_t_replace_owner_d | F_file_mode_t_replace_group_d | F_file_mode_t_replace_world_d,
    F_file_mode_t_replace_special_d | F_file_mode_t_replace_owner_d | F_file_mode_t_replace_group_d | F_file_mode_t_replace_world_d,
    F_file_mode_t_replace_special_d | F_file_mode_t_replace_owner_d | F_file_mode_t_replace_group_d | F_file_mode_t_replace_world_d,
    F_file_mode_t_replace_special_d | F_file_mode_t_replace_owner_d | F_file_mode_t_replace_group_d | F_file_mode_t_replace_world_d,
    F_file_mode_t_replace_special_d | F_file_mode_t_replace_owner_d | F_file_mode_t_replace_group_d | F_file_mode_t_replace_world_d,
    F_file_mode_t_replace_special_d | F_file_mode_t_replace_owner_d | F_file_mode_t_replace_group_d | F_file_mode_t_replace_world_d,
    F_file_mode_t_replace_special_d | F_file_mode_t_replace_owner_d | F_file_mode_t_replace_group_d | F_file_mode_t_replace_world_d,
    F_file_mode_t_replace_special_d | F_file_mode_t_replace_owner_d | F_file_mode_t_replace_group_d | F_file_mode_t_replace_world_d,
    F_file_mode_t_replace_special_d | F_file_mode_t_replace_owner_d | F_file_mode_t_replace_group_d | F_file_mode_t_replace_world_d,
    F_file_mode_t_replace_special_d | F_file_mode_t_replace_owner_d | F_file_mode_t_replace_group_d | F_file_mode_t_replace_world_d,
    F_file_mode_t_replace_special_d | F_file_mode_t_replace_owner_d | F_file_mode_t_replace_group_d | F_file_mode_t_replace_world_d,
    F_file_mode_t_replace_special_d | F_file_mode_t_replace_owner_d | F_file_mode_t_replace_group_d | F_file_mode_t_replace_world_d,
    F_file_mode_t_replace_special_d | F_file_mode_t_replace_owner_d | F_file_mode_t_replace_group_d | F_file_mode_t_replace_world_d,
    F_file_mode_t_replace_special_d | F_file_mode_t_replace_owner_d | F_file_mode_t_replace_group_d | F_file_mode_t_replace_world_d,
    F_file_mode_t_replace_special_d | F_file_mode_t_replace_owner_d | F_file_mode_t_replace_group_d | F_file_mode_t_replace_world_d,
    F_file_mode_t_replace_special_d | F_file_mode_t_replace_owner_d | F_file_mode_t_replace_group_d | F_file_mode_t_replace_world_d,
    F_file_mode_t_replace_special_d | F_file_mode_t_replace_owner_d | F_file_mode_t_replace_group_d | F_file_mode_t_replace_world_d,
    F_file_mode_t_replace_special_d | F_file_mode_t_replace_owner_d | F_file_mode_t_replace_group_d | F_file_mode_t_replace_world_d,
    F_file_mode_t_replace_special_d | F_file_mode_t_replace_owner_d | F_file_mode_t_replace_group_d | F_file_mode_t_replace_world_d,
    F_file_mode_t_replace_special_d | F_file_mode_t_replace_owner_d | F_file_mode_t_replace_group_d | F_file_mode_t_replace_world_d,
    F_file_mode_t_replace_special_d | F_file_mode_t_replace_owner_d | F_file_mode_t_replace_group_d | F_file_mode_t_replace_world_d,
    F_file_mode_t_replace_special_d | F_file_mode_t_replace_owner_d | F_file_mode_t_replace_group_d | F_file_mode_t_replace_world_d,
    F_file_mode_t_replace_special_d | F_file_mode_t_replace_owner_d | F_file_mode_t_replace_group_d | F_file_mode_t_replace_world_d,
    F_file_mode_t_replace_special_d | F_file_mode_t_replace_owner_d | F_file_mode_t_replace_group_d | F_file_mode_t_replace_world_d,
    F_file_mode_t_replace_special_d | F_file_mode_t_replace_owner_d | F_file_mode_t_replace_group_d | F_file_mode_t_replace_world_d,
    F_file_mode_t_replace_special_d | F_file_mode_t_replace_owner_d | F_file_mode_t_replace_group_d | F_file_mode_t_replace_world_d,
    F_file_mode_t_replace_special_d | F_file_mode_t_replace_owner_d | F_file_mode_t_replace_group_d | F_file_mode_t_replace_world_d,
    F_file_mode_t_replace_special_d | F_file_mode_t_replace_owner_d | F_file_mode_t_replace_group_d | F_file_mode_t_replace_world_d,
    F_file_mode_t_replace_special_d | F_file_mode_t_replace_owner_d | F_file_mode_t_replace_group_d | F_file_mode_t_replace_world_d,
    F_file_mode_t_replace_special_d | F_file_mode_t_replace_owner_d | F_file_mode_t_replace_group_d | F_file_mode_t_replace_world_d,
    F_file_mode_t_replace_special_d | F_file_mode_t_replace_owner_d | F_file_mode_t_replace_group_d | F_file_mode_t_replace_world_d,
    F_file_mode_t_replace_special_d | F_file_mode_t_replace_owner_d | F_file_mode_t_replace_group_d | F_file_mode_t_replace_world_d,
    F_file_mode_t_replace_special_d | F_file_mode_t_replace_owner_d | F_file_mode_t_replace_group_d | F_file_mode_t_replace_world_d,
    F_file_mode_t_replace_special_d | F_file_mode_t_replace_owner_d | F_file_mode_t_replace_group_d | F_file_mode_t_replace_world_d,
    F_file_mode_t_replace_special_d | F_file_mode_t_replace_owner_d | F_file_mode_t_replace_group_d | F_file_mode_t_replace_world_d,
    F_file_mode_t_replace_special_d | F_file_mode_t_replace_owner_d | F_file_mode_t_replace_group_d | F_file_mode_t_replace_world_d,
    F_file_mode_t_replace_special_d | F_file_mode_t_replace_owner_d | F_file_mode_t_replace_group_d | F_file_mode_t_replace_world_d,
    F_file_mode_t_replace_special_d | F_file_mode_t_replace_owner_d | F_file_mode_t_replace_group_d | F_file_mode_t_replace_world_d,
    F_file_mode_t_replace_special_d | F_file_mode_t_replace_owner_d | F_file_mode_t_replace_group_d | F_file_mode_t_replace_world_d,
    F_file_mode_t_replace_special_d | F_file_mode_t_replace_owner_d | F_file_mode_t_replace_group_d | F_file_mode_t_replace_world_d,
    F_file_mode_t_replace_special_d | F_file_mode_t_replace_owner_d | F_file_mode_t_replace_group_d | F_file_mode_t_replace_world_d,
    F_file_mode_t_replace_special_d | F_file_mode_t_replace_owner_d | F_file_mode_t_replace_group_d | F_file_mode_t_replace_world_d,
    F_file_mode_t_replace_special_d | F_file_mode_t_replace_owner_d | F_file_mode_t_replace_group_d | F_file_mode_t_replace_world_d,
    F_file_mode_t_replace_special_d | F_file_mode_t_replace_owner_d | F_file_mode_t_replace_group_d | F_file_mode_t_replace_world_d,
    F_file_mode_t_replace_special_d | F_file_mode_t_replace_owner_d | F_file_mode_t_replace_group_d | F_file_mode_t_replace_world_d,
    F_file_mode_t_replace_special_d | F_file_mode_t_replace_owner_d | F_file_mode_t_replace_group_d | F_file_mode_t_replace_world_d,
    F_file_mode_t_replace_special_d | F_file_mode_t_replace_owner_d | F_file_mode_t_replace_group_d | F_file_mode_t_replace_world_d,
    F_file_mode_t_replace_special_d | F_file_mode_t_replace_owner_d | F_file_mode_t_replace_group_d | F_file_mode_t_replace_world_d,
    F_file_mode_t_replace_special_d | F_file_mode_t_replace_owner_d | F_file_mode_t_replace_group_d | F_file_mode_t_replace_world_d,
    F_file_mode_t_replace_special_d | F_file_mode_t_replace_owner_d | F_file_mode_t_replace_group_d | F_file_mode_t_replace_world_d,
    F_file_mode_t_replace_special_d | F_file_mode_t_replace_owner_d | F_file_mode_t_replace_group_d | F_file_mode_t_replace_world_d,
    F_file_mode_t_replace_special_d | F_file_mode_t_replace_owner_d | F_file_mode_t_replace_group_d | F_file_mode_t_replace_world_d,
    F_file_mode_t_replace_special_d | F_file_mode_t_replace_owner_d | F_file_mode_t_replace_group_d | F_file_mode_t_replace_world_d,
    F_file_mode_t_replace_special_d | F_file_mode_t_replace_owner_d | F_file_mode_t_replace_group_d | F_file_mode_t_replace_world_d,
    F_file_mode_t_replace_special_d | F_file_mode_t_replace_owner_d | F_file_mode_t_replace_group_d | F_file_mode_t_replace_world_d,
    F_file_mode_t_replace_special_d | F_file_mode_t_replace_owner_d | F_file_mode_t_replace_group_d | F_file_mode_t_replace_world_d,
    F_file_mode_t_replace_special_d | F_file_mode_t_replace_owner_d | F_file_mode_t_replace_group_d | F_file_mode_t_replace_world_d,
    F_file_mode_t_replace_special_d | F_file_mode_t_replace_owner_d | F_file_mode_t_replace_group_d | F_file_mode_t_replace_world_d,
    0,
    0,
    0,
    0,
    0,
    0,
    0,
    0,
    0,
    0,
    0,
    0,
    0,
    0,
    0,
    0,
    0,
    0,
    0,
    0,
    0,
    0,
    0,
    0,
    0,
    0,
    0,
    0,
    0,
    0,
    0,
    0,
    0,
    0,
    0,
    0,
    0,
    0,
    0,
    0,
    0,
    0,
    0,
    0,
    0,
    0,
    0,
    0,
    0,
    0,
    0,
    0,
    0,
    0,
    0,
    0,
    0,
    0,
    0,
    0,
    0,
    0,
    0,
    0,
    0,
    0,
    0,
    0,
    0,
    0,
    0,
    0,
    0,
    0,
    0,
    0,
    0,
    0,
    0,
    0,
    0,
    0,
    0,
    0,
    0,
    0,
    0,
    0,
  };

  for (int i = 0; i < 176; ++i) {

    f_file_mode_t mode = 0;
    uint8_t replace = 0;

    const f_status_t status = f_file_mode_from_string(codes[i], 0, &mode, &replace);

    assert_int_equal(status, F_okay);
    assert_int_equal(mode, modes[i]);
    assert_int_equal(replace, replaces[i]);
  } // for
}

#ifdef __cplusplus
} // extern "C"
#endif
